;------------------------------------------------------------------------------
; Disassembling a komentr Roman Brik
; - 14. Oktber 2007 (Revzia 3)
; - 20. Oktber 2012 (Revzia 4)
;------------------------------------------------------------------------------
;
;          ********************************************************
;          *               EXTENDED ROM BASIC - ERB               *
;          ********************************************************
;
; ERB roziruje zkladn BASIC v1.0 o alie prkazy a funkcie, hlavne
; o prkazy sliace pre obsluhu disketovej jednotky MFD-85 (prpadne PMD 30).
; ERB sa presunie do pamti prkazom "ROM 0" BASICu. V pamti je uloen od
; adresy 7600H a zaber 2kB.
;
; ERB obsahuje zopr chb.
;
; V prkaze @DISK= sa nesm poui adresy 15 a 16, pretoe sposobuj konflikt
; so stykovmi povelmi IMS-2 zbernice. Na disketovej jednotke MFD-85 sa
; nastavuje adresa v rozsahu 0 a 15 a adresa 15 sa tie nesmie z uvedenho
; dvodu nastavi. Platn adresu 0, paradoxne, neumouje poui samotn prkaz
; @DISK=.
;
; V rutine pre vyhodnotenie reazca na adrese 78F4H sa po analze premennej
; netestuje jej typ a po uveden selnej premennej sa nehlsi chyba.
; Teda vo vetkch prkazoch ERB, kde m by reazcov premenn, uvedenie
; selnej premennej m za nsledok nepredvdaten sprvanie.
;
; Podobne sa v prkaze @SEARCH# na adrese 7DA9H netestuje typ premennej, do
; ktorej sa m priradi slo njdenho zznamu. Ak sa uvedie reazcov premenn
; a t sa potom pouije, moe to ma nepredvdaten sprvanie.
;
; Na niektorch miestach sa vyskytuje hluch kd, prpadne zbytone zloit
; programov rieenia.
;
; Vo vpise s symbolom >> oznaen miesta, ktor s v rmci ERB modifikovan.
;------------------------------------------------------------------------------


;------------------------------------------------------------------------------
; Zhlavie ERB. Vykon sa inicializcia, modifikcia zkladnho BASICu pre nov
; prkazy, modifikcia u existujcich prkazov a presunutie ERB na adresu 7600.
; Inicializcia je vykonan po natiahnut z ROM modulu prkazom "ROM 0".
;------------------------------------------------------------------------------
7000  E5              PUSH H            ; odpamataj programov ukazate
7001  21 5EF0         LXI  H,5EF0       ; adresa editanho buffra - 1
7004  22 2212         SHLD 2212         ; modifikuj BASIC
7007  23              INX  H            ; + 1
7008  22 085C         SHLD 085C
700B  21 80C0         LXI  H,80C0       ; semafr @ novch prkazov
700E  22 1B60         SHLD 1B60         ; ulo do tabuky kovch slov
7011  21 7667         LXI  H,7667       ; exekutva pre @ nov prkazy
7014  22 19F8         SHLD 19F8         ; ulo
7017  21 7660         LXI  H,7660       ; modifikcia rutiny IMS-2 OUT
701A  22 2009         SHLD 2009
701D  3E CD           MVI  A,CD         ; modifikcia rutiny HLPVL
701F  32 02AD         STA  02AD         ; - hadanie povelu
7022  21 767A         LXI  H,767A
7025  22 02AE         SHLD 02AE
7028  21 7691         LXI  H,7691       ; modifikcia rutiny LIST, LLIST
702B  22 043D         SHLD 043D
702E  22 03CC         SHLD 03CC
7031  CD 8C00         CALL 8C00         ; transfer modulu ERB
7034  2400 0900       DW   2400,0900
7038  7600            DW   7600         ; na adresu 7600
703A  3E 2C           MVI  A,','        ; oddeova reaz. na vstupe v prkazoch
703C  32 0883         STA  0883         ; typu INPUT - namiesto ':'
703F  21 0FDA         LXI  H,0FDA       ; zvenie presnosti vpotu SIN, COS,
7042  22 1519         SHLD 1519         ; TAN a ATN na 6 a 7 desatinnch miest
7045  21 7BD1         LXI  H,7BD1       ; nastavenie vstupnej rutiny pre
7048  22 20E6         SHLD 20E6         ; kanl 406
704B  3E C3           MVI  A,C3         ; modifikcia prkazu POKE
704D  32 0F03         STA  0F03
7050  00              NOP
7051  00              NOP
7052  00              NOP
7053  CD 7DDB         CALL 7DDB         ; preve alie modifikcie prkazov
7056  E1              POP  H
7057  C9              RET


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
7658  FF FF           DB   FF,FF


;------------------------------------------------------------------------------
; Nastavenie IMS-2 zbernice - REN=1, vstup
;------------------------------------------------------------------------------
765A  3E 41           MVI  A,41         ; REN=1, vstup
765C  D3 7E           OUT  7E
765E  C9              RET


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
765F  FF              DB   FF


;------------------------------------------------------------------------------
; Rutina IMS-2 OUT.
;------------------------------------------------------------------------------
7660  4F              MOV  C,A          ; odpamtaj posielan byte do C
7661  CD 2046         CALL 2046         ; nastav na IMS-2 zbernici REN=1, OUT
7664  C3 1FE1         JMP  1FE1         ; sko odosla byte


;------------------------------------------------------------------------------
; Exekutva @ novch prkazov.
;------------------------------------------------------------------------------
7667  D1              POP  D            ; vyrovnaj STACK
7668  B7              ORA  A            ; ak prkaz nepokrauje,
7669  F2 00FF         JP   00FF         ; tak zahls "Syntax error"
766C  D5              PUSH D
766D  07              RLC               ; vpoet offsetu do tabuky executv
766E  E6 FE           ANI  FE
7670  4F              MOV  C,A
7671  06 00           MVI  B,00
7673  EB              XCHG
7674  21 77C0         LXI  H,77C0       ; bzov adresa executv prkazov ERB
7677  C3 04E0         JMP  04E0         ; pokraova v interpretovan


;------------------------------------------------------------------------------
; Modifikcia rutiny HLPVL - hadanie povelu
;------------------------------------------------------------------------------
767A  12              STAX D            ; vloenie pvodnho interpreteru
767B  13              INX  D
767C  0C              INR  C
767D  FE E2           CPI  E2           ; porovnaj kd @ - prefix novch prk.
767F  E5              PUSH H
7680  21 19F9         LXI  H,19F9       ; nastavenie pvodnej tabuky vektorov
7683  22 0259         SHLD 0259         ; executv prkazov
7686  E1              POP  H
7687  C0              RNZ               ; ak to nie je kd @, vr sa
7688  E5              PUSH H
7689  21 76FF         LXI  H,76FF       ; nastavenie novej tabuky
768C  22 0259         SHLD 0259         ; kovch slov ERB
768F  E1              POP  H
7690  C9              RET


;------------------------------------------------------------------------------
; Modifikcia rutiny LIST, LLIST
;------------------------------------------------------------------------------
7691  FE C0           CPI  C0           ; porovnaj ASCII znak @ + 128
7693  E5              PUSH H
7694  21 19FA         LXI  H,19FA       ; nastavenie pvodnej tabuky
7697  22 0430         SHLD 0430         ; kovch slov BASIC
769A  22 03BF         SHLD 03BF
769D  E1              POP  H            ; ak s to pvodn prkazy,
769E  C2 03D9         JNZ  03D9         ; sko do rutiny CONSOLA OUTPUT
76A1  E5              PUSH H            ; pre nov prkazy
76A2  21 7700         LXI  H,7700       ; nastav nov tabuku
76A5  22 0430         SHLD 0430         ; kovch slov ERB
76A8  22 03BF         SHLD 03BF
76AB  E1              POP  H
76AC  C3 03D9         JMP  03D9         ; skok do rutiny CONSOLA OUTPUT


;------------------------------------------------------------------------------
; Prkaz: @DISK=vraz
; * Nastavenie aktvneho disku.
;------------------------------------------------------------------------------
76AF  CD 16D7         CALL 16D7         ; vyhodno vraz za prkazom
76B2  B7              ORA  A            ; ak je to 0,
76B3  CA 093D         JZ   093D         ; zahls chybu "TYPE CONV."
76B6  FE 11           CPI  11           ; ak je v ako 16
76B8  D2 093D         JNC  093D         ; zahls chybu "TYPE CONV."
76BB  47              MOV  B,A          ; ulo slo (adresu) disku
76BC  F6 20           ORI  20           ; pridaj "masku" Listener
76BE  32 7867         STA  7867         ; a ulo do stykovej sprvy - COMMAND
76C1  C6 10           ADI  10           ; zv adresu o 16
76C3  32 786F         STA  786F         ; a ulo do stykovej sprvy - DATA WRITE
76C6  78              MOV  A,B          ; vezmi adresu
76C7  F6 40           ORI  40           ; pridaj "masku" Talker
76C9  32 786B         STA  786B         ; a ulo do stykovej sprvy - STATUS
76CC  C6 10           ADI  10           ; zv adresu o 16
76CE  32 7873         STA  7873         ; a ulo do stykovej sprvy - DATA READ
76D1  C9              RET


;------------------------------------------------------------------------------
; Dokonenie prkazu @NAME ; A$
;------------------------------------------------------------------------------
76D2  CD 0075         CALL 0075         ; posu sa v progr. riadku
76D5  E5              PUSH H            ; odpamtaj prog. ukazate
76D6  21 5EF1         LXI  H,5EF1       ; adresa buffra
76D9  22 77BE         SHLD 77BE         ; ulo
76DC  21 76E7         LXI  H,76E7       ; adresa nvratu z vykonania povelu
76DF  E5              PUSH H            ; ulo na zsobnk
76E0  E5              PUSH H
76E1  21 20EB         LXI  H,20EB       ; adresa rutiny pre prjem dt z MFD 85
76E4  C3 78C9         JMP  78C9         ; sko dopredu vykona povel


;------------------------------------------------------------------------------
; Dokonenie prkazu - uloenie vsledku do premennej A$
;------------------------------------------------------------------------------
76E7  21 76F0         LXI  H,76F0
76EA  22 085F         SHLD 085F
76ED  C3 081B         JMP  081B         ; ulo prijat reazec do A$

76F0  2B              DCX  H            ; zn ukazate prog.
76F1  C9              RET


;------------------------------------------------------------------------------
; reazec povelu pre uzatvorenie vetkch sborov
;------------------------------------------------------------------------------
76F2  41 48 0D 0A     DB   'AH',0D,0A

;------------------------------------------------------------------------------
; Prkaz: @CLOSE
; Povel m tvar: AH
; * Uzatvorenie vetkch sborov.
;------------------------------------------------------------------------------
76F6  E5              PUSH H            ; odpamtaj prog. ukazate
76F7  21 76F2         LXI  H,76F2       ; adresa povelu @CLOSE
76FA  CD 783C         CALL 783C         ; odoli povel do MFD 85
76FD  E1              POP  H            ; obnov prog. ukazate
76FE  C9              RET               ; vr sa do prog. sluky


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
76FF  C9              DB   C9


;------------------------------------------------------------------------------
; Tabuka kovch slov
;------------------------------------------------------------------------------
7700  C3 41 54        DB   C3,'AT'      ; CAT
7703  C4 49 53 4B     DB   C4,'ISK='    ; DISK=
7707  3D
7708  CE 41 4D 45     DB   CE,'AME'     ; NAME
770C  D0 55 52 47     DB   D0,'URGE'    ; PURGE
7710  45
7711  C9 4E 49 54     DB   C9,'NIT'     ; INIT
7715  C3 52 45 41     DB   C3,'REATE'   ; CREATE
7719  54 45
771B  FF 7F 7F 7F     DB   FF,7F,7F,7F
771F  7F              DB   7F
7720  C3 4C 4F 53     DB   C3,'LOSE#'   ; CLOSE#
7724  45 23
7726  C3 4C 4F 53     DB   C3,'LOSE'    ; CLOSE
772A  45
772B  D0 52 49 4E     DB   D0,'RINT#'   ; PRINT#
772F  54 23
7731  D2 45 41 44     DB   D2,'EAD#'    ; READ#
7735  23
7736  D3 45 43 55     DB   D3,'ECURE'   ; SECURE
773A  52 45
773C  D7 52 49 54     DB   D7,'RITE'    ; WRITE (neimplementovan)
7740  45
7741  C4 4F 4B 45     DB   C4,'OKE'     ; DOKE
7745  D3 7F 7F 7F     DB   D3,7F,7F,7F
7749  7F 7F           DB   7F,7F
774B  C7 53 54 4F     DB   C7,'STORE'   ; GSTORE
774F  52 45
7751  C7 4C 4F 41     DB   C7,'LOAD'    ; GLOAD
7755  44
7756  C2 53 54 4F     DB   C2,'STORE'   ; BSTORE
775A  52 45
775C  C2 4C 4F 41     DB   C2,'LOAD'    ; BLOAD
7760  44
7761  D3 54 4F 52     DB   D3,'TORE'    ; STORE
7765  45
7766  CC 4F 41 44     DB   CC,'OAD'     ; LOAD
776A  C3 4F 50 59     DB   C3,'OPY'     ; COPY
776E  C3 4D 44        DB   C3,'MD'      ; CMD
7771  C7 45 54        DB   C7,'ET'      ; GET (neimplementovan)
7774  C2 55 46 3D     DB   C2,'UF='	; BUF=
7778  CF 50 45 4E     DB   CF,'PEN'	; OPEN
777C  CF 4E 20 45     DB   CF,'N ERROR'	; ON ERROR
7780  52 52 4F 52
7784  CF 46 46 20     DB   CF,'FF ERROR'; OFF ERROR
7788  45 52 52 4F
778C  52
778D  C5 58 45 43     DB   C5,'XEC'     ; EXEC
7791  D3 45 41 52     DB   D3,'EARCH#'  ; SEARCH#
7795  43 48 23
7798  FF FF 80        DB   FF,FF,80


;------------------------------------------------------------------------------
; Prkaz: @CMD A$ ; [ A$ ]
; * prkaz pre priamu komunikciu so systmom a vykonvanie diskovch sluieb.
;------------------------------------------------------------------------------
779B  CD 78F4         CALL 78F4         ; spracuj reazec za prkazom
779E  3E 0D           MVI  A,0D         ; ukoni ho CRLF
77A0  12              STAX D
77A1  13              INX  D
77A2  3E 0A           MVI  A,0A
77A4  12              STAX D
77A5  CD 006D         CALL 006D         ; mus nasledova bodkoiarka
77A8  3B              DB   ';'
77A9  E5              PUSH H
77AA  21 79EC         LXI  H,79EC       ; adresa rutiny pre odoslanie dt
77AD  22 78EF         SHLD 78EF         ; ulo adresu rutiny
77B0  21 7A10         LXI  H,7A10       ; adresa rutiny pre prjem dt
77B3  22 7897         SHLD 7897         ; ulo adresu rutiny
77B6  21 5EF1         LXI  H,5EF1       ; adresa povelovho buffra
77B9  C3 7808         JMP  7808         ; vykonaj cel povel


;------------------------------------------------------------------------------
; Dve premenn potrebn pre diskov sluby - adresa buffra a jeho dka.
; Modifikuj sa prkazom @BUF=adr,len
;------------------------------------------------------------------------------
77BC  C35E         >> DW   C35E         ; dka buffra
77BE  5EF1         >> DW   5EF1         ; adresa buffra


;------------------------------------------------------------------------------
; Tabuka vektorov (adries) exekutvy novch prkazov
;------------------------------------------------------------------------------
77C0  78D6 76AF       DW   78D6,76AF    ; CAT, DISK=
77C4  78BA 792A       DW   78BA,792A    ; NAME, PURGE
77C8  7927 796D       DW   7927,796D    ; INIT, CREATE
77CC  FFFF 7A4A       DW   FFFF,7A4A    ; -, CLOSE#
77D0  76F6 79BA       DW   76F6,79BA    ; CLOSE, PRINT#
77D4  7A04 792D       DW   7A04,792D    ; READ#, SECURE
77D8  FFFF 7D4D       DW   FFFF,7D4D    ; WRITE, DOKE
77DC  FFFF 7B93       DW   FFFF,7B93    ; -, GSTORE
77E0  7AC1 7BAE       DW   7AC1,7BAE    ; GLOAD, BSTORE
77E4  7AED 7B5D       DW   7AED,7B5D    ; BLOAD, STORE
77E8  7AF4 7C24       DW   7AF4,7C24    ; LOAD, COPY
77EC  779B FFFF       DW   779B,FFFF    ; CMD, GET
77F0  7D60 7A2E       DW   7D60,7A2E    ; BUF=, OPEN
77F4  7C9B 7CAD       DW   7C9B,7CAD    ; ON ERROR, OFF ERROR
77F8  7D7F 7DA9       DW   7D7F,7DA9    ; EXEC, SEARCH#
77FC  FFFF FFFF       DW   FFFF,FFFF
7800  FFFF FFFF       DW   FFFF,FFFF
7804  FFFF FFFF       DW   FFFF,FFFF


;------------------------------------------------------------------------------
; Rutina vykon cel povel - poadovan prkaz.
; Ak djde ku chybe a bolo nastaven odchytenie chyby prkazom @ON ERROR
; (7825), ; pokrauje sa vykonanm prkazov uvedench za prkazom @ON ERROR.
; Ak nebolo odchytenie chyby nastaven, chyba sa zobraz a urob sa nvrat do
; editora.
; Vstup: HL = adresa povelu
; Vstup: vykonan prkaz a nvrat do prog. sluky
;         ohlsenie chyby, alebo vykonanie prkazov za @ON ERROR
; Men: vetky
;------------------------------------------------------------------------------
7808  CD 783C         CALL 783C         ; odoli povel do MFD 85
780B  CD 784A         CALL 784A         ; pretaj kd chyby z MFD 85
780E  2A 77BE         LHLD 77BE         ; HL=adresa buffra
7811  CA 7828         JZ   7828         ; bez chyby? no, sko
7814  FE 40           CPI  40           ; mu sa odosla dta ?
7816  CA 78E0         JZ   78E0         ; no, sko odosla dta
7819  FE 80           CPI  80           ; s pripraven dta na prijatie ?
781B  CA 7888         JZ   7888         ; no, sko prija dta
781E  21 7875         LXI  H,7875       ; chybov hlka "** DISK ERR = xxx"
7821  22 C074         SHLD C074         ; ulo adresu hlky do sys. prem.
7824  CD 8A89      >> CALL 8A89         ; zobraz hlku a akaj na klvesu
; alebo spracuj @ON ERROR prkazy
7827  3A              DB   3A           ; LDA adr - presko nasl. dve intrukcie
7828  E1              POP  H            ; obnov programov ukazate
7829  C9              RET               ; a vr sa do programovej sluky

782A  C3 0118         JMP  0118         ; vr sa po chybe do editora


;------------------------------------------------------------------------------
; Rutina odole z buffra dta do MFD 85.
; Vstup: (77BE) = adresa dt ukonench 0A (LF)
; Vstup: odoslan dta
; Men: AF, C, HL
;------------------------------------------------------------------------------
782D  2A 77BE         LHLD 77BE         ; HL = adresa dt

;------------------------------------------------------------------------------
; Rutina odole z buffra dta do MFD 85.
; Vstup: HL = adresa dt ukonench 0A (LF)
; Vstup: odoslan dta
; Men: AF, C, HL
;------------------------------------------------------------------------------
7830  7E              MOV  A,M          ; vezmi znak
7831  CD 7660         CALL 7660         ; odoli do MFD 85
7834  23              INX  H            ; posu sa na al znak
7835  79              MOV  A,C          ; test na koniec dt
7836  FE 0A           CPI  0A           ; je to LF ?
7838  C2 7830         JNZ  7830         ; nie, pokrauj v odosielan
783B  C9              RET


;------------------------------------------------------------------------------
; Rutina odole povel do COMMAND registra MFD 85.
; Vstup: HL = adresa povelu
; Vstup: odoslan povel
; Men: AF, C, HL
;------------------------------------------------------------------------------
783C  CD 2042         CALL 2042         ; prepni IMS-2 zbernicu na vstup
783F  E5              PUSH H            ; odpamtaj adresu povelu
7840  21 7865         LXI  H,7865       ; zpis do COMMAND registra MFD 85
7843  CD 1FB5         CALL 1FB5         ; odoli stykov sprvu
7846  E1              POP  H            ; obnov adresu povelu
7847  C3 7830         JMP  7830         ; odoli povel do MFD 85


;------------------------------------------------------------------------------
; Rutina pre natanie STATUS registra - kdu chyby z MFD 85
; Vstup: -
; Vstup: A=kd chyby, Z=1 - bez chyby
;------------------------------------------------------------------------------
784A  CD 2042         CALL 2042         ; prepni IMS-2 zbernicu na vstup
784D  21 7869         LXI  H,7869       ; tanie STATUS registra MFD 85
7850  CD 1FB5         CALL 1FB5         ; odoli stykov sprvu
7853  CD 765A         CALL 765A         ; nastav REN=1, vstup
7856  21 7883         LXI  H,7883       ; adresa buffra pre natanie kdu chyby
7859  E5              PUSH H            ; ulo na zsobnk
785A  CD 20EB         CALL 20EB         ; prjmi kd chyby
785D  E1              POP  H            ; obnov adresu buffra s kdom chyby
785E  CD 16D7         CALL 16D7         ; preve na slo do A
7861  36 0D           MVI  M,0D         ; vr CR do buffra
7863  B7              ORA  A            ; nastav Zero priznak poda kdu chyby
7864  C9              RET


;------------------------------------------------------------------------------
; Stykov sprvy IMS-2 pre komunikciu s MFD 85.
; Prkazom @DISK= je v stykovch sprvach (offset +2) modifikovan adresa MFD 85
;------------------------------------------------------------------------------
; zpis do COMMAND registra MFD 85
; Unlisten, Talker: 15h=PMD 85, Listener: 01h=MFD 85
7865  3F 55 21 00     DB   3F,55,21,00

; tanie STATUS registra MFD 85
; Unlisten, Listener: 15h=PMD 85, Talker: 01h=MFD 85
7869  3F 35 41 00     DB   3F,35,41,00

; zpis do DATA registra MFD 85
; Unlisten, Talker: 15h=PMD 85, Listener: 11h=MFD 85
786D  3F 55 31 00     DB   3F,55,31,00

; tanie DATA registra MFD 85
; Unlisten, Listener: 15h=PMD 85, Talker: 11h=MFD 85
7871  3F 35 51 00     DB   3F,35,51,00


;------------------------------------------------------------------------------
; Chybov hlka.
; Na pozciu reazca "000" (7883) sa zapisuje kd chyby.
; Reazec "ERR" (787D) sa pouva na priradenie kdu chyby premennej 'ER',
; ktor je mon poui v BASICu po odchyten chyby.
;------------------------------------------------------------------------------
7875  2A 2A 20 44     DB   '** DISK '
7879  49 53 4B 20
787D  45 52 52 20     DB   'ERR = 000',0D,0A
7881  3D 20 30 30
7885  30 0D 0A


;------------------------------------------------------------------------------
; Spolon rutina pre prjem dt z MFD 85.
; Adresa rutiny, ktor spracuje prijat dta, mus by uloen na adrese 7897.
; Vstup: HL = adresa buffra
; Vstup: prijat dta
; Men: vetky
;------------------------------------------------------------------------------
7888  E5              PUSH H            ; odpamtaj adresu buffra
7889  21 7871         LXI  H,7871       ; tanie DATA registra MFD 85
788C  CD 2042         CALL 2042         ; prepni IMS-2 zbernicu na vstup
788F  CD 1FB5         CALL 1FB5         ; odoli stykov sprvu
7892  CD 765A         CALL 765A         ; nastav REN=1, vstup
7895  E1              POP  H            ; obnov adresu buffra
7896  CD 78A1      >> CALL 78A1         ; prjmi dta
7899  C3 780B         JMP  780B         ; pokrauj pretanm kdu chyby


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
789C  FF FF FF FF     DB   FF,FF,FF,FF
78A0  FF              DB   FF


;------------------------------------------------------------------------------
; Rutina prjme zo zbernice reazec znakov a zobraz ho na aktulnu pozciu.
; Vstup: (77BE) = adresa buffra
; Vstup: zobrazen prijat reazec
; Men: AF, HL
;------------------------------------------------------------------------------
78A1  CD 20EB         CALL 20EB         ; prjmi reazec zo zbernice
78A4  2A 77BE         LHLD 77BE         ; adresa buffra
78A7  7E              MOV  A,M          ; vezmi znak
78A8  B7              ORA  A            ; koniec reazca ?
78A9  CA 7A56         JZ   7A56         ; no, sko dopredu
78AC  CD 8500         CALL 8500         ; zobraz znak
78AF  23              INX  H            ; posu sa na al znak
78B0  C3 78A7         JMP  78A7         ; opakuj pre cel reazec


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
78B3  FF FF FF        DB   FF,FF,FF


;------------------------------------------------------------------------------
; Reazec povelu pre zskanie mena disku
;------------------------------------------------------------------------------
78B6  4E 44 0D 0A     DB   'ND',0D,0A

;------------------------------------------------------------------------------
; Prkaz: @NAME [ ; A$ ]
; Povel m tvar: ND
; * Zobrazenie alebo zskanie mena disku.
;------------------------------------------------------------------------------
78BA  FE 3B           CPI  3B           ; je alm znakom bodkoiarka ?
78BC  CA 76D2         JZ   76D2         ; no, sko dopredu
78BF  E5              PUSH H            ; odpamtaj prog. ukazate
78C0  21 5EF1         LXI  H,5EF1       ; adresa buffra
78C3  22 77BE         SHLD 77BE         ; ulo
78C6  21 78A1         LXI  H,78A1       ; adresa rutiny pre prjem reazca
78C9  22 7897         SHLD 7897         ; a jeho zobrazenie
78CC  21 78B6         LXI  H,78B6       ; adresa povelu prkazu @NAME
78CF  C3 7808         JMP  7808         ; vykonaj cel povel


;------------------------------------------------------------------------------
; Reazec povelu pre zskanie zoznamu sborov - katalg disku
;------------------------------------------------------------------------------
78D2  44 44 0D 0A     DB   'DD',0D,0A

;------------------------------------------------------------------------------
; Prkaz: @CAT
; Povel m tvar: ND    - pre nzov disku, potom opakovane
;                DD    - pre mena sborov v katalgu
; * Vpis katalgu disku.
;------------------------------------------------------------------------------
78D6  CD 78BF         CALL 78BF         ; zskaj najprv meno disku a zobraz ho
78D9  E5              PUSH H            ; odpamtaj prog. ukazate
78DA  21 78D2         LXI  H,78D2       ; adresa povelu pre katalg disku
78DD  C3 7808         JMP  7808         ; vykonaj cel povel


;------------------------------------------------------------------------------
; Spolon rutina pre odoslanie dt do MFD 85.
; Adresa rutiny, ktor odole dta, mus by uloen na adrese 78EF.
; Vstup: HL = adresa buffra
; Vstup: odoslan dta
; Men: vetky
;------------------------------------------------------------------------------
78E0  E5              PUSH H            ; odpamtaj adresu buffra
78E1  00              NOP
78E2  00              NOP
78E3  00              NOP
78E4  CD 2042         CALL 2042         ; prepni IMS-2 zbernicu na vstup
78E7  21 786D         LXI  H,786D       ; zpis do DATA registra MFD 85
78EA  CD 1FB5         CALL 1FB5         ; odoli stykov sprvu
78ED  E1              POP  H            ; obnov adresu buffra
78EE  CD 782D      >> CALL 782D         ; odoli dta z buffra do MFD 85
78F1  C3 780B         JMP  780B         ; pokrauj pretanm kdu chyby


;------------------------------------------------------------------------------
; Rutina vyhodnot a spracuje reazec v prkaze. Po vyhodnoten, je reazec
; uloen v buffri od adresy 5EF1.
; Ak je to kontantn reazec, mus zana aj koni uvodzovkami.
; Ak je to premenn, mus to by, pochopitene, reazcov premenn. Slovo
; "mus", je v tomto prpade na mieste, pretoe v rutine sa po analze premennej
; nekontroluje typ premennej a po uveden selnej premennej sa nehlsi chyba.
; Uvedenie selnej premennej m teda za nsledok nepredvdaten sprvanie.
; Vstup: HL=adresa prog. ukazatea
; Vstup: DE=ukazuje do buffra povelu za uloen reazec
; Men: vetky
;------------------------------------------------------------------------------
78F4  7E              MOV  A,M          ; vezmi prv znak
78F5  FE 22           CPI  '"'          ; s to vodzovky ?
78F7  CA 7914         JZ   7914         ; no, sko spracova kont. reazec
78FA  CD 0B07         CALL 0B07         ; analyzuj premenn, DE=adresa premennej
78FD  E5              PUSH H            ; odpamtaj prog. ukazate
78FE  1A              LDAX D            ; vezmi dku reazca
78FF  47              MOV  B,A          ; ulo do B
7900  13              INX  D            ; posu sa na adresu reazca
7901  13              INX  D
7902  1A              LDAX D            ; adresa reazca do HL
7903  6F              MOV  L,A
7904  13              INX  D
7905  1A              LDAX D
7906  67              MOV  H,A
7907  11 5EF1         LXI  D,5EF1       ; adresa buffra pre povel
790A  7E              MOV  A,M          ; skopruj reazec o dke B
790B  12              STAX D
790C  23              INX  H
790D  13              INX  D
790E  05              DCR  B            ; opakuj B krt
790F  C2 790A         JNZ  790A
7912  E1              POP  H            ; obnov prog. ukazate
7913  C9              RET

7914  11 5EF1         LXI  D,5EF1       ; adresa buffra pre povel
7917  23              INX  H            ; posu sa na al znak
7918  7E              MOV  A,M          ; vezmi znak
7919  B7              ORA  A            ; ak je to 00 (koniec riadku),
791A  CA 00FF         JZ   00FF         ; chbaj vodzovky a je to chyba
791D  FE 22           CPI  '"'          ; s to vodzovky ?
791F  CA 0075         JZ   0075         ; no, vr sa cez peskoenie medzier
7922  12              STAX D            ; ulo znak do buffra
7923  13              INX  D            ; posu sa v buffri
7924  C3 7917         JMP  7917         ; opakuj pre cel reazec


;------------------------------------------------------------------------------
; Prkaz: @INIT A$
; Povel m tvar: FH'diskname'
; * Inicializcia diskety - formtovanie - s menom disku A$.
;------------------------------------------------------------------------------
7927  3E 46           MVI  A,'F'        ; kd povelu - formt disku
7929  01              DB   01           ; LXI B,xxxx - preskoenie nasl. intr.

;------------------------------------------------------------------------------
; Prkaz: @PURGE A$
; Povel m tvar: EH'filename'
; * Vymazanie sboru s menom A$.
;------------------------------------------------------------------------------
792A  3E 45           MVI  A,'E'        ; kd povelu - vymazanie sboru
792C  01              DB   01           ; LXI B,xxxx - preskoenie nasl. intr.

;------------------------------------------------------------------------------
; Prkaz: @SECURE A$
; Povel m tvar: BH'filename'
; * Utajenie/Odtajnenie sboru s menom A$ v katalgu.
;------------------------------------------------------------------------------
792D  3E 42           MVI  A,'B'        ; kd povelu - utajenie sboru
792F  01 794A         LXI  B,794A       ; adresa textu ukon. reazca a povelu
7932  C5              PUSH B            ; odpamtaj
7933  32 5EEE         STA  5EEE         ; ulo do buffra kd povelu
7936  CD 78F4         CALL 78F4         ; spracuj reazec za prkazom
7939  C1              POP  B            ; obnov adresu textu ukon. povelu
793A  CD 794D         CALL 794D         ; presu do povelovho buffra
793D  E5              PUSH H            ; odpamtaj prog. ukazate
793E  21 5EF0         LXI  H,5EF0       ; adresa v buffri
7941  36 27           MVI  M,''''       ; zaiaton apostrof
7943  2B              DCX  H
7944  36 48           MVI  M,'H'        ; hodnoty ako HEXA
7946  2B              DCX  H            ; HL=zaiatok buffra povelu
7947  C3 7808         JMP  7808         ; vykonaj cel povel


;------------------------------------------------------------------------------
; ukonenie reazca apostrofom a CRLF
;------------------------------------------------------------------------------
794A  27 0D 0A        DB   '''',0D,0A


;------------------------------------------------------------------------------
; Presun reazca ukonenho LF.
; Vstup: BC=adresa textu ukonenho LF
; Vstup: DE=adresa cieovho buffra
; Men: AF, BC, DE
;------------------------------------------------------------------------------
794D  0A              LDAX B            ; vezmi znak
794E  12              STAX D            ; ulo do buffra
794F  FE 0A           CPI  0A           ; je to koniec textu (LF) ?
7951  03              INX  B            ; posu oba ukazatele
7952  13              INX  D
7953  C2 794D         JNZ  794D         ; opakuj pre cel reazec
7956  C9              RET


;------------------------------------------------------------------------------
; Rutina vyhodnot aktulny vraz v prog. riadku a ulo do povelovho riadku
; ako '$XXXX', kde XXXX je HEXA hodnota vrazu
; Vstup: HL=prog. ukazate
;        DE=adresa v povelovom riadku
; Vstup: '$' + slo/poet zznamov ako HEXA v povelovom riadku
;         DE=adresa v povelovom riadku za uloenm slom
;         HL=prog. ukazate za vyhodnotenm vrazom
; Men: vetky
;------------------------------------------------------------------------------
7957  3E 24           MVI  A,'$'        ; parameter - slo/poet zznamov
7959  12              STAX D            ; ulo
795A  13              INX  D            ; posu ukazate v povelovom riadku
795B  D5              PUSH D            ; odpamtaj
795C  CD 0933         CALL 0933         ; vyhodno vraz v prog. riadku
795F  CD 05C3         CALL 05C3         ; ako 16. bitove slo, ulo do DE

; 7 intrukci od 7962 do 796A sa dalo napsa dvoma intrukciami:
;                     XTHL              ; odpamtaj prog. ukazate
;                     CALL 7999         ; vsledok do povelovho buffra ako HEXA

7962  D5              PUSH D            ; vsledok - slo/poet zznamu
7963  C1              POP  B            ; do BC
7964  D1              POP  D            ; obnov ukazate do povelovho buffra
7965  E5              PUSH H            ; odpamtaj prog. ukazate
7966  C5              PUSH B            ; vsledok - slo/poet zznamu
7967  E1              POP  H            ; do HL
7968  CD 7998         CALL 7998         ; a ulo do povelovho buffra ako HEXA

796B  E1              POP  H            ; obnov prog. ukazate
796C  C9              RET


;------------------------------------------------------------------------------
; Prkaz: @CREATE A$; X, Y
; Povel m tvar: CH'filename'$xxxx@yyyy*D
; * Vytvorenie dtovho sboru s menom A$, s X zaznamami, s dkou Y na jeden
;   zznam.
;------------------------------------------------------------------------------
796D  3E 43           MVI  A,'C'        ; kd povelu - vytv. dtovho sboru
796F  32 5EEE         STA  5EEE         ; ulo do povelovho buffra
7972  CD 78F4         CALL 78F4         ; spracuj reazec za prkazom
7975  3E 27           MVI  A,''''       ; ukoni reazec apostrofom
7977  12              STAX D
7978  13              INX  D
7979  CD 006D         CALL 006D         ; mus nasledova bodkoiarka
797C  3B              DB   ';'
797D  CD 7957         CALL 7957         ; spracuj poet zznamov v sbore
7980  CD 006D         CALL 006D         ; mus nasledova iarka
7983  2C              DB   ','
7984  CD 79A8         CALL 79A8         ; spracuj dku jednho zznamu
7987  01 798D         LXI  B,798D       ; adresa reazca pre ukonenie povelu
798A  C3 793A         JMP  793A         ; ukoni povel a vykonaj cel prkaz

;------------------------------------------------------------------------------
; Reazec pre ukonenie povelu pre prkaz @CREATE
;------------------------------------------------------------------------------
798D  2A 44 0D 0A     DB   '*D',0D,0A


;------------------------------------------------------------------------------
; Hluch kd.
; plne identick kd je aj od adresy 7AFB.
;------------------------------------------------------------------------------
7991  2A 5E7A         LHLD 5E7A
7994  01 DC04         LXI  B,DC04
7997  09              DAD  B


;------------------------------------------------------------------------------
; Rutina ulo do povelovho riadku slo ako ASCII HEXA.
; Vstup: HL=ukladan hodnota
;        DE=adresa v povelovom riadku
; Vstup: (77BC)=ukladan hodnota
;         DE=adresa v povelovom riadku za uloenm slom
; Men: AF, B, DE
;------------------------------------------------------------------------------
7998  EB              XCHG              ; hodnota do DE
7999  7A              MOV  A,D          ; najprv vy byte
799A  CD 813B         CALL 813B         ; ulo do povelovho buffra ako 2xHEXA
799D  23              INX  H            ; posu ukazate
799E  7B              MOV  A,E          ; teraz ni byte
799F  CD 813B         CALL 813B         ; ulo do povelovho buffra ako 2xHEXA
79A2  23              INX  H            ; posu ukazate
79A3  EB              XCHG              ; hodnota do HL
79A4  22 77BC         SHLD 77BC         ; ulo ako dku dt (dtovho buffra)
79A7  C9              RET


;------------------------------------------------------------------------------
; Rutina vyhodnot aktulny vraz v prog. riadku a ulo do povelovho riadku
; ako '@XXXX', kde XXXX je 8. bit HEXA hodnota vrazu
; Vstup: HL=prog. ukazate
;        DE=adresa v povelovom riadku
; Vstup: '@' + dka zznamu/dt ako HEXA v povelovom riadku
;         DE=adresa v povelovom riadku za uloenm slom
;         HL=prog. ukazate za vyhodnotenm vrazom
; Men: vetky
;------------------------------------------------------------------------------
79A8  3E 40           MVI  A,'@'        ; parameter - dka jednho zznamu
79AA  12              STAX D            ; ulo

;------------------------------------------------------------------------------
; Rutina vyhodnot aktulny vraz v prog. riadku a ulo do povelovho riadku
; 8. bit HEXA hodnotu vrazu.
; Vstup: HL=prog. ukazate
;        DE=adresa v povelovom riadku
; Vstup: hodnota vrazu ako HEXA v povelovom riadku
;         DE=adresa v povelovom riadku za uloenm slom
;         HL=prog. ukazate za vyhodnotenm vrazom
; Men: vetky
;------------------------------------------------------------------------------
79AB  13              INX  D            ; posu ukazate
79AC  D5              PUSH D            ; a odpamtaj
79AD  CD 16D7         CALL 16D7         ; vyhodno vraz v prog. riadku - 8 bit
79B0  D1              POP  D            ; obnov ukazate do povelovho riadku
79B1  E5              PUSH H            ; odpamtaj prog. ukazate
79B2  26 00           MVI  H,00         ; hodnota vrazu do HL
79B4  6F              MOV  L,A
79B5  CD 7998         CALL 7998         ; a ulo do povelovho buffra ako HEXA
79B8  E1              POP  H            ; obnov prog. ukazate
79B9  C9              RET


;------------------------------------------------------------------------------
; Prkaz: @PRINT# A, X ; vraz
; Povel m tvar: PH#aaaa$xxxx!
; * Zpis do zvolenho logickho zznamu X dtovho sboru s slom A.
;------------------------------------------------------------------------------
79BA  3E 50           MVI  A,'P'        ; kd povelu - zpis do dtovho sboru
79BC  E5              PUSH H            ; odpamtaj prog. ukazate
79BD  21 79EC         LXI  H,79EC       ; adresa rutiny pre odoslanie dt
79C0  22 78EF         SHLD 78EF         ; ulo adresu rutiny
79C3  21 5EEE         LXI  H,5EEE       ; adresa povelovho buffra
79C6  77              MOV  M,A          ; ulo kd povelu
79C7  23              INX  H
79C8  36 48           MVI  M,'H'        ; HEXA hodnoty
79CA  23              INX  H
79CB  36 23           MVI  M,'#'        ; parameter - slo dtovho sboru
79CD  EB              XCHG              ; adresa povelovho buffra do DE
79CE  E1              POP  H            ; obnov prog ukazate
79CF  01 7A01         LXI  B,7A01       ; adresa textu ukonenia povelu
79D2  C5              PUSH B            ; na zsobnk
79D3  CD 79AB         CALL 79AB         ; vyhodno a ulo slo dtovho sboru
79D6  CD 006D         CALL 006D         ; mus nasledova iarka
79D9  2C              DB   ','
79DA  CD 7957         CALL 7957         ; vyhodno a ulo slo zznamu
79DD  CD 006D         CALL 006D         ; mus nasledova bodkoiarka
79E0  3B              DB   ';'
79E1  C1              POP  B            ; obnov adresu textu ukonenia povelu
79E2  CD 794D         CALL 794D         ; presu text do povelovho buffra
79E5  E5              PUSH H            ; odpamtaj prog. ukazate
79E6  21 5EEE         LXI  H,5EEE       ; adresa povelovho buffra
79E9  C3 7808         JMP  7808         ; vykonaj cel povel/prkaz


;------------------------------------------------------------------------------
; Rutina pre odoslanie dt uvedench za prkazmi @SEARCH#, @PRINT#, @CMD.
;------------------------------------------------------------------------------
79EC  C1              POP  B            ; zaho nvratov adresu
79ED  21 7660         LXI  H,7660       ; adresu pre vstup na IMS-2 zbernicu
79F0  22 0015         SHLD 0015         ; ulo ako tandardn vstup - PRINT
79F3  E1              POP  H            ; obnov prog. ukazate
79F4  CD 0076         CALL 0076         ; presko medzery v prog. riadku
79F7  CD 0744         CALL 0744         ; odoli dta na zbernicu
79FA  E5              PUSH H            ; odpamtaj prog. ukazate
79FB  C3 780B         JMP  780B         ; pokrauj pretanim kdu chyby


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
79FE  FF              DB   FF


;------------------------------------------------------------------------------
; Adresa prkazov za @ON ERROR, ktor sa vykonaj pri chybe.
;------------------------------------------------------------------------------
79FF  78FF            DW   78FF


;------------------------------------------------------------------------------
; Adresa textu pre ukonenie povelov 'P' a 'I' (prkazy @PRINT# a @READ#).
; '!' znamen kontrolu parametrov.
;------------------------------------------------------------------------------
7A01  21 0D 0A        DB   '!',0D,0A


;------------------------------------------------------------------------------
; Prkaz: @READ# A, X; premenn [ , premenn ]
; Povel m tvar: IH#aaaa$xxxx!
; * tanie zo zvolenho logickho zznamu X z dtovho sboru A.
;------------------------------------------------------------------------------
7A04  3E 49           MVI  A,'I'        ; kd povelu - tanie z dtovho sboru
7A06  E5              PUSH H            ; odpamtaj prog. ukazate
7A07  21 7A10         LXI  H,7A10       ; adresa rutiny pre prjem dt
7A0A  22 7897         SHLD 7897         ; ulo adresu rutiny
7A0D  C3 79C3         JMP  79C3         ; spracuj a vykonaj povel/prkaz


;------------------------------------------------------------------------------
; Rutina pre prjem dt pre prkazy @READ# a @CMD.
;------------------------------------------------------------------------------
7A10  21 5EF1         LXI  H,5EF1       ; adresa kam sa prjmu dta
7A13  CD 20EB         CALL 20EB         ; prjmi dta zo zbernice
7A16  C1              POP  B            ; zaho nvratov adresu
7A17  21 76E7         LXI  H,76E7       ; adresa nvratu z vykonania povelu
7A1A  E5              PUSH H            ; ulo na zsobnk
7A1B  E5              PUSH H
7A1C  C3 780B         JMP  780B         ; pokrauj pretanim kdu chyby


;------------------------------------------------------------------------------
; Rutina priprav zaiatok povelu a spracuje slo dtovho sboru v prkaze.
; Vstup: HL=prog. ukazate
;        DE= adr. povelovho buffra
;        B=kd povelu, C=parameter '#'
; Vstup: pripaveny zaiatok povelovho buffra
; Men: vetky
;------------------------------------------------------------------------------
7A1F  E5              PUSH H            ; odpamtaj prog. ukazate
7A20  21 5EEE         LXI  H,5EEE       ; adresa povelovho buffra
7A23  70              MOV  M,B          ; ulo kd povelu
7A24  23              INX  H            ; posu ukazate
7A25  36 48           MVI  M,'H'        ; HEXA hodnoty
7A27  23              INX  H            ; posu ukazate
7A28  71              MOV  M,C          ; ulo kd parametra
7A29  EB              XCHG              ; adresa povelovho buffra do DE
7A2A  E1              POP  H            ; obnov prog. ukazate
7A2B  C3 79AB         JMP  79AB         ; vr sa cez spracovanie sla sboru


;------------------------------------------------------------------------------
; Prkaz: @OPEN A$ # A
; Povel m tvar: OH'filename'#aaaa
; * Otvorenie dtovho sboru s menom A$ s slom A.
;------------------------------------------------------------------------------
7A2E  3E 4F           MVI  A,'O'        ; kd povelu - otvorenie sboru
7A30  32 5EEE         STA  5EEE         ; ulo do povelovho buffra
7A33  CD 78F4         CALL 78F4         ; spracuj reazec za prkazom
7A36  CD 006D         CALL 006D         ; mus nasledova hash-krik
7A39  23              DB   '#'
7A3A  3E 27           MVI  A,''''       ; ulo ukonovac apostrof
7A3C  12              STAX D
7A3D  13              INX  D
7A3E  3E 23           MVI  A,'#'        ; ulo kd parametera slo sboru
7A40  12              STAX D
7A41  CD 79AB         CALL 79AB         ; vyhodno a ulo slo dtovho sboru
7A44  01 7A02         LXI  B,7A02       ; adresa CRLF
7A47  C3 793A         JMP  793A         ; ukoni povel a vykonaj cel prkaz


;------------------------------------------------------------------------------
; Prkaz: @CLOSE# A
; Povel m tvar: UH#aaaa
; * Uzatvorenie dtovho sboru s slom A.
;------------------------------------------------------------------------------
7A4A  01 5523         LXI  B,5523       ; 'U' - kd povelu, '#' - slo sboru
7A4D  CD 7A1F         CALL 7A1F         ; priprav povelov buffer a slo sboru
7A50  01 7A02         LXI  B,7A02       ; adresa CRLF
7A53  C3 79E2         JMP  79E2         ; ukoni povel a vykonaj cel prkaz


;------------------------------------------------------------------------------
; Ukonenie prkazu @NAME, ak sa vypisuje meno na obrazovku
;------------------------------------------------------------------------------
7A56  3E 0D           MVI  A,0D
7A58  C3 8500         JMP  8500         ; odriadkuj a vr sa


;------------------------------------------------------------------------------
; Rutina preta byte zo zbernice IMS-2.
; Vstup: -
; Vstup: A=pretan byte
; Men: AF
;------------------------------------------------------------------------------
7A5B  3E 49           MVI  A,49         ; NDAC=1, NRFD=0
7A5D  D3 7E           OUT  7E
7A5F  DB 7D           IN   7D           ; je DAV=1 ?
7A61  E6 02           ANI  02
7A63  CA 7A5F         JZ   7A5F         ; nie, akaj
7A66  DB 7C           IN   7C           ; pretaj byte
7A68  F5              PUSH PSW
7A69  3E 45           MVI  A,45         ; NDAC=0, NRFD=1
7A6B  D3 7E           OUT  7E
7A6D  DB 7D           IN   7D           ; pokaj na DAV=0
7A6F  E6 02           ANI  02
7A71  C2 7A6D         JNZ  7A6D
7A74  3E 4D           MVI  A,4D         ; NDAC=1, NRFD=1
7A76  D3 7E           OUT  7E
7A78  F1              POP  PSW
7A79  C9              RET


;------------------------------------------------------------------------------
; Rutina preta jednu "vetu" ukonen CRLF zo zbernice.
; Vstup: (77BE)=adresa pamti, kam sa uloia natan dta
; Vstup: natan dta
; Men: AF, HL, (77BE)
;------------------------------------------------------------------------------
7A7A  2A 77BE         LHLD 77BE         ; HL=adresa bufferu
7A7D  3E 92           MVI  A,92         ; prepni IMS-2 zbernicu na vstup
7A7F  D3 7F           OUT  7F
7A81  3E 4D           MVI  A,4D         ; NDAC=1, NRFD=1
7A83  D3 7E           OUT  7E
7A85  CD 7A5B         CALL 7A5B         ; pretaj znak zo zbernice
7A88  FE 0D           CPI  0D           ; je to R ?
7A8A  CA 7A5B         JZ   7A5B         ; no, vr sa cez pretanie LF
7A8D  CD 80E0         CALL 80E0         ; preve HEXA na slo
7A90  07              RLC               ; presu do hornych tyroch bitov
7A91  07              RLC
7A92  07              RLC
7A93  07              RLC
7A94  77              MOV  M,A          ; odpamtaj
7A95  CD 7A5B         CALL 7A5B         ; pretaj znak zo zbernice
7A98  CD 80E0         CALL 80E0         ; preve HEXA na slo - doln bity
7A9B  B6              ORA  M            ; pridaj horne bity
7A9C  77              MOV  M,A          ; ulo cel hodnotu
7A9D  23              INX  H            ; posu ukazate
7A9E  7D              MOV  A,L          ; ak si vo VIDEORAM dosiahol oblas
7A9F  E6 30           ANI  30           ; zpisnka,
7AA1  FE 30           CPI  30
7AA3  CC 7AB1      >> CZ   7AB1         ; uprav ukazate do alieho mikroriadku
7AA6  22 77BE         SHLD 77BE         ; ulo ukazate
7AA9  C3 7A85         JMP  7A85         ; opakuj pre cel HEXA reazec

; Rutina pre pravu ukazatea pri zpise alebo tani z/do VIDEORAM
7AAC  7D              MOV  A,L          ; prejdi na nov mikroriadok
7AAD  F6 0F           ORI  0F
7AAF  6F              MOV  L,A
7AB0  23              INX  H
7AB1  C9              RET


;------------------------------------------------------------------------------
; Reazec pre ukonenie povelu pre prkazy @BLOAD a @BSTORE.
;------------------------------------------------------------------------------
7AB2  27 2A 42 0D     DB   '''*B',0D,0A
7AB6  0A

;------------------------------------------------------------------------------
; Reazec pre ukonenie povelu pre prkazy @LOAD a @STORE.
;------------------------------------------------------------------------------
7AB7  27 2A 50 0D     DB   '''*P',0D,0A
7ABB  0A

;------------------------------------------------------------------------------
; Reazec pre ukonenie povelu pre prkazy @GLOAD a @GSTORE.
;------------------------------------------------------------------------------
7ABC  27 2A 47 0D     DB   '''*G',0D,0A
7AC0  0A


;------------------------------------------------------------------------------
; Prkaz: @GLOAD A$
; Povel m tvar: LH'filename'*G
; * Nahratie sboru s menom A$ do VIDEORAM.
;------------------------------------------------------------------------------
7AC1  E5              PUSH H            ; odpamtaj prog. ukazate
7AC2  21 C000         LXI  H,C000       ; adresa buffra - zaiatok VIDORAM
7AC5  01 7ABC         LXI  B,7ABC       ; adr. reazca ukonujceho povel
7AC8  22 77BE         SHLD 77BE         ; ulo adresu buffra
7ACB  21 7AAC         LXI  H,7AAC       ; adresa rutiny pre pravu ukazatea
7ACE  22 7AA4         SHLD 7AA4         ; ulo adresu rutiny pre pr. ukazatea
7AD1  3E 4C           MVI  A,4C         ; ???
7AD3  21 7A7A         LXI  H,7A7A       ; adresa rutiny pre tanie zo zbernice
7AD6  22 7897         SHLD 7897         ; ulo adresu rutiny
7AD9  E1              POP  H            ; obnov prog. ukazate
7ADA  C3 7932         JMP  7932         ; sko preta sbor


;------------------------------------------------------------------------------
; Prkaz: @LOAD A$ - pokraovanie
; Povel m tvar: LH'filename'*P
; * Nahratie programu s menom A$ do pamti.
;------------------------------------------------------------------------------
7ADD  E5              PUSH H            ; odpamtaj prog. ukazate
7ADE  21 2400         LXI  H,2400       ; adresa buffra - zaiatok prog. BASIC
7AE1  01 7AB7         LXI  B,7AB7       ; adr. reazca ukonujceho povel
7AE4  22 77BE         SHLD 77BE         ; ulo adresu buffra
7AE7  21 7AB1         LXI  H,7AB1       ; adresa rutiny - bez pravy ukazatea
7AEA  C3 7ACE         JMP  7ACE         ; pokrauj


;------------------------------------------------------------------------------
; Prkaz: @BLOAD A$
; Povel m tvar: LH'filename'*B
; * Nahratie binarnych dt zo sboru s menom A$ do pamti.
;------------------------------------------------------------------------------
7AED  E5              PUSH H            ; odpamtaj prog. ukazate
7AEE  01 7AB2         LXI  B,7AB2       ; adr. reazca ukonujceho povel
7AF1  C3 7AE7         JMP  7AE7         ; pokrauj


;------------------------------------------------------------------------------
; Prkaz: @LOAD A$
; Povel m tvar: LH'filename'*P
; * Nahratie programu s menom A$ do pamti.
;------------------------------------------------------------------------------
7AF4  CD 7ADD         CALL 7ADD         ; pretaj program zo sboru
7AF7  E5              PUSH H
7AF8  C3 1E04         JMP  1E04         ; a nastav nanovo syst. premenn BASIC


;------------------------------------------------------------------------------
; Rutina pre vpoet dky programu a uloenie dky ako HEXA do povelovho
; buffra pre prkaz @STORE.
; Vstup: DE = adresa povelovho buffra
; Vstup: (77BC)=dka programu
; Men: vetky
;------------------------------------------------------------------------------
7AFB  2A 5E7A         LHLD 5E7A         ; HL=adresa konca programu
7AFE  01 DC04         LXI  B,DC04       ; -23FC
7B01  09              DAD  B            ; HL = dka programu
7B02  EB              XCHG              ; preve dku do HEXA
7B03  7A              MOV  A,D          ; a ulo do povelovho buffra
7B04  CD 813B         CALL 813B         ; vy byte
7B07  23              INX  H
7B08  7B              MOV  A,E
7B09  CD 813B         CALL 813B         ; ni byte
7B0C  23              INX  H
7B0D  EB              XCHG
7B0E  22 77BC         SHLD 77BC         ; ulo dku programu
7B11  C9              RET


;------------------------------------------------------------------------------
; Rutina pre odoslanie binarnych dt.
; Vstup: (77BE) = aktualna adresa dt
;        (77BC) = zostvajca dka dt
; Vstup: odoslan dta
; Men: Vetky
;------------------------------------------------------------------------------
7B12  01 0080         LXI  B,0080       ; dka dt v jednom bloku 128
7B15  2A 77BC         LHLD 77BC         ; HL = zostvajca dka
7B18  11 FF80         LXI  D,FF80       ; -128
7B1B  CD 7BA9         CALL 7BA9         ; ak je zostvajca dka via ako
7B1E  DA 7B25         JC   7B25         ; 128, sko dopredu
7B21  4D              MOV  C,L          ; zostvajca dka do B
7B22  21 0080         LXI  H,0080       ; 128 - pre nsledne vynulovanie HL
7B25  19              DAD  D            ; odpotaj 128
7B26  22 77BC         SHLD 77BC         ; ulo zostvajcu dku
7B29  41              MOV  B,C          ; dka bloku do B
7B2A  2A 77BE         LHLD 77BE         ; HL =  adresa dt
7B2D  7E              MOV  A,M          ; vezmi byte
7B2E  0F              RRC               ; a preve do HEXA
7B2F  0F              RRC
7B30  0F              RRC
7B31  0F              RRC
7B32  E6 0F           ANI  0F           ; horn 4 bity
7B34  CD 814F         CALL 814F         ; preve na ASCII
7B37  CD 7660         CALL 7660         ; odoli
7B3A  7E              MOV  A,M          ; vezmi byte
7B3B  E6 0F           ANI  0F           ; doln 4 bity
7B3D  CD 814F         CALL 814F         ; preve na ASCII
7B40  CD 7660         CALL 7660         ; odoli
7B43  23              INX  H            ; posu ukazate na dta
7B44  7D              MOV  A,L          ; ak si vo VIDEORAM dosiahol oblas
7B45  E6 30           ANI  30           ; zpisnka,
7B47  FE 30           CPI  30
7B49  CC 7AB1      >> CZ   7AB1         ; uprav ukazate do alieho mikroriadku
7B4C  22 77BE         SHLD 77BE         ; ulo ukazate
7B4F  05              DCR  B            ; zn poet odosielanch dt v bloku
7B50  C2 7B2D         JNZ  7B2D         ; opakuj pre cel blok dt
7B53  3E 0D           MVI  A,0D         ; ukoni dta s CRLF
7B55  CD 7660         CALL 7660
7B58  3E 0A           MVI  A,0A
7B5A  C3 7660         JMP  7660


;------------------------------------------------------------------------------
; Prkaz: @STORE A$
; Povel m tvar: ZH'filename'$xxxx*B
; * Uloenie BASIC programu s menom A$ na disk.
;------------------------------------------------------------------------------
7B5D  E5              PUSH H            ; odpamtaj prog. ukazate
7B5E  21 2400         LXI  H,2400       ; adresa zaiatku programu
7B61  22 77BE         SHLD 77BE         ; ulo ako adresu buffra
7B64  21 7AB1         LXI  H,7AB1       ; adresa rutiny - bez pravy ukazatea
7B67  22 7B4A         SHLD 7B4A         ; ulo adresu rutiny pre upr. ukazatea
7B6A  01 7AB8         LXI  B,7AB8       ; adresa reazca s ukonenm povelu
7B6D  21 7AFB         LXI  H,7AFB       ; adresa rutiny pre prpravu dky dt
7B70  22 7B8D         SHLD 7B8D         ; ulo adresu rutiny
7B73  21 7B12         LXI  H,7B12       ; adresa rutiny pre odoslanie dt
7B76  22 78EF         SHLD 78EF         ; ulo adresu rutiny
7B79  E1              POP  H            ; obnov prog. ukazate
7B7A  3E 5A           MVI  A,'Z'        ; kd povelu - binrny zapis
7B7C  32 5EEE         STA  5EEE         ; ulo kd povelu
7B7F  C5              PUSH B            ; odpamtaj adr. reazca s ukon. povelu
7B80  CD 78F4         CALL 78F4         ; spracuj reazec za prkazom
7B83  3E 27           MVI  A,''''       ; ukonovac apostrof mena sboru
7B85  12              STAX D            ; ulo do povelovho buffra
7B86  13              INX  D            ; posu ukazate
7B87  E5              PUSH H            ; odpamtaj prog. ukazate
7B88  3E 24           MVI  A,'$'        ; parameter - dka dt
7B8A  12              STAX D            ; ulo
7B8B  13              INX  D            ; posu ukazate
7B8C  CD 7AFB      >> CALL 7AFB         ; ulo dku v HEXA do povelovho buffra
7B8F  E1              POP  H            ; obnov prog. ukazate
7B90  C3 7939         JMP  7939         ; ukoni a vykonaj povel


;------------------------------------------------------------------------------
; Prkaz: @GSTORE A$
; Povel m tvar: ZH'filename'$xxxx*G
; * Uloenie VIDEORAM do sboru s menom A$. Uklad sa iba 245 mikroriadkov, teda ;   bez dialgovho riadku.
; Adresa rutiny pre prpravu dky dt je o 1 niia, ako by mala by. Naastie
; to nespsobuje iadny problm.
;------------------------------------------------------------------------------
7B93  E5              PUSH H            ; odpamtaj prog. ukazate
7B94  21 C000         LXI  H,C000       ; adresa VIDEORAM
7B97  22 77BE         SHLD 77BE         ; ako adresa buffra
7B9A  21 7AAC         LXI  H,7AAC       ; adresa rutiny pre pravu ukazatea
7B9D  01 7ABD         LXI  B,7ABD       ; adresa reazca s ukonenm povelu
7BA0  22 7B4A         SHLD 7B4A         ; ulo adresu rutiny pre upr. ukazatea
7BA3  21 7BBD         LXI  H,7BBD       ; adresa rutiny pre prpravu dky dt
7BA6  C3 7B70         JMP  7B70         ; ukoni a vykonaj povel


;------------------------------------------------------------------------------
; Rutina porovna BC a HL
; Vstup: HL, BC
; Vstup: CY = 1, ak HL > BC
;         CY = 0, ak HL <= BC
; Men: AF, HL
;------------------------------------------------------------------------------
7BA9  79              MOV  A,C          ; odpotaj ni byte
7BAA  95              SUB  L
7BAB  78              MOV  A,B          ; odpotaj vy byte
7BAC  9C              SBB  H
7BAD  C9              RET


;------------------------------------------------------------------------------
; Prkaz: @BSTORE A$
; Povel m tvar: ZH'filename'$xxxx*B
; * Uloenie binarnych dt do sboru s menom A$.
; Adresa rutiny pre prpravu dky dt je o 1 niia, ako by mala by. Naastie
; to nespsobuje iadny problm.
;------------------------------------------------------------------------------
7BAE  E5              PUSH H            ; odpamtaj prog. ukazate
7BAF  01 7AB3         LXI  B,7AB3       ; adresa reazca s ukonenm povelu
7BB2  21 7BB7         LXI  H,7BB7       ; adresa rutiny pre prpravu dky dt
7BB5  C3 7B70         JMP  7B70         ; ukoni a vykonaj povel


;------------------------------------------------------------------------------
; Rutina pre prpravu dky dt a uloenie dky ako HEXA do povelovho buffra
; pre prkaz @BSTORE.
; Vstup: DE = adresa povelovho buffra
;        (77BC)=dka programu
; Vstup: -
; Men: vetky
;------------------------------------------------------------------------------
7BB8  2A 77BC         LHLD 77BC         ; HL = pripraven dka dt
7BBB  C3 7B02         JMP  7B02


;------------------------------------------------------------------------------
; Rutina pre prpravu dky VIDEO dt a uloenie dky ako HEXA do povelovho
; buffra pre prkaz @GSTORE.
; Vstup: DE = adresa povelovho buffra
; Vstup: (77BC)=dka programu
; Men: vetky
;------------------------------------------------------------------------------
7BBE  21 2E00         LXI  H,2E00       ; 245 mikroriadkov * 48 znakovch
7BC1  C3 7B02         JMP  7B02         ; stlpcov + 16 bytov z 246. mikroriadku


;------------------------------------------------------------------------------
; Rutina pre vyhodnotenie sla njdenho zznamu.
; Vstup: DE=adresa premennej, do ktorej sa prirad slo njdenho zznamu
;------------------------------------------------------------------------------
7BC4  21 5EF1         LXI  H,5EF1       ; adresa kam sa prjmu dta
7BC7  CD 20EB         CALL 20EB         ; prjmi dta zo zbernice
7BCA  23              INX  H            ; posu ukazate na za. prijatch dt
7BCB  CD 06AD         CALL 06AD         ; prira dta (hodnotu) do premennej
7BCE  C3 780B         JMP  780B         ; pokrauj pretanim kdu chyby


;------------------------------------------------------------------------------
; Vstupn rutina pre kanl 406 - negovan vstup
;------------------------------------------------------------------------------
7BD1  2F              CMA               ; neguj posielan byte
7BD2  C3 20CD         JMP  20CD         ; a poli na vstup cez kanl 403


;------------------------------------------------------------------------------
; Adresa tlaovho buffra.
;------------------------------------------------------------------------------
7BD5  5ED7            DW   5ED7

;------------------------------------------------------------------------------
; Priprav 4 estice pod sebou do tlaovho buffra.
; 4 body nad sebou ulo zdvojene do 1 bytu.
; Celkom sa teda do tlaovho buffra priprav 6 bytov.
; Vstup: HL=adresa vo VIDEORAM
;        DE=0040 - posun na al mikroriadok
;        (7BD5)=adresa tlaovho buffra
; Vstup: pripraven dta v tlaovom buffri
; Men: AF, (7BD5)
;------------------------------------------------------------------------------
7BD7  C5              PUSH B            ; odpamtaj potadlo stpcov, riadkov
7BD8  3E 0E           MVI  A,0E         ; ni byte rutiny pre rotovanie
7BDA  32 7BE2         STA  7BE2         ; estice bodov.
7BDD  E5              PUSH H            ; odpamtaj adresu do VIDEORAM
7BDE  06 04           MVI  B,04         ; 4 body nad sebou
7BE0  7E              MOV  A,M          ; vezmi byte z VIDEORAM
7BE1  CD 7C0E      >> CALL 7C0E         ; odrotuj si prisln bod do CY
7BE4  F5              PUSH PSW          ; odpamtaj si stav bodu
7BE5  79              MOV  A,C
7BE6  17              RAL               ; zarotuj do cieovho bytu
7BE7  4F              MOV  C,A
7BE8  F1              POP  PSW          ; obnov si stav bodu
7BE9  79              MOV  A,C
7BEA  17              RAL               ; a zarotuj op (dvojit vka)
7BEB  4F              MOV  C,A
7BEC  19              DAD  D            ; posu sa na al mikroriadok
7BED  05              DCR  B            ; zn potadlo bodov
7BEE  C2 7BE0         JNZ  7BE0         ; opakuj pre vetky
7BF1  2A 7BD5         LHLD 7BD5         ; HL=cieov buffer
7BF4  71              MOV  M,C          ; ulo vytvoren byte
7BF5  23              INX  H            ; posu ukazate do cieovho buffra
7BF6  22 7BD5         SHLD 7BD5         ; ulo ukazate
7BF9  2A 7BE2         LHLD 7BE2         ; HL=adresa rutiny pre rotovanie bytu
7BFC  2B              DCX  H            ; zn adresu pre zvenie potu rotci
7BFD  22 7BE2         SHLD 7BE2         ; ulo adresu
7C00  7E              MOV  A,M          ; test, i sa spracovalo vetkch
7C01  B7              ORA  A            ; 6 bitov - sme na adrese 7C08?
7C02  E1              POP  H            ; obnov adresu VIDEORAM
7C03  C2 7BDD         JNZ  7BDD         ; pokrauj pre kad zo iestich bitov
7C06  C1              POP  B            ; obnov potadlo stpcov, riadkov
7C07  C9              RET

;------------------------------------------------------------------------------
; Rutina pre rotovanie hytu.
; Postupne je volan od adresy 7C0E, 7C0D, 7C0C, 7C0B, 7C0A a 7C09 pre kad
; bit z bytu.
; Vstup: A=byte z VIDEORAM
; Vstup: CY=prisln bit z bytu
; Men: AF
;------------------------------------------------------------------------------
7C08  00              NOP
7C09  0F              RRC               ; 6x
7C0A  0F              RRC               ; 5x
7C0B  0F              RRC               ; 4x
7C0C  0F              RRC               ; 3x
7C0D  0F              RRC               ; 2x
7C0E  0F              RRC               ; 1x
7C0F  C9              RET


;------------------------------------------------------------------------------
; Rutina odole byte do tlaiarne.
; Vstup: HL=adresa dt
; Vstup: -
; Men: AF
;------------------------------------------------------------------------------
7C10  DB 4E           IN   4E           ; test na pripravenos tlaiarne
7C12  E6 08           ANI  08
7C14  CA 7C10         JZ   7C10         ; akaj, km bude pripraven
7C17  7E              MOV  A,M          ; vezmi byte
7C18  2F              CMA               ; invertuj
7C19  D3 4C           OUT  4C           ; poli do tlaiarne
7C1B  C9              RET

;------------------------------------------------------------------------------
; Escape kd pre nastavenie 6 liniek na palec - pre znakov tla.
; ESC & l 6 D         -> 6 lines per inch
;------------------------------------------------------------------------------
7C1C  1B 26 6C 36     DB   1B,26,6C,36
7C20  44 0A           DB   44,0A

7C22  FFFF            DW   FFFF

;------------------------------------------------------------------------------
; Prkaz: @COPY
; * Kopia VIDEORAM 2x2 na tlaiarni. Netla sa dialgov riadok, tla sa teda
;   celkom 244 mikroriadkov.
;   Pouvaj sa Escape kdy poda protokolu Hewlet-Packard.
;------------------------------------------------------------------------------
7C24  E5              PUSH H            ; odpamtaj prog. ukazate
7C25  21 C000         LXI  H,C000       ; adresa VIDEORAM
7C28  3E A0           MVI  A,A0         ; inicializcia GPIO - SK A: MOD1 PA=OUT
7C2A  D3 4F           OUT  4F           ;   SK B: PB=OUT, PC03=OUT
7C2C  3E 0D           MVI  A,0D         ; 1->PC6
7C2E  D3 4F           OUT  4F
7C30  0E 3D           MVI  C,3D         ; 61 x 4 mikroriadkov = 244
7C32  11 0040         LXI  D,0040       ; 64 - offset medzi mikroriadkami
7C35  06 30           MVI  B,30         ; 48 znakovch stlpcov
7C37  CD 7BD7         CALL 7BD7         ; priprav 4 mikror. jednho zn. stpca
7C3A  05              DCR  B            ; zn poet stlpcov
7C3B  23              INX  H            ; posu sa na al
7C3C  C2 7C37         JNZ  7C37         ; opakuj pre vetky stlpce
7C3F  00              NOP
7C40  00              NOP
7C41  E5              PUSH H            ; odpamtaj adresu VIDEORAM
7C42  CD 7C7E         CALL 7C7E         ; inicializuj grafick reim tlaiarne
7C45  21 5ED7         LXI  H,5ED7       ; adresa tlaovho buffra
7C48  22 7BD5         SHLD 7BD5         ; ulo
7C4B  CD 7C10         CALL 7C10         ; odoli byte z buffra do tlaiarne
7C4E  CD 7C10         CALL 7C10         ; a ete raz (dvojit rka)
7C51  23              INX  H            ; posu ukazate
7C52  7C              MOV  A,H          ; odoslal sa cel buffer ?
7C53  FE 5F           CPI  5F           ; (5ED7H + 48 * 6 = 5FF7H)
7C55  C2 7C4B         JNZ  7C4B
7C58  7D              MOV  A,L
7C59  FE F7           CPI  F7
7C5B  C2 7C4B         JNZ  7C4B         ; opakuj pre cel buffer
7C5E  21 7C7D         LXI  H,7C7D       ; odriadkuj - LF
7C61  CD 7C10         CALL 7C10
7C64  E1              POP  H            ; obnov adresu VIDEORAM
7C65  19              DAD  D            ; posu sa o tyri mikroriadky dolu
7C66  19              DAD  D
7C67  19              DAD  D
7C68  19              DAD  D
7C69  2E 00           MVI  L,00         ; posun na zaiatok riadku
7C6B  CD 8C74         CALL 8C74         ; otestuj STOP-ku
7C6E  C3 7C8C         JMP  7C8C         ; sko dalej

;------------------------------------------------------------------------------
; Escape kd pre nastavenie 9 liniek na palec - pre grafick tla.
; ESC & l 9 D         -> 9 lines per inch
;------------------------------------------------------------------------------
7C71  1B 26 6C 39     DB   1B,26,6C,39
7C75  44              DB   44

;------------------------------------------------------------------------------
; Escape kd pre nastavenie grafickej tlae - 576 grafickch dt (bytov).
; - 2 nsobn rka - 48 * 6 * 2 = 576
; ESC * b 5 7 6 G     -> 576 grafickch dt
;------------------------------------------------------------------------------
7C76  1B 2A 62 35     DB   1B,2A,62,35
7C79  37 36 47        DB   37,36,47
7C7D  0A              DB   0A

;------------------------------------------------------------------------------
; Rutina pre nastavenie grafickej tlae.
; Vstup: -
; Vstup: -
; Men: AF, HL
;------------------------------------------------------------------------------
7C7E  21 7C71         LXI  H,7C71       ; adresa ESC sekvencie

;------------------------------------------------------------------------------
; Rutina pre odoslanie Escape sekvencie.
; Vstup: HL=adresa escape sekvencie
; Vstup: -
; Men: AF, HL
;------------------------------------------------------------------------------
7C81  CD 7C10         CALL 7C10         ; odoli byte
7C84  23              INX  H            ; posu sa na al
7C85  7E              MOV  A,M          ; je to koniec ESC sekvencie ?
7C86  FE 0A           CPI  0A
7C88  C2 7C81         JNZ  7C81         ; nie, opakuj
7C8B  C9              RET

;------------------------------------------------------------------------------
; Pokraovanie prkazu @COPY.
;------------------------------------------------------------------------------
7C8C  CA 7C93         JZ   7C93         ; po stlaen STOP, ukoni prkaz
7C8F  0D              DCR  C            ; zn potadlo stvorc mikroriadkov
7C90  C2 7C35         JNZ  7C35         ; opakuj pre vetky
7C93  21 7C1C         LXI  H,7C1C       ; nastav riadkovanie pre znakov tla
7C96  CD 7C81         CALL 7C81
7C99  E1              POP  H            ; obnov prog. ukazate
7C9A  C9              RET


;------------------------------------------------------------------------------
; Prkaz: @ON ERROR prkazy
; * Nastavenie odchytvania diskovej chyby.
;------------------------------------------------------------------------------
7C9B  E5              PUSH H            ; odpamtaj prog. ukazate a ulo ho ako
7C9C  22 79FF         SHLD 79FF         ; adr. prk., kt. sa pri chybe vykonaj
7C9F  21 7CB6         LXI  H,7CB6       ; adresa rutiny pre obsluhu chyby
7CA2  22 7825         SHLD 7825
7CA5  E1              POP  H            ; obnov prog. ukazate
7CA6  7E              MOV  A,M          ; njdi koniec riadku
7CA7  B7              ORA  A
7CA8  C8              RZ                ; a vr sa do interpretera
7CA9  23              INX  H
7CAA  C3 7CA6         JMP  7CA6

;------------------------------------------------------------------------------
; Prkaz: @OFF ERROR
; * Zru odchytvanie diskovej chyby.
;------------------------------------------------------------------------------
7CAD  E5              PUSH H            ; odpamtaj prog. ukazate
7CAE  21 8A89         LXI  H,8A89       ; nastav adresu pre zobrazenie diskovej
7CB1  22 7825         SHLD 7825         ; chyby
7CB4  E1              POP  H            ; obnov prog. ukazate
7CB5  C9              RET

;------------------------------------------------------------------------------
; Obsluha odchytenia chyby.
;------------------------------------------------------------------------------
7CB6  E1              POP  H            ; zaho nepotrebn hodnoty na zsobnku
7CB7  E1              POP  H
7CB8  E1              POP  H
7CB9  21 787D         LXI  H,787D       ; text chyby "ERR = xxx"
7CBC  CD 0B07         CALL 0B07         ; analza premennej "ER"
7CBF  23              INX  H            ; posu prog. ukazate
7CC0  CD 06AD         CALL 06AD         ; priradenie kdu chyby do premennej ER
7CC3  2A 79FF         LHLD 79FF         ; adresa prkazov pre obsluhu chyby
7CC6  2B              DCX  H            ; posu prog. ukazate nasp
7CC7  C3 04C6         JMP  04C6         ; a vykonaj ON ERROR prkazy


;------------------------------------------------------------------------------
; Prkaz: POKE adr,byte [,byte ...]
; * Zpis viacerch bytov do pamti (rozrenie pvodnho prkazu).
;------------------------------------------------------------------------------
7CCA  D1              POP  D            ; ukladacia adresa do DE
7CCB  12              STAX D            ; ulo byte
7CCC  CD 0076         CALL 0076         ; test na koniec prkazu
7CCF  C8              RZ                ; je to koniec prkazu, vr sa
7CD0  13              INX  D            ; posu sa na aliu adresu
7CD1  C3 0EFB         JMP  0EFB         ; vyhodno al vraz ako byte


;------------------------------------------------------------------------------
; Funkcia TAB(X, Y)
; * "Tabultor" pre presn umiestnenie textovho kurzora.
;------------------------------------------------------------------------------
7CD4  23              INX  H            ; posu prog. ukazate
7CD5  CD 1CE3         CALL 1CE3         ; vyhodno vrazy X a Y
7CD8  E5              PUSH H            ; odpamtaj prog. ukazate
7CD9  2A C17A         LHLD C17A         ; vezmi vypotan adr. obrazovky
7CDC  22 C03E         SHLD C03E         ; ulo ako pozciu PRINT kurzora
7CDF  E1              POP  H            ; obnov prog. ukazate
7CE0  CD 006D         CALL 006D         ; mus nasledova prav ztvorka
7CE3  29              DB   ')'
7CE4  C3 074E         JMP  074E         ; nvrat do PRINT rutiny


;------------------------------------------------------------------------------
; Prkaz: CODE [ (B,C) ] A$ [,A$ ...]
; * Vykonvanie reazcov ako binrny podprogram.
; Ak za prkazom nasleduje av ztvorka, povauje sa to za nov syntax, inak
; sa ske rovno do pvodnej exekutvy.
;------------------------------------------------------------------------------
7CE7  E5              PUSH H            ; odpamtaj prog. ukazate
7CE8  21 7F00         LXI  H,7F00       ; nastav pvodne parametre prkazu CODE
7CEB  22 22E7         SHLD 22E7
7CEE  22 22F8         SHLD 22F8
7CF1  E1              POP  H            ; obnov prog. ukazate
7CF2  CD 0076         CALL 0076         ; vezmi aktulny znak z programu
7CF5  FE 28           CPI  '('          ; je to lva ztvorka ?
7CF7  C2 22D5         JNZ  22D5         ; nie, je to klasick pouitie, sko
7CFA  23              INX  H            ; posu ukazate v programe
7CFB  CD 7D16         CALL 7D16         ; prevezmi parameter B - ukladacia adr.
7CFE  EB              XCHG
7CFF  22 22E7         SHLD 22E7         ; ulo
7D02  EB              XCHG
7D03  CD 006D         CALL 006D         ; mus nasledova iarka
7D06  2C              DB   ','
7D07  CD 7D16         CALL 7D16         ; prevezmi parameter C - adresa skoku
7D0A  EB              XCHG
7D0B  22 22F8         SHLD 22F8         ; ulo
7D0E  EB              XCHG
7D0F  CD 006D         CALL 006D         ; mus nasledova prav ztvorka
7D12  29              DB   ')'
7D13  C3 22D5         JMP  22D5         ; spracuj zbytok prkazu CODE


;------------------------------------------------------------------------------
; Rutina prevezme 16 bitov integer (vraz) z programovho riadku.
; Pri chybe vo vraze (napr. to nie je slo), sa interne ske rovno na
; chybov hlku.
; Vstup: HL=programov ta
; Vstup: DE=vsledn hodnota vrazu
;------------------------------------------------------------------------------
7D16  CD 0933         CALL 0933         ; spracuj vraz
7D19  C3 05C3         JMP  05C3         ; preve hodnotu do DE


;------------------------------------------------------------------------------
; Funkcia: POS premenn
; * Zskanie adresy premennej.
;------------------------------------------------------------------------------
7D1C  CD 0075         CALL 0075         ; posu sa v progr. riadku
7D1F  CD 0B07         CALL 0B07         ; analyzuj premenn, DE=adresa prem.
7D22  4B              MOV  C,E          ; DE ulo do A:C
7D23  7A              MOV  A,D
7D24  22 5E74         SHLD 5E74         ; odpamtaj prog. ukazate
7D27  CD 0CBB         CALL 0CBB         ; spracuj hodnotu funkcie
7D2A  C1              POP  B            ; zaho pvodn nvratov adresu
7D2B  C3 0955         JMP  0955         ; a vr sa do interpretera


;------------------------------------------------------------------------------
; Funkcia : DEEK adr
; adr moe by vraz
; * tanie z pamti - 16 bit
;------------------------------------------------------------------------------
7D2E  CD 0075         CALL 0075         ; posu sa v progr. riadku
7D31  CD 7D16         CALL 7D16         ; prevezmi 16 bit INT - DE=adresa
7D34  1A              LDAX D            ; a hodnotu z adresy DE ulo do A:C
7D35  4F              MOV  C,A
7D36  13              INX  D
7D37  1A              LDAX D
7D38  C3 7D24         JMP  7D24         ; sko ukoni funkciu


;------------------------------------------------------------------------------
; Rozskok na funkcie DEEK, POS a @
;------------------------------------------------------------------------------
7D3B  FE 97           CPI  97           ; je to funkcia DEEK ?
7D3D  CA 7D2E         JZ   7D2E         ; no vykonaj funkciu
7D40  FE B4           CPI  B4           ; je to funkcia POS ?
7D42  CA 7D1C         JZ   7D1C         ; no vykonaj funkciu
7D45  FE E2           CPI  E2           ; je to funkcia @ ?
7D47  CA 7D75         JZ   7D75         ; no vykonaj funkciu
7D4A  C3 09F3         JMP  09F3         ; test na alie funkcie


;------------------------------------------------------------------------------
; Prkaz: @DOKE adr,val
; adr a val mu by vrazy
; * Zapis do pamti - 16 bit.
;------------------------------------------------------------------------------
7D4D  CD 7D16         CALL 7D16         ; prevezmi 16 bit INT - DE=adresa
7D50  D5              PUSH D            ; adresu na zsobnk
7D51  CD 006D         CALL 006D         ; mus nasledova iarka
7D54  2C              DB   ','
7D55  CD 7D16         CALL 7D16         ; prevezmi 16 bit INT - DE=hodnota

; 7 intrukci od 7D58 do 7D5E sa dali napsa zrozumitenejie a kratie
;                     XTHL              ; odpamtaj prog. ukazate, HL=adresa
;                     MOV  M,E          ; ulo ni byte
;                     INX  H            ; posu adresu
;                     MOV  M,D          ; ulo vy byte
;                     POP  H            ; obnov prog. ukazate

7D58  42              MOV  B,D          ; odpamtaj hodnotu do A:B
7D59  7B              MOV  A,E
7D5A  D1              POP  D            ; obnov adresu
7D5B  12              STAX D            ; a na u ulo ni byte
7D5C  13              INX  D
7D5D  78              MOV  A,B
7D5E  12              STAX D            ; a vyi byte
7D5F  C9              RET


;------------------------------------------------------------------------------
; Prkaz: @BUF=adr,len
; adr a len mu by vrazy
; * Definovanie buffra.
;------------------------------------------------------------------------------
7D60  CD 7D16         CALL 7D16         ; prevezmi 16 bit INT - DE=adresa
7D63  EB              XCHG
7D64  22 77BE         SHLD 77BE         ; nastav nov adresu buffra
7D67  EB              XCHG
7D68  CD 006D         CALL 006D         ; mus nasledova iarka
7D6B  2C              DB   ','
7D6C  CD 7D16         CALL 7D16         ; prevezmi 16 bit INT - DE=dka
7D6F  EB              XCHG
7D70  22 77BC         SHLD 77BC         ; nastav dku buffra
7D73  EB              XCHG
7D74  C9              RET


;------------------------------------------------------------------------------
; Funkcia: @XXXX
; * Prevod HEXA -> DEC
;------------------------------------------------------------------------------
7D75  23              INX  H            ; posun za prv hexa znak
7D76  CD 8109         CALL 8109         ; preve tvoricu HEXA znakov na slo
7D79  DA 093D         JC   093D         ; chyba: TYPE CONV.
7D7C  C3 7D22         JMP  7D22         ; ukoni funkciu


;------------------------------------------------------------------------------
; Prkaz: @EXEC A$ [ , A$ ]
; * Vykonvanie reazcov ako BASIC prkazy.
;------------------------------------------------------------------------------
7D7F  F1              POP  PSW          ; zaho nvratov adresu
7D80  CD 0076         CALL 0076         ; presko medzery v prkaze
7D83  CD 78F4         CALL 78F4         ; spracuj reazec za prkazom
7D86  E5              PUSH H            ; odpamtaj prog. ukazate
7D87  AF              XRA  A            ; ukoni reazec (poadovan prkaz) 00
7D88  12              STAX D
7D89  11 5EF1         LXI  D,5EF1       ; adresa reazca s prkazom
7D8C  D5              PUSH D
7D8D  E1              POP  H            ; ulo do HL
7D8E  E5              PUSH H            ; aj na zsobnk
7D8F  CD 022D         CALL 022D         ; preve prkaz do vntornho kdu
7D92  E1              POP  H            ; obnov adresu prkazu
7D93  7E              MOV  A,M          ; prv byte prkazu
7D94  CD 04CE         CALL 04CE         ; vykonaj prkaz
7D97  E1              POP  H            ; obnov pvodn prog. ukazate
7D98  CD 0500         CALL 0500         ; otestuj klvesu STOP
7D9B  22 5E72         SHLD 5E72         ; ulo prog. ukazate
7D9E  7E              MOV  A,M          ; test, ci pokrauje al reazec
7D9F  FE 2C           CPI  ','          ; je tam iarka ?
7DA1  23              INX  H            ; posu prog. ukazate
7DA2  CA 7D80         JZ   7D80         ; ak pokrauje al reazec, spracuj ho
7DA5  2B              DCX  H            ; posu prog. ukazate nazad
7DA6  C3 04A9         JMP  04A9         ; a pokrauj v normalnom programe


;------------------------------------------------------------------------------
; Prkaz: @SEARCH# A, X, Y, Z; vraz
; Povel m tvar: HH#aaaa$xxxx@yyyy
; * Vyhadvanie v dtovom sbore s slom A, od zznamu X, vraz dky Y.
;   Njden slo zznamu sa ulo do premennej Z.
; Ak sa ako Z uvedie reazcov premenn, t bude obsahova "nezmyseln" reazec
; a jeho pouitie me spsobi nepredvdaten sprvanie.
;------------------------------------------------------------------------------
7DA9  E5              PUSH H            ; odpamtaj prog. ukazate
7DAA  21 79EC         LXI  H,79EC       ; adresa rutiny pre odoslanie dt
7DAD  22 78EF         SHLD 78EF         ; ulo adresu rutiny
7DB0  21 7DD3         LXI  H,7DD3       ; adresa rutiny pre prjem dt
7DB3  22 7897         SHLD 7897         ; ulo adresu rutiny
7DB6  E1              POP  H            ; obnov prog. ukazate
7DB7  01 4823         LXI  B,4823       ; 'H' - kd povelu, '#' - slo sboru
7DBA  CD 7A1F         CALL 7A1F         ; priprav povelov buffer a slo sboru
7DBD  23              INX  H            ; posu prog. ukazate
7DBE  CD 7957         CALL 7957         ; vyhodno a ulo slo zznamu
7DC1  23              INX  H            ; posu prog. ukazate
7DC2  CD 79A8         CALL 79A8         ; spracuj dku jednho zznamu
7DC5  23              INX  H            ; posu prog. ukazate
7DC6  01 7A02         LXI  B,7A02       ; adresa CRLF
7DC9  CD 794D         CALL 794D         ; ukoni povel
7DCC  CD 0B07         CALL 0B07         ; analyzuj premenn
7DCF  D5              PUSH D            ; odpamtaj adresu premennej
7DD0  C3 79E5         JMP  79E5         ; vykonaj povel/prkaz

;------------------------------------------------------------------------------
; Rutina pre vyhodnotenie sla njdenho zznamu.
;------------------------------------------------------------------------------
7DD3  C1              POP  B            ; zaho nvratov adresu
7DD4  E1              POP  H            ; HL=prog. ukazate
7DD5  D1              POP  D            ; DE=adresa premennej
7DD6  E5              PUSH H            ; odpamtaj znovu prog. ukazate
7DD7  C3 7BC4         JMP  7BC4         ; sko dalej


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
7DDA  FF              DB   FF

;------------------------------------------------------------------------------
; Rutina vykon zbytok inicializcie ERB.
;------------------------------------------------------------------------------
7DDB  21 7CCA         LXI  H,7CCA       ; modifikcia prkazu POKE
7DDE  22 0F04         SHLD 0F04
7DE1  21 7CD4         LXI  H,7CD4       ; modifikcia funkcie TAB()
7DE4  22 0758         SHLD 0758
7DE7  21 7CE7         LXI  H,7CE7       ; modifikcia prkazu CODE
7DEA  22 19F4         SHLD 19F4
7DED  21 45C4         LXI  H,45C4       ; nov funkcia DEEK - znaky 'DE'
7DF0  22 1A52         SHLD 1A52
7DF3  21 4B45         LXI  H,4B45       ; znaky 'EK'
7DF6  22 1A54         SHLD 1A54
7DF9  21 7D3B         LXI  H,7D3B       ; obsluha DEEK, POS a @
7DFC  22 22B7         SHLD 22B7
7DFF  C9              RET
