;------------------------------------------------------------------------------
; Disassembling a komentar Roman Borik - 14 Oct 2007 (Revizia 2)
;------------------------------------------------------------------------------
;
;          ********************************************************
;          * Ovladaci program disketovej jednotky PMD 30 (MFD-85) *
;          ********************************************************
;
; PMD 30 je disketova jednotka s jednou 5,25" mechanikou.
; Je riadena mikroprocesorom 8080A s vlastnym riadiacim programom - operacnym
; systemom MFS (Management File System) - o velkosti 4 kB.
; Pamat RAM o velkosti 1kB sluzi ako operacna pamat mikroprocesora a vyrovnava-
; cia pamat pre prenos dat medzi PMD 30 a nadradenym pocitacom. Cast pamati RAM
; o velkosti 256 bytov je volna pre uzivatela.
; Zakladne diskove sluzby su vykonavane obvodom FDC 8271. Format diskety je 40
; stop, 18 sektorov na stopu, velkost sektora 128 bytov, jednostranne. Sposob
; zaznamu na diskete je FM podla normy IBM 3740.
; PMD 30 komunikuje s nadradenym pocitacom prostrednictvom zbernice IMS-2.
; Nadradeny pocitac posiela povely do PMD 30 v podobe COMMAND "slova", na ktore
; MFS odpoveda vyslanim STATUS slova. Podla neho sa nadradeny pocitac dozvie, ci
; bol povel vykonany bez chyb, resp. ci bude nasledovat operacia transferu dat.
; Na zbernici moze byt pripojenych max. 15 PMD 30 (jedna jednotka spotrebuje
; dve adresy: A (registre COMMAND a STATUS) a A+16 (registre DATA READ/WRITE)).
; Adresa jednotky v rozsahu 0 az 14 sa nastavuje prepojkami na DPS. Prepojkami
; mozno nastavit aj normalne platnu adresu 15, ta je vsak v tomto pripade
; nepripustna, kedze zvysena o 16 uz koliduje so stykovymi spravami UNL (3Fh)
; a UNT (5Fh).
; PMD 30 moze pracovat v dvoch rezimoch:
; - MASTER - kedy nepotrebuje ziadne prikazy od nadradeneho systemu a jej
;            cinnost je riadena autonomne na zaklade vykonavania programu zo
;            systemovej diskety. V tomto pripade moze PMD 30 zastavat na IMS-2
;            zbernici funkciu CONTROLLERa a na jej zbernicu mozu byt pripojene
;            dalsie zariadenia so zberniciu IMS-2 (aj ina PMD 30 v rezime SLAVE)
; - SLAVE  - kedy ocakava od nadradeneho systemu (moze to byt aj ina jednotka
;            PMD 30 v rezime MASTER) povely pre vykonavanie diskovej sluzby.
; Rezim PMD 30 sa nastavuje na DPS dratenou prepojkou. Nastaveny rezim sa
; testuje iba po resete, softverovom alebo hardvarovom. Zmena rezimu je mozna
; aj softverovo, zavolanim prislusnych rutin.
;
; Disketova jednotka PMD 30 je zjednodusenou variantou svojej "starsej sestry",
; disketovej jednotky MFD-85. MFD-85 sa lisi od PMD 30 v tychto detailoch:
; - RAM ma velkost 2 kB, takze pre uzivatela je volnych 1,25 kB
; - nastavenie IMS-2 adresy jednotky a rezimu MASTER/SLAVE sa nastavuje DIL
;   prepinacmi, ktore su umiestnene na zadnej strane MFD-85
; - ma vyvedenu lokalnu systemovu zbernicu, takze je ju mozne pripojit priamo
;   na aplikacny konektor pocitaca a pouzivat napr. ako disketovu jednotku
;   pre operacny system CP/M
; Po softwarovej stranke su PMD 30 a MFD-85 identicke, takze nasledujuci
; komentovany vypis plati pre obe disketove jednotky.
;
;
;------------------------------------------------------------------------------
; ** MFS - Management File system **
;
; Jedinym spravcom naformatovanej diskety (jedna strana, 40 stop, 18 sektorov
; na stranu, 128 bytov na sektor) je operacny system MFS.
; MFS ma vytvorene tzv. rozmiestnovacie jednotky (RJ) o velkosti 1 kB, t.j. 8
; sektorov. Vsetky sektory su chapane ako postupnost tychto RJ. Celkovo sa na
; diskete nachadza 89 RJ. Obsadenost RJ eviduje MFS na kazdej diskete a to na
; stope 0, sektor 1. Pridelovanie RJ suboru dat popripade binarnym programom je
; evidovane v katalogu diskety, ktory zabera celkom necele dve RJ od sektora 2
; po sektor 16 na stope 0. Katalog diskety patri medzi nejdolezitejsiu cast
; diskety, pretoze operacny system MFS pristupuje k pozadovanym datam
; prostrednictvom jeho informacii. Kapacita katalogu je 59 vstupov (zaznamov).
; Dlzka jedneho zaznamu v katalogu je konstantna v rozsahu 32 byte.
; Po formate diskety sa vytvori alokacna mapa RJ a katalog diskety.
; Zaroven sa v alokacnej mape oznacia dve RJ ako obsadene - su obsadene samotnou
; alokacnou mapou a katalogom. Po formate ma disketa kapacitu 87 kB.
;
; Jeden zaznam katalogu:
; -------------------------------------------------------------------
; Offset | vyznam
; -------------------------------------------------------------------
; 0      | 00/FF - neutajeny/utajeny subor v katalogu
; 1 - 8  | nazov suboru
; 9      | typ suboru - 'D' - datovy
;        |              'E' - vymazany
;        |              'P' - program
;        |              'B' - binarny
;        |              'G' - graficky
;        |              FF  - NEXT - subor ma dalsi vstup v katalogu
;        |              00  - END - koniec suboru
; 10,11  | 0000 - nevyuzite
; 12     | pocet RJ
; 13,14  | pocet zaznamov / dlzka binarneho suboru
; 15     | velkost zaznamu
; 16-31  | zoznam cisel RJ
; -------------------------------------------------------------------

; MFS si neuchovava katalog v operacnej pamati. Pred pracou s datovym suborom
; je potrebne ho otvorit (sluzba 'O'). Udaje od 13. pozicie z daneho vstupu sa
; ulozia do OPEN BUFFERa (adresa 18E0). Celkovo mozno otvorit az 8 suborov (0
; az 7). Pri praci s danym zaznamom v subore sa operacny system MFS obracia na
; OPEN BUFFER.
;
; Jeden vstup v OPEN BUFFERi:
; -------------------------------------------------------------------
; Offset | vyznam
; -------------------------------------------------------------------
; 0      | 00/FF - zatvoreny/otvoreny subor
; 1,2    | pocet zaznamov
; 3      | dlzka jedneho zaznamu
; 4-19   | zoznam cisel RJ
; -------------------------------------------------------------------

; MFS poskytuje/vykonava celkom 19 sluzieb/povelov
;
;   W - zapis na fyzicky sektor
;   R - citanie z fyzickeho sektora
;   P - zapis na logicky sektor (do datoveho suboru)
;   I - citanie z logickeho sektora (z datoveho suboru)
;   C - vytvorenie datoveho suboru
;   U - uzatvorenie suboru
;   F - formatovanie diskety
;   O - otvorenie datoveho suboru
;   G - citanie z operacnej pamati
;   A - uzatvorenie vsetkych suborov
;   J - skok na interpretovanie podprogramu
;   E - vymazanie suboru
;   M - zapis do operacnej pamati
;   D - citanie katalogu (zoznamu suborov na diskete)
;   N - citanie nazvu diskety
;   Z - zapis binarnych dat (suboru)
;   L - citanie binarnych dat (suboru)
;   B - utajenie suboru v katalogu
;   H - vyhladanie slova v datovom subore
;
; Nadradeny system ziada o sluzbu odoslanim COMMAND slova, ktore ma nasledujuci
; format:
;             | sluzba | D/H | parameter | hodnota parametra | ... | OD |
;
; Znak 'D' alebo 'H' urcuje tvar hodnot parametrov - decimalne / hexadecimalne.
;
; Parametre:
;---------------------------------------------------------------------------
; znak | hodnota  | vyznam
;---------------------------------------------------------------------------
;  T   | xx       | nastavenie parametra stopa /TRACK/
;  S   | xx       | nastavenie parametra sektor
;  #   | xx       | presun udajov z katalogu do OPEN BUFFERu - cislo suboru
;  $   | xxxx     | nastavenie cisla zaznamu
;  @   | xx       | nastavenie dlzky zaznamu
;  '   | xxxxxxxx | nazov suboru - max. 8 znakov
;  &   | xxxx     | adresa RAM
;  !   | ziadna   | prevedenie kontroly vsetkych params. v COMMAND slove
;  *   | D        | typ suboru ASCII
;      | B        |            binarny
;      | G        |            graficky
;      | P        |            program BASIC
;---------------------------------------------------------------------------
; xx reprezentuje decimalnu alebo hexadecimalnu hodnotu.
; V pripade parametra apostrof sa jedna o znaky ASCII.

; Tvar COMMAND slov jednotlivych povelov:
------------------------------------------
;  W  D/H  T  x  S  x  @  x  *  x
;  R  D/H  T  x  S  x  @  x  *  x
;  P  D/H  #  x  $  x  !
;  I  D/H  #  x  $  x  !
;  C  D/H  '  x  '  $  x  @  x  *  x
;  U  D/H  #  x
;  F  D/H  '  x  '
;  O  D/H  '  x  '  #  x
;  G  D/H  &  x  @  x
;  A  D/H
;  J  D/H  &  x
;  E  D/H  '  x  '
;  M  D/H  &  x  @  x
;  D  D/H
;  N  D/H
;  Z  D/H  '  x  '  $  x  *  x
;  L  D/H  '  x  '  *  x
;  B  D/H  '  x  '
;  H  D/H  #  x  $  x  @  x
------------------------------------------
; x reprezentuje hodnotu parametra, popripade ASCII znaky v pripade mena suboru.

; Spracovanie COMMAND slova sa vykonava rutinou na adrese 0400. Ta si okrem
; dalsich parametrov odpamatava na adrese 1808 kod sluzby/povelu.
; Vykonanie povelu sa prevadza (podla typu povelu aj opakovane) v rutine EXECUTE
; na adrese 04B9.
; V priebehu vykonavania povelu sa moze menit kod povelu, aby sa rozlisila
; cinnost, ktora sa ma vykonat. Sled povelov/subpovelov:
;
; 'W' 01
; 'R' 01
; 'P' 02
; 'I' 02
; 'C'
; 'U'
; 'F'
; 'O'
; 'G' 05
; 'A'
; 'J'
; 'E'
; 'M' 05
; 'D' 04
; 'N' 05
; 'Z' 03
; 'L' 03
; 'B'
; 'H' 06 05

;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
; Rozdelenie adries periferii v PMD 30 (MFD-85)
; ----------------------------------------------
;
; ** FDC 8271 **
; ---------------
; EC - R/W - status/command register
; ED - R/W - result/parameter register
; BF - R/W - DATA register
;
;
; ** PIO 8255 * IMS-2 zbernica **
; --------------------------------
; DC - R/W - port A -> DIO1 az DIO8
; DD - R/O - port B -> PB0 - DRQ 8271
;                      PB1 - DAV
;                      PB2 - NRFD
;                      PB3 - NDAC
;                      PB4 -
;                      PB5 - ATN
;                      PB6 - REN
;                      PB7 -
; DE - W/O - port C -> PC0 - smer DIO - 0=OUT, 1=IN
;                      PC1 - DAV
;                      PC2 - NRFD
;                      PC3 - NDAC
;                      PC4 -
;                      PC5 - ATN
;                      PC6 - REN
;                      PC7 -
; DF - W/O - riadiaci port
;
;
; ** konfiguracia disketovej jednotky **
; ---------------------------------------
; 1400 - R/O - mapovane do pamatovej oblasti
;            - drotene prepojky na DPS v PMD 30, resp. 8 konfiguracnych DIL
;              prepinacov na MFD-85 (cislovane od 1 do 8)
;            - negativna logika
;
;   8 (7. bit) - rezim cinnosti - 0 = SLAVE, 1 = MASTER
;   7 (6. bit) -
;   6 (5. bit) -
;   5 (4. bit) -
;   4 (3. bit) --\
;   3 (2. bit) -  \  IMS-2 adresa jednotky, teda 0 az 15
;   2 (1. bit) -  /  (adresa 15 sa nesmie pouzit)
;   1 (0. bit) --/
;
;
;------------------------------------------------------------------------------
; Mapa pamati v PMD 30 (MFD-85)
; -------------------------------------
;       |-----------|
;  0000 |           |
;       |   EPROM   |   - firmware
;       |           |
;       | 4 kB MFS  |
;  0FFF |           |
;       |-----------|
;  1000 |           |
;       | nevyuzite |
;  13FF |           |
;       |-----------|
;  1400 | konfigur. |   - IMS-2 adresa jednotky, rezim cinnosti
;       |-----------|
;  1401 |           |
;       | nevyuzite |
;  17FF |           |
;       |-----------|
;  1800 |           |   - systemove premenne MFS
;       | RAM 1 kB  |   - buffre
;  1BFF |           |   - uzivatelska oblast 0,25 kB
;       |-----------|
;  1C00 |           |   - iba MFD-85
;       | RAM 1 kB  |   - uzivatelska oblast 1 kB
;  1FFF |           |
;       |-----------|
;
;------------------------------------------------------------------------------


;------------------------------------------------------------------------------
; Start
;------------------------------------------------------------------------------
0000  31 186F         LXI  SP,186F      ; nastavenie zasobnika
0003  06 11           MVI  B,11         ; prenes 17 bytov "inicializacnych" dat
0005  11 1800         LXI  D,1800       ; do RAM
0008  21 0029         LXI  H,0029       ; zdrojova adresa
000B  CD 05CC         CALL 05CC         ; presun
000E  AF              XRA  A            ; vynuluj aktualny sektor
000F  32 183A         STA  183A
0012  3E 92           MVI  A,92         ; init IMS-2 - vstup
0014  D3 DF           OUT  DF
0016  CD 0728         CALL 0728         ; precitaj FDC STATUS
0019  CD 0843         CALL 0843         ; inic. FDC a vynuluj OPEN buffer
001C  3A 1400         LDA  1400         ; precitaj konfiguraciu jednotky
001F  17              RAL               ; a zisti zvoleny rezim
0020  DA 0C00         JC   0C00         ; rezim SLAVE
0023  C3 0953         JMP  0953         ; rezim MASTER


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0026  FF FF FF        DB   FF,FF,FF


;------------------------------------------------------------------------------
; Nasledujuce data su pri inicializacii kopirovane do RAM od adresy 1800
;------------------------------------------------------------------------------
0029  00 00 00 8B     DB   00,00,00,8B
002D  07 01 D9 00     DB   07,01,D9,00
0031  00 00 00 80     DB   00,00,00,80
0035  19 00 1A        DB   19,00,1A


;------------------------------------------------------------------------------
; Vstupny bod prerusenia.
; Prerusenie je vyvolavane FDC po skonceni FDC povelu.
;------------------------------------------------------------------------------
0038  C3 073E         JMP  073E         ; skoc na obsluhu prerusenia


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
003B  FF FF FF FF     DB   FF,FF,FF,FF
003F  FF              DB   FF


;------------------------------------------------------------------------------
; Povel 03 - binarne citanie/zapis
; Binarne subory sa spracovavaju po 128 bytovych blokoch. Z posledneho bloku sa
; spracuva len potrebna cast.
; Vstup: (1820) = zostavajuca velkost binarnych dat pre transfer
;        (183B) = pocitadlo logickych sektorov
; Vystup: (1822) = velkost bloku, ktory sa ma preniest
;         precitany/zapisany blok dat
; Meni: vsetky
;------------------------------------------------------------------------------
0040  01 0080         LXI  B,0080       ; BC = 128
0043  2A 1820         LHLD 1820         ; HL = velkost binarneho suboru
0046  CD 0252         CALL 0252         ; porovnaj BC a HL
0049  DA 0053         JC   0053         ; ak HL > BC, skoc
004C  7D              MOV  A,L          ; zostavajuca cast suboru
004D  32 1822         STA  1822
0050  C3 016C         JMP  016C         ; precitaj/zapis sektor

0053  79              MOV  A,C          ; 128 bytovy blok
0054  32 1822         STA  1822
0057  11 FF80         LXI  D,FF80       ; DE = -128
005A  19              DAD  D            ; zniz zostavajucu velkost
005B  22 1820         SHLD 1820         ; a uloz
005E  2A 183B         LHLD 183B         ; zvys pocitadlo logickych sektorov
0061  23              INX  H
0062  22 183B         SHLD 183B
0065  C3 180F         JMP  180F         ; precitaj/zapis sektor


;------------------------------------------------------------------------------
; Obsluha 'E' - vymazanie z katalogu - pokracovanie
;------------------------------------------------------------------------------
0068  D2 05B4         JNC  05B4         ; 12 - chyba nazvu suboru al. duplicita
006B  C0              RNZ               ; pri chybe sa vrat
006C  CD 01F4         CALL 01F4         ; vyhladaj subor
006F  C0              RNZ               ; pri chybe sa vrat
0070  D2 0084         JNC  0084         ; nie je dalsia hlavicka, skoc dopredu
0073  06 09           MVI  B,09         ; vymaz meno suboru
0075  36 20           MVI  M,20
0077  23              INX  H
0078  05              DCR  B
0079  C2 0075         JNZ  0075
007C  36 45           MVI  M,45         ; nastav typ 'E' - zmazany subor
007E  CD 0575         CALL 0575         ; zapis sektor
0081  C3 006B         JMP  006B         ; skus najst dalsiu hlavicku

0084  21 0100         LXI  H,0100       ; stopa=0, sektor=1 - alokacna mapa
0087  22 1825         SHLD 1825         ; uloz
008A  21 1A00         LXI  H,1A00       ; cielova adresa
008D  CD 032A         CALL 032A         ; precitaj sektor
0090  C0              RNZ               ; vrat sa pri chybe
0091  3A 1827         LDA  1827         ; pocet RJ
0094  47              MOV  B,A          ; do B
0095  26 1A           MVI  H,1A         ; horny byte alokacnej mapy
0097  11 1870         LXI  D,1870       ; zoznam RJ, ktore boli suboru pridelene
009A  1A              LDAX D            ; vezmi cislo RJ
009B  13              INX  D            ; posun ukazatel
009C  6F              MOV  L,A          ; offset do alokacnej mapy
009D  36 00           MVI  M,00         ; uvolni RJ
009F  05              DCR  B            ; zniz pocet RJ
00A0  C2 009A         JNZ  009A         ; opakuj pre vsetky RJ
00A3  C3 0387         JMP  0387         ; skoc zapisat alokacnu mapu


;------------------------------------------------------------------------------
; Rutina vypocita cislo fyzickej stopy a sektora, kde sa nachadzaju data, resp.
; kam sa ma zapisovat.
; Vstup: (183B) = poradove cislo logickeho sektora
;        (1870) = zoznam RJ
; Vystup: (1825) = stopa a sektor, kde sa zaznam nachadza
; Meni: vsetky
;------------------------------------------------------------------------------
00A6  2A 183B         LHLD 183B         ; poradove cislo logickeho sektora
00A9  7D              MOV  A,L          ; vypocitaj offset logickeho
00AA  E6 07           ANI  07           ; sektora v RJ
00AC  4F              MOV  C,A
00AD  29              DAD  H            ; vypocet offsetu do zoznamu RJ
00AE  29              DAD  H
00AF  29              DAD  H
00B0  29              DAD  H
00B1  29              DAD  H
00B2  5C              MOV  E,H
00B3  16 00           MVI  D,00         ; DE = offset do zoznamu RJ
00B5  21 1870         LXI  H,1870       ; adresa zoznamu RJ
00B8  C3 0502         JMP  0502         ; pokracuj dalej


;------------------------------------------------------------------------------
; Povel 'M' - zapis do operacnej pamati
;------------------------------------------------------------------------------
00BB  3E 40           MVI  A,40         ; flag - ocakavaju sa data
00BD  21              DB   21           ; LXI H - preskoc MVI A,80
;------------------------------------------------------------------------------
; Povel 'G' - citanie z operacnej pamati
;------------------------------------------------------------------------------
00BE  3E 80           MVI  A,80         ; flag - budu sa posielat data
00C0  2A 1814         LHLD 1814         ; zdrojova/cielova adresa pamati
00C3  22 180D         SHLD 180D         ; ako adresa IMS-2 buffra
00C6  32 1800         STA  1800         ; uloz flag
00C9  3E 05           MVI  A,05         ; novy kod povelu
00CB  67              MOV  H,A          ; "typ" suboru
00CC  C3 0914         JMP  0914         ; skoc ulozit


;------------------------------------------------------------------------------
; Obsluha 'O' - otvorenie datoveho suboru - pokracovanie
;------------------------------------------------------------------------------
00CF  2A 1812         LHLD 1812         ; adresa zaznamu v open bufferi
00D2  EB              XCHG              ; do DE
00D3  06 14           MVI  B,14         ; zaznam ma 20 bytov
00D5  12              STAX D            ; ???
00D6  C3 05CC         JMP  05CC         ; presun hlavicky do zaznamu v OPEN buf.


;------------------------------------------------------------------------------
; Zoznam nizsich bytov adries rutin pre obsluhu povelov a parametrov.
; Vyssi byte (01) je ulozeny v zapisniku na adrese 1805.
;------------------------------------------------------------------------------
00D9  2C              DB   2C           ; 012C - 'T' - stopa
00DA  25              DB   25           ; 0125 - 'S' - sektor
00DB  1E              DB   1E           ; 011E - '$' - cislo zaznamu
00DC  A4              DB   A4           ; 01A4 - '''' - nazov suboru
00DD  17              DB   17           ; 0117 - '@' - dlzka zaznamu
00DE  33              DB   33           ; 0133 - '&' - adresa
00DF  00              DB   00           ; 0100 - '#' - cislo otvoreneho suboru
00E0  53              DB   53           ; 0153 - 'W' - zapis na fyz. sektor
00E1  64              DB   64           ; 0164 - 'R' - citanie z fyz. sektoru
00E2  3A              DB   3A           ; 013A - 'P' - zapis na log. sektor
00E3  4B              DB   4B           ; 014B - 'I' - citanie z log. sektora
00E4  AA              DB   AA           ; 01AA - 'C' - vytvorenie dat. suboru
00E5  AD              DB   AD           ; 01AD - 'U' - uzatvorenie suboru
00E6  A7              DB   A7           ; 01A7 - 'F' - formatovanie diskety
00E7  6C              DB   6C           ; 016C - 01  - pokracovanie 'W' a 'R'
00E8  78              DB   78           ; 0178 - 02  - pokracovanie 'P' a 'I'
00E9  C7              DB   C7           ; 01C7 - 03  - binarne citanie/zapis
00EA  7E              DB   7E           ; 017E - '!' - kontrola parametrov
00EB  C4              DB   C4           ; 01C4 - 'O' - otvorenie datoveho suboru
00EC  B3              DB   B3           ; 01B3 - 'A' - uzatv. vsetkych suborov
00ED  E8              DB   E8           ; 01E8 - 'G' - citanie z operac. pamati
00EE  C0              DB   C0           ; 01C0 - 'J' - skok na podprogram
00EF  CD              DB   CD           ; 01CD - 'E' - vymazanie z katalogu
00F0  EB              DB   EB           ; 01EB - 'L' - citanie binarnych dat
00F1  DE              DB   DE           ; 01DE - '*' - typ suboru
00F2  E5              DB   E5           ; 01E5 - 'M' - zapis do operacnej pamati
00F3  DB              DB   DB           ; 01DB - 04  - pokr./ukoncenie 'D'
00F4  D8              DB   D8           ; 01D8 - 'D' - citanie katalogu
00F5  D3              DB   D3           ; 01D3 - 'N' - citanie nazvu diskety
00F6  EE              DB   EE           ; 01EE - 'Z' - zapis binarnych dat
00F7  6F              DB   6F           ; 016F - 05  - ukoncenie povelov
00F8  F1              DB   F1           ; 01F1 - 'B' - utajenie suboru v katal.
00F9  D0              DB   D0           ; 01D0 - 'H' - vyhladanie slova v subore
00FA  7B              DB   7B           ; 017B - 06  - pokr. vyhl. sl. v subore


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
00FB  FF FF FF 77     DB   FF,FF,FF,77
00FF  FF              DB   FF


;------------------------------------------------------------------------------
; Parameter '#' - cislo otvoreneho suboru
; Vstup: DE = adresa vo vstupnom buffri
; Vystup: (1812) = adresa polozky v OPEN buffri, CY = 1
; Meni: vsetky
;------------------------------------------------------------------------------
0100  CD 180F         CALL 180F         ; rozparsuj cislo
0103  D0              RNC               ; pri chybe sa vrat
0104  E6 07           ANI  07           ; cislo suboru 0 az 7
0106  32 1822         STA  1822         ; 2. cinitel nasobenia
0109  21 0014         LXI  H,0014       ; velkost jednej polozky v OPEN buffri
010C  22 1820         SHLD 1820         ; ako 1. cinitel nasobenia
010F  D5              PUSH D            ; odpamataj adresu v buffri
0110  CD 0582         CALL 0582         ; vynasob cislo suboru a velkost polozky
0113  C3 0257         JMP  0257         ; HL = offset do OPEN buffra


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0116  FF              DB   FF


;------------------------------------------------------------------------------
; Parameter '@' - dlzka zaznamu
; Vstup: DE = adresa vstupneho buffra
; Vystup: (1822) = dlzka zaznamu
; Meni: vsetky
;------------------------------------------------------------------------------
0117  CD 180F         CALL 180F         ; rozparsuj cislo
011A  32 1822         STA  1822         ; uloz dlzku zaznamu
011D  C9              RET


;------------------------------------------------------------------------------
; Parameter '$' - cislo zaznamu
; Vstup: DE = adresa vstupneho buffra
; Vystup: (1820) = cislo zaznamu
; Meni: vsetky
;------------------------------------------------------------------------------
011E  CD 180F         CALL 180F         ; rozparsuj cislo
0121  22 1820         SHLD 1820         ; uloz cislo zaznamu
0124  C9              RET


;------------------------------------------------------------------------------
; Parameter 'S' - sektor
; Vstup: DE = adresa vstupneho buffra
; Vystup: (1826) = cislo sektora
; Meni: vsetky
;------------------------------------------------------------------------------
0125  CD 180F         CALL 180F         ; rozparsuj cislo
0128  32 1826         STA  1826         ; uloz cislo sektoru
012B  C9              RET


;------------------------------------------------------------------------------
; Parameter 'T' - stopa
; Vstup: DE = adresa vstupneho buffra
; Vystup: (1825) = cislo stopy
; Meni: vsetky
;------------------------------------------------------------------------------
012C  CD 180F         CALL 180F         ; rozparsuj cislo
012F  C3 0622         JMP  0622         ; pokracuj dalej


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0132  FF              DB   FF


;------------------------------------------------------------------------------
; Parameter '&' - adresa
; Vstup: DE = adresa vstupneho buffra
; Vystup: (1814) = adresa podprogramu alebo adresa pamati pre citanie/zapis
; Meni: vsetky
;------------------------------------------------------------------------------
0133  CD 180F         CALL 180F         ; rozparsuj cislo
0136  22 1814         SHLD 1814         ; uloz adresu
0139  C9              RET


;------------------------------------------------------------------------------
; Povel 'P' - zapis na log. sektor
; Vstup: DE = adresa vstupneho buffra
; Vystup: -
; Meni: vsetky
;------------------------------------------------------------------------------
013A  21 0562         LXI  H,0562       ; adr. rutiny - presun IMS-2 -> sektor
013D  3E 40           MVI  A,40         ; flag - ocakavaju sa data
013F  32 1800         STA  1800         ; uloz flag
0142  3E 02           MVI  A,02         ; novy kod povelu pre 'P' a 'I'
0144  32 1808         STA  1808         ; uloz novy kod
0147  22 1810         SHLD 1810
014A  C9              RET


;------------------------------------------------------------------------------
; Povel  'I' - citanie z log. sektora
;------------------------------------------------------------------------------
014B  21 0550         LXI  H,0550       ; adr. rutiny - presun sektor -> IMS-2
014E  3E 80           MVI  A,80         ; flag - budu sa posielat data
0150  C3 013F         JMP  013F


;------------------------------------------------------------------------------
; Povel 'W' - zapis na fyz. sektor
;------------------------------------------------------------------------------
0153  21 0714         LXI  H,0714       ; adresa rutiny pre zapis sektora
0156  3E 40           MVI  A,40         ; flag - ocakavaju sa data
0158  32 1800         STA  1800         ; uloz flag
015B  3E 01           MVI  A,01         ; novy kod povelu pre 'W' a 'R'
015D  32 1808         STA  1808         ; uloz novy kod
0160  C3 0298         JMP  0298


;------------------------------------------------------------------------------
; hluchy kod
;------------------------------------------------------------------------------
0163  C9              RET


;------------------------------------------------------------------------------
; Povel 'R' - citanie z fyz. sektoru
;------------------------------------------------------------------------------
0164  21 062B         LXI  H,062B       ; adresa rutiny pre citanie sektora
0167  3E 80           MVI  A,80         ; flag - budu sa posielat data
0169  C3 0158         JMP  0158         ; skoc ulozit


;------------------------------------------------------------------------------
; Povel 01 - pokracovanie 'W' a 'R'
;------------------------------------------------------------------------------
016C  CD 074A         CALL 074A         ; precitaj alebo zapis sektor

;------------------------------------------------------------------------------
; Povel 05 - ukoncenie povelov
;------------------------------------------------------------------------------
016F  3A 1800         LDA  1800         ; vezmi kod chyby
0172  E6 0F           ANI  0F           ; odmaskuj iba  samotny kod
0174  32 1800         STA  1800         ; uloz kod chyby
0177  C9              RET


;------------------------------------------------------------------------------
; Povel 02 - pokracovanie 'P' a 'I'
;------------------------------------------------------------------------------
0178  C3 091D         JMP  091D


;------------------------------------------------------------------------------
; Povel 06 - pokracovanie 'H'
;------------------------------------------------------------------------------
017B  C3 0B15         JMP  0B15


;------------------------------------------------------------------------------
; Parameter '!' - kontrola parametrov povelov 'P', 'I' a 'H'
; Vstup: (1812) = adresa polozky OPEN buffra
;        (1820) = pozadovane cislo zaznamu
; Vystup: (1812) = ukazatel na rozmiestnovacie jednotky suboru
;         (1822) = dlzka zaznamu
;         (180D) = 1A00 - default adresa IMS-2 buffra
; Meni: HL, BC, AF
;------------------------------------------------------------------------------
017E  21 1A00         LXI  H,1A00       ; nastav defaultnu adresu IMS-2 buffra
0181  22 180D         SHLD 180D
0184  2A 1812         LHLD 1812         ; vezmi adresu polozky OPEN buffra
0187  AF              XRA  A
0188  BE              CMP  M            ; zisti, ci je otvoreny subor
0189  CA 05B1         JZ   05B1         ; 11 - nie je otvoreny subor
018C  23              INX  H            ; posun ukazatel na pocet zaznamov
018D  4E              MOV  C,M          ; a uloz do BC
018E  23              INX  H
018F  46              MOV  B,M
0190  23              INX  H            ; posun ukazatel na dlzku zaznamu
0191  7E              MOV  A,M
0192  32 1822         STA  1822         ; uloz na adresu 1822
0195  23              INX  H            ; ukazatel na rozmiestnovacie jednotky
0196  22 1812         SHLD 1812         ; uloz
0199  2A 1820         LHLD 1820         ; do HL pozadovane cislo zaznamu
019C  23              INX  H            ; zvys o 1
019D  CD 0252         CALL 0252         ; porovnaj, ci je v rozsahu
01A0  3F              CMC               ; CY=0, pri chybe
01A1  C3 084C         JMP  084C         ; pokracuj dalej


;------------------------------------------------------------------------------
; Parameter '''' - nazov suboru
; Vstup: DE = adresa vstupneho buffra
; Vystup: (1816) = meno suboru - 8 znakov
; Meni: vsetky
;------------------------------------------------------------------------------
01A4  C3 02A2         JMP  02A2         ; skoc dopredu


;------------------------------------------------------------------------------
; Povel 'F' - formatovanie diskety
; Vstup: (1816) = meno suboru
; Vystup: -
; Meni: vsetky
;------------------------------------------------------------------------------
01A7  C3 0A18         JMP  0A18


;------------------------------------------------------------------------------
; Povel 'C' - vytvorenie dat. suboru
;------------------------------------------------------------------------------
01AA  C3 033D         JMP  033D


;------------------------------------------------------------------------------
; Povel 'U' - uzatvorenie suboru
;------------------------------------------------------------------------------
01AD  2A 1812         LHLD 1812         ; adresa polozky v OPEN buffri
01B0  36 00           MVI  M,00         ; znacka - uzatvoreny subor
01B2  C9              RET


;------------------------------------------------------------------------------
; Povel 'A' - uzatvorenie vsetkych suborov
; Rutina zmaze OPEN buffer
; Vstup: -
; Vystup: -
; Meni: HL, B, PSW
;------------------------------------------------------------------------------
01B3  21 18E0         LXI  H,18E0       ; adresa OPEN buffra
01B6  06 A0           MVI  B,A0         ; velkost 160 bytov
01B8  36 00           MVI  M,00         ; zmaz cely OPEN buffer
01BA  23              INX  H
01BB  05              DCR  B
01BC  C2 01B8         JNZ  01B8
01BF  C9              RET


;------------------------------------------------------------------------------
; Povel 'J' - skok na podprogram
;------------------------------------------------------------------------------
01C0  2A 1814         LHLD 1814         ; HL = adresa skoku
01C3  E9              PCHL              ; skoc do podprogramu


;------------------------------------------------------------------------------
; Povel 'O' - otvorenie datoveho suboru
;------------------------------------------------------------------------------
01C4  C3 02C6         JMP  02C6


;------------------------------------------------------------------------------
; Povel 03 - binarne citanie/zapis
;------------------------------------------------------------------------------
01C7  CD 00A6         CALL 00A6         ; vypocitaj cislo sektora a stopy
01CA  C3 0040         JMP  0040         ; skoc dalej


;------------------------------------------------------------------------------
; Povel 'E' - vymazanie z katalogu
;------------------------------------------------------------------------------
01CD  C3 0700         JMP  0700


;------------------------------------------------------------------------------
; Povel 'H' - vyhladanie slova v subore
;------------------------------------------------------------------------------
01D0  C3 0AFD         JMP  0AFD


;------------------------------------------------------------------------------
; Povel 'N' - citanie nazvu diskety
;------------------------------------------------------------------------------
01D3  3E 05           MVI  A,05         ; novy kod povelu
01D5  C3 0802         JMP  0802         ; skoc dopredu


;------------------------------------------------------------------------------
; Povel 'D' - citanie katalogu
;------------------------------------------------------------------------------
01D8  C3 0800         JMP  0800


;------------------------------------------------------------------------------
; Povel 04 - pokracovanie/ukoncenie povelu 'D'
;------------------------------------------------------------------------------
01DB  C3 085F         JMP  085F


;------------------------------------------------------------------------------
; Parameter '*' - typ suboru
; Vstup: DE = adresa vstupneho buffra
; Vystup: (183D) = typ suboru
; Meni: vsetky
;------------------------------------------------------------------------------
01DE  13              INX  D            ; posun ukazatel
01DF  1A              LDAX D            ; vezmi typ suboru
01E0  32 183D         STA  183D         ; a uloz
01E3  37              STC               ; CY=1 - OK
01E4  C9              RET


;------------------------------------------------------------------------------
; Povel 'M' - zapis do operacnej pamati
;------------------------------------------------------------------------------
01E5  C3 00BB         JMP  00BB


;------------------------------------------------------------------------------
; Povel 'G' - citanie z operac. pamati
;------------------------------------------------------------------------------
01E8  C3 00BE         JMP  00BE


;------------------------------------------------------------------------------
; Povel 'L' - citanie binarnych dat
;------------------------------------------------------------------------------
01EB  C3 03D7         JMP  03D7


;------------------------------------------------------------------------------
; Povel 'Z' - zapis binarnych dat
;------------------------------------------------------------------------------
01EE  C3 096E         JMP  096E


;------------------------------------------------------------------------------
; Povel 'B' - utajenie suboru v katalogu
;------------------------------------------------------------------------------
01F1  C3 0941         JMP  0941


;------------------------------------------------------------------------------
; Rutina vyhlada prislusny subor v katalogu. Hlada sa podla mena alebo podla
; typu suboru.
; Ak sa najde hlavicka
; Vstup: (1838) = typ suboru, ak je "N", hlada sa podla mena
;        (1816) = meno suboru
; Vystup: HL = adresa najdenej hlavicky
;         Z=1, CY=1 - OK naslo sa
;         Z=1, CY=0 - volna hlavicka
;         Z=0, CY=0 - nenaslo sa
;------------------------------------------------------------------------------
01F4  21 0200         LXI  H,0200       ; 0. stopa, 2. sektor - katalog diskety
01F7  22 1825         SHLD 1825         ; uloz
01FA  21 062B         LXI  H,062B       ; adresa rutiny READ SECTOR
01FD  CD 0578         CALL 0578         ; precitaj sektor
0200  C0              RNZ
0201  2A 180B         LHLD 180B         ; HL = adresa, kam sa nacital sektor
0204  06 04           MVI  B,04         ; 4 hlavicky suborov v jednom sektore
0206  3A 1838         LDA  1838         ; A = typ pozadovaneho suboru
0209  C5              PUSH B            ; odpamataj pocitadlo
020A  E5              PUSH H            ; adresu "v sektore"
020B  FE 4E           CPI  4E           ; je typ "N" ?
020D  C2 0247         JNZ  0247         ; nie, skoc dopredu
0210  23              INX  H            ; posun ukazatel na nazov
0211  11 1816         LXI  D,1816       ; adresa nazvu suboru
0214  06 08           MVI  B,08         ; nazov suboru ma 8 znakov
0216  1A              LDAX D            ; porovnaj jednotlive znaky
0217  BE              CMP  M
0218  C2 0225         JNZ  0225         ; nezhoduje sa, skoc dopredu
021B  23              INX  H            ; posun ukazatele
021C  13              INX  D
021D  05              DCR  B            ; zniz pocitadlo znakov
021E  C2 0216         JNZ  0216         ; porovnavaj dalej
0221  E1              POP  H            ; obnov adresu hlavicky suboru
0222  C1              POP  B            ; obnov BC
0223  37              STC               ; Z=1, CY=1 - OK naslo sa
0224  C9              RET               ; vrat sa

0225  E1              POP  H            ; obnov adresu hlavicky suboru
0226  C1              POP  B            ; obnov pocitadlo
0227  11 0009         LXI  D,0009       ; offset k typu suboru
022A  19              DAD  D            ; pripocitaj
022B  7E              MOV  A,M          ; typ suboru do A
022C  FE 00           CPI  00           ; je to volna hlavicka ?
022E  11 0017         LXI  D,0017       ; posun ukazatel na dalsiu hlavicku
0231  19              DAD  D
0232  CA 0393         JZ   0393         ; je to volna hlavicka, skoc dopredu
0235  05              DCR  B            ; zniz pocitadlo hlaviciek v sektore
0236  C2 0206         JNZ  0206         ; opakuj pre vsetky hlavicky
0239  3A 1826         LDA  1826         ; zvys cislo sektoru
023C  3C              INR  A
023D  32 1826         STA  1826
0240  FE 11           CPI  11           ; presiel si vsetky hlavisky ?
0242  C2 01FA         JNZ  01FA         ; nie, opakuj
0245  A7              ANA  A            ; Z=0, CY=0 - nenaslo sa
0246  C9              RET

0247  11 0009         LXI  D,0009       ; posun ukazatel na typ suboru
024A  19              DAD  D
024B  BE              CMP  M            ; je to pozadovany typ ?
024C  C2 0225         JNZ  0225         ; nie, prejdi na dalsiu hlavicku
024F  C3 0221         JMP  0221         ; ano, vrat sa


;------------------------------------------------------------------------------
; Rutina CMP BC,HL
; Vstup: BC, HL
; Vystup: CY=1, ak HL > BC
;         CY=0, ak HL <= BC
; Meni: AF
;------------------------------------------------------------------------------
0252  79              MOV  A,C
0253  95              SUB  L
0254  78              MOV  A,B
0255  9C              SBB  H
0256  C9              RET


;------------------------------------------------------------------------------
; '#' - cislo otvoreneho suboru - pokracovanie
; Vstup: DE = adresa vo vstupnom buffri
; Vystup: (1812) = adresa polozky v OPEN buffri, CY = 1
; Meni: vsetky
;------------------------------------------------------------------------------
0257  11 18E0         LXI  D,18E0       ; adresa OPEN buffra
025A  19              DAD  D            ; pripocitaj offset
025B  22 1812         SHLD 1812         ; uloz adresu polozky v OPEN buffri
025E  D1              POP  D            ; obnov adresu vo vstupnom buffri
025F  37              STC               ; CY = 1 - OK
0260  C9              RET


;------------------------------------------------------------------------------
; Povel 'F' - formatovanie diskety
; Naformatuje jednu stranu diskety a na koniec prvych 16. sektorov zapise
; meno disku.
; Vstup: (1816) = meno suboru
; Vystup: Z=1 - OK, Z=0 - chyba
; Meni: vsetky
;------------------------------------------------------------------------------
0261  21 068E         LXI  H,068E       ; adresa rutiny format diskety
0264  CD 0578         CALL 0578         ; sformatuj disketu
0267  C0              RNZ               ; vrat sa pri chybe
0268  21 0100         LXI  H,0100       ; 0. stopa, 1. sektor
026B  22 1825         SHLD 1825         ; uloz
026E  06 80           MVI  B,80         ; 128 bytov ma sektor
0270  2A 180B         LHLD 180B         ; adresa sektoroveho buffra
0273  36 00           MVI  M,00         ; vynuluj sektor
0275  23              INX  H
0276  05              DCR  B
0277  C2 0273         JNZ  0273
027A  06 08           MVI  B,08         ; zapis na koniec sektora meno disku
027C  11 181D         LXI  D,181D       ; adresa konca mena suboru
027F  2B              DCX  H
0280  1A              LDAX D
0281  77              MOV  M,A
0282  1B              DCX  D
0283  05              DCR  B
0284  C2 027F         JNZ  027F
0287  CD 0575         CALL 0575         ; zapis sektor
028A  C0              RNZ               ; vrat sa pri chybe
028B  3A 1826         LDA  1826         ; zvys cislo sektoru
028E  3C              INR  A
028F  32 1826         STA  1826
0292  FE 11           CPI  11           ; prejdi cely katalog
0294  C2 0287         JNZ  0287
0297  C9              RET


;------------------------------------------------------------------------------
; Obsluha 'W' a 'R' - pokracovanie
;------------------------------------------------------------------------------
0298  22 1809         SHLD 1809         ; ulozenie adresy obsluznej rutiny
029B  2A 180B         LHLD 180B         ; adresa pre fyzicky sektor
029E  22 180D         SHLD 180D         ; a ta ista ako adresa IMS-2 buffra
02A1  C9              RET


;------------------------------------------------------------------------------
; Parameter '''' - nazov suboru - pokracovanie
; Vstup: DE = adresa vstupneho buffra
; Vystup: (1816) = meno suboru
; Meni: vsetky
;------------------------------------------------------------------------------
02A2  06 08           MVI  B,08         ; max. 8 znakov
02A4  21 1815         LXI  H,1815       ; adresa cieloveho buffra - 1
02A7  13              INX  D            ; posun ukazatele
02A8  23              INX  H
02A9  1A              LDAX D            ; vezmi znak
02AA  FE 27           CPI  27           ; je to '''' - ukoncenie mena ?
02AC  CA 02BD         JZ   02BD         ; ano, skoc dopredu
02AF  77              MOV  M,A          ; uloz znak
02B0  05              DCR  B            ; zniz pocitadlo
02B1  C2 02A7         JNZ  02A7         ; opakuj pre cele meno
02B4  13              INX  D            ; posun ukazatel
02B5  1A              LDAX D            ; over ci je meno ukoncene apostrofom
02B6  FE 27           CPI  27
02B8  C2 05B4         JNZ  05B4         ; 12 - chyba nazvu suboru al. duplicita
02BB  37              STC               ; CY=1 - OK
02BC  C9              RET

; kratsie meno je doplnene medzerami
02BD  36 20           MVI  M,20         ; uloz medzeru
02BF  05              DCR  B            ; zniz pocitadlo
02C0  37              STC               ; CY=1 - OK
02C1  C8              RZ                ; hotovo, vrat sa
02C2  23              INX  H            ; posun ukazatel
02C3  C3 02BD         JMP  02BD         ; opakuj


;------------------------------------------------------------------------------
; Obsluha 'O' - otvorenie datoveho suboru
; Vstup: (1816) = meno suboru
; Vystup: zaznam v OPEN bufferi
;         (1812) = adresa tohto zaznamu
; Meni: vsetky
;------------------------------------------------------------------------------
02C6  3E 4E           MVI  A,4E         ; 'N' - bude sa hladat podla mena
02C8  32 1838         STA  1838
02CB  CD 01F4         CALL 01F4         ; hladaj subor
02CE  C0              RNZ               ; ak sa nenajde,
02CF  D2 05B4         JNC  05B4         ; 12 - chyba nazvu suboru al. duplicita
02D2  7E              MOV  A,M          ; vezmi flag utajenia suboru
02D3  B7              ORA  A            ; je utajeny ?
02D4  00              NOP               ; aaa, nic...
02D5  00              NOP               ; tu bol zrejme podmieneny skok na 05BA
02D6  00              NOP
02D7  11 0009         LXI  D,0009       ; posun sa na typ suboru
02DA  19              DAD  D
02DB  7E              MOV  A,M
02DC  FE 44           CPI  44           ; je to 'D' datovy subor ?
02DE  C2 05BD         JNZ  05BD         ; 15 - chyba v type suboru
02E1  23              INX  H            ; posun ukazatel na pocet RJ
02E2  23              INX  H
02E3  23              INX  H
02E4  EB              XCHG              ; presun do DE
02E5  C3 00CF         JMP  00CF         ; skoc dalej


;------------------------------------------------------------------------------
; Rutina "alokuje" potrebny pocet RJ pre novo vytvarany datovy subor.
; Vstup: (1820) = pocet zaznamov
;        (1822) = velkost zaznamu
; Vystup: Z=0 - pri chybe
;         Z=1 - OK
;         (1827) = pocet potrebnych RJ
;         (1870) = max. 8 cisel RJ, kde bude umiestneny vytvarany subor
; Meni: vsetky
;------------------------------------------------------------------------------
02E8  CD 0582         CALL 0582         ; vypocitaj vekost vytvaraneho suboru
02EB  7C              MOV  A,H          ; ak je pozadovana velkost > 16383,
02EC  E6 C0           ANI  C0           ; je to chyba
02EE  C2 05B7         JNZ  05B7         ; 13 - parameter mimo rozsah
02F1  7C              MOV  A,H          ; vypocitaj pocet potrebnych RJ
02F2  1F              RAR
02F3  1F              RAR
02F4  E6 3F           ANI  3F

;------------------------------------------------------------------------------
; Rutina "alokuje" potrebny pocet RJ pre novo vytvarany subor.
; Vstup: A = pocet RJ - 1
; Vystup: Z=0 - pri chybe
;         Z=1 - OK
;         (1827) = pocet potrebnych RJ
;         (1870) = cisla RJ, kde bude umiestneny vytvarany subor
; Meni: vsetky
;------------------------------------------------------------------------------
02F6  3C              INR  A
02F7  32 1827         STA  1827         ; uloz pocet potrebnych RJ
02FA  47              MOV  B,A          ; aj do B
02FB  C5              PUSH B            ; odpamataj
02FC  21 0100         LXI  H,0100       ; stopa=0, sektor=1 - alokacna mapa
02FF  22 1825         SHLD 1825         ; uloz
0302  21 1A00         LXI  H,1A00       ; adresa kam sa ulozi sektor
0305  CD 032A         CALL 032A         ; precitaj sektor
0308  C1              POP  B            ; obnov pocet porebnych RJ
0309  C0              RNZ               ; vrat sa pri chybe citania sektoru
030A  21 1A02         LXI  H,1A02       ; adresa alokacne mapy
030D  11 1870         LXI  D,1870       ; adresa buduceho zoznamu RJ suboru
0310  AF              XRA  A            ; hladame volne RJ
0311  BE              CMP  M            ; je to volna RJ ?
0312  CC 0322         CZ   0322         ; ano, spracuj
0315  23              INX  H            ; posun sa na dalsiu polozku
0316  7D              MOV  A,L          ; max. 90 RJ na disku
0317  FE 5A           CPI  5A
0319  C2 0310         JNZ  0310         ; opakuj pre vsetky
031C  05              DCR  B            ; ak sa neslo dostatok volnych RJ,
031D  04              INR  B            ; je to chyba
031E  C2 05AE         JNZ  05AE         ; 10 - disk plny
0321  C9              RET

0322  7D              MOV  A,L          ; cislo volnej RJ ulozime
0323  75              MOV  M,L          ; do alokacnej mapy
0324  12              STAX D            ; aj do buduceho zoznamu RJ suboru
0325  13              INX  D            ; posun ukazatel
0326  05              DCR  B            ; zniz pocet potrebnych RJ
0327  C0              RNZ               ; vrat sa, ak nie su najdene vsetky
0328  E1              POP  H            ; zahod navratovu adresu
0329  C9              RET               ; a vrat sa


;------------------------------------------------------------------------------
; Rutina pre nacitanie sektora s volbou adresy cieloveho buffra.
; Vstup: HL = adresa cieloveho buffra
; Vystup: nacitany sektor
;         nastavena defaultna adresa buffra
; Meni: vsetky
;------------------------------------------------------------------------------
032A  22 180B         SHLD 180B         ; uloz cielovu adresu

;------------------------------------------------------------------------------
; Rutina pre nacitanie sektora.
; Vstup: (180B) = adresa cieloveho buffra
; Vystup: (180B) = 1980 - defaultna adresa
; Meni: vsetky
;------------------------------------------------------------------------------
032D  21 062B         LXI  H,062B       ; adresa rutiny READ SECTOR

;------------------------------------------------------------------------------
; Rutina pre zapis/citanie sektora.
; Vstup: HL = adresa rutiny
;        (180B) = adresa cieloveho buffra
; Vystup: (180B) = 1980 - defaultna adresa
; Meni: vsetky
;------------------------------------------------------------------------------
0330  22 1809         SHLD 1809         ; uloz adresu rutiny
0333  CD 074A         CALL 074A         ; zavolaj rutinu
0336  21 1980         LXI  H,1980       ; nastav defaultnu adresu buffra
0339  22 180B         SHLD 180B
033C  C9              RET


;------------------------------------------------------------------------------
; Povel 'C' - vytvorenie datoveho suboru
;------------------------------------------------------------------------------
033D  CD 02E8         CALL 02E8         ; zisti pocet potrebnych RJ
0340  C0              RNZ               ; vrat sa, ak je disk plny
0341  3E 4E           MVI  A,4E         ; 'N' - bude sa hladat podla mena
0343  32 1838         STA  1838         ; zisti, ci sa uz subor s tymto meno
0346  CD 01F4         CALL 01F4         ; na disku nachadza
0349  C0              RNZ               ; vrat sa pri chybe, ak subor existuje,
034A  DA 05B4         JC   05B4         ; 12 - chyba nazvu suboru al. duplicita
034D  3E 45           MVI  A,45         ; 'E' - budeme hladat zmazane subory
034F  32 1838         STA  1838
0352  C3 0BEB         JMP  0BEB         ; skoc dporedu

;------------------------------------------------------------------------------
; hluchy kod
;------------------------------------------------------------------------------
0355  C0              RNZ

;------------------------------------------------------------------------------
; Povel 'C' - vytvorenie datoveho suboru - pokracovanie
; Vstup: (1816) = meno suboru
;------------------------------------------------------------------------------
0356  01 0844         LXI  B,0844       ; 8 znakov, typ suboru 'D'
0359  36 00           MVI  M,00         ; flag neutajeny subor
035B  23              INX  H            ; posun ukazatel
035C  EB              XCHG              ; presun do DE
035D  21 1816         LXI  H,1816       ; presun meno suboru do hlavicky
0360  CD 05CC         CALL 05CC
0363  79              MOV  A,C          ; zapis typ suboru
0364  12              STAX D
0365  13              INX  D            ; posun ukazatel
0366  13              INX  D
0367  13              INX  D
0368  00              NOP
0369  3A 1827         LDA  1827         ; zapis pocet RJ
036C  12              STAX D
036D  4F              MOV  C,A          ; pocet RJ do C
036E  06 03           MVI  B,03         ; presun pocet zaznamov
0370  23              INX  H            ; a velkost zaznamu
0371  23              INX  H
0372  13              INX  D
0373  CD 05CC         CALL 05CC
0376  21 1870         LXI  H,1870       ; zoznam alokovanych RJ
0379  41              MOV  B,C          ; pocet RJ do B
037A  CD 05CC         CALL 05CC         ; presun
037D  CD 0575         CALL 0575         ; zapis sektor
0380  C0              RNZ               ; vrat sa pri chybe
0381  21 0100         LXI  H,0100       ; stopa=0, sektor=1 - alokacna mapa
0384  22 1825         SHLD 1825
0387  21 1A00         LXI  H,1A00       ; adresa, kde je alokacna mapa
038A  22 180B         SHLD 180B
038D  21 0714         LXI  H,0714       ; adresa rutiny WRITE SECTOR
0390  C3 0330         JMP  0330         ; zapis sektor

;------------------------------------------------------------------------------
; Rutina pre vyhladanie suboru v katalogu - ukoncenie.
; Vystup: HL = adresa volnej hlavicky
;         Z=1, CY=0 - volna hlavicka
;------------------------------------------------------------------------------
0393  11 FFE0         LXI  D,FFE0       ; -32
0396  19              DAD  D            ; posun sa naspat na volnu hlavicku
0397  A7              ANA  A            ; Z=1, CY=0 - volna hlavicka
0398  C9              RET


;------------------------------------------------------------------------------
; Rutina vyhlada podla mena subor v katalogu a pripravi zoznam pridelenych RJ.
; Vstup: (1816) = meno suboru
; Vystup: CY=1 - OK, (1870) = zoznam RJ
;         CY=0, Z=0 - chyba
;------------------------------------------------------------------------------
0399  21 1870         LXI  H,1870       ; adresa zoznamu pridelenych RJ
039C  22 1812         SHLD 1812         ; uloz
039F  3E 4E           MVI  A,4E         ; 'N' - bude sa hladat podla mena
03A1  32 1838         STA  1838
03A4  CD 01F4         CALL 01F4         ; vyhladaj subor
03A7  D0              RNC               ; vrat sa, ak sa nenasiel
03A8  11 000C         LXI  D,000C       ; offset na pocet RJ v hlavicke suboru
03AB  C0              RNZ               ; vrat sa, ak sa subor nenasiel
03AC  E5              PUSH H            ; odpamataj HL, BC z vyhladania suborov
03AD  C5              PUSH B
03AE  19              DAD  D            ; posun sa na pocet RJ
03AF  7E              MOV  A,M
03B0  32 1827         STA  1827         ; uloz pocet RJ
03B3  23              INX  H            ; posun sa na pocet zaznamov
03B4  7E              MOV  A,M          ; a uloz
03B5  32 1820         STA  1820         ; nizsi byte
03B8  23              INX  H
03B9  7E              MOV  A,M
03BA  32 1821         STA  1821         ; vyssi byte
03BD  23              INX  H            ; posun ukazatel na zoznam RJ
03BE  23              INX  H
03BF  06 10           MVI  B,10         ; zoznam RJ ma max. 16 poloziek
03C1  EB              XCHG
03C2  2A 1812         LHLD 1812
03C5  EB              XCHG
03C6  CD 05CC         CALL 05CC         ; prenes zoznam RJ do na cielovu adresu
03C9  EB              XCHG
03CA  22 1812         SHLD 1812         ; uloz cielovu adresu
03CD  C1              POP  B            ; obnov BC, HL
03CE  E1              POP  H
03CF  CD 0227         CALL 0227         ; vyhldaj dalsiu hlavicku
03D2  DA 03A8         JC   03A8         ; ak sa nasla, pokracuj
03D5  37              STC               ; CY=1, hotovo
03D6  C9              RET


;------------------------------------------------------------------------------
; Povel 'L' - citanie binarnych dat
;------------------------------------------------------------------------------
03D7  CD 0399         CALL 0399         ; vyhladaj subor a priprav zoznam RJ
03DA  C0              RNZ               ; vrat sa pri chybe
03DB  CD 01F4         CALL 01F4         ; vyhladaj hlavicku suboru
03DE  C0              RNZ               ; vrat sa pri chybe
03DF  D2 05B4         JNC  05B4         ; 12 - chyba nazvu suboru al. duplicita
03E2  01 0009         LXI  B,0009       ; offset na typ suboru
03E5  09              DAD  B
03E6  3A 183D         LDA  183D         ; porovnaj typ
03E9  BE              CMP  M
03EA  C2 05BD         JNZ  05BD         ; 15 - chyba v type suboru
03ED  CD 0683         CALL 0683         ; priprav obsluznu rutinu a flag
03F0  60              MOV  H,B          ; vynuluj poradove cislo log. sektora
03F1  68              MOV  L,B
03F2  22 183B         SHLD 183B
03F5  32 1800         STA  1800         ; uloz flag
03F8  3E 03           MVI  A,03         ; novy kod povelu pre 'Z' a 'L'
03FA  32 1808         STA  1808
03FD  C3 029B         JMP  029B         ; vrat sa cez nast. adresy IMS-2 buffra


;------------------------------------------------------------------------------
; Podprogram COMMAND.
; Rutina spracuje COMMAND slovo ulozene v buffri na adrese 1870.
; Kod povelu sa ulozi na adresu 1808.
; Format COMMAND slova:
;   povel | D/H | parameter | hodnota parametra | ... | OD
;   D = decimalne hodnoty v parametroch
;   H = hexadecimalne hodnoty v parametroch
; Rutina nespravne testuje koniec tabulky so zoznamom povelov a parametrov,
; takze prehladavanie prejde az do kodu nasledujuceho za tabulkou. Nastastie
; to nema destruktivne nasledky.
;------------------------------------------------------------------------------
0400  21 07B0         LXI  H,07B0       ; adresa zoznamu povelov a parametrov
0403  11 1870         LXI  D,1870       ; COMMAND buffer
0406  06 0D           MVI  B,0D         ; znacka ukoncenia povelu
0408  1A              LDAX D            ; citaj kod povelu z buffra
0409  BE              CMP  M            ; porovnaj s tabulkou
040A  CA 041B         JZ   041B         ; je to on, skoc do predu
040D  23              INX  H            ; najdi dalsi povel v zozname
040E  7E              MOV  A,M
040F  B7              ORA  A            ; je to koniec tabulky ?
0410  CA 0451         JZ   0451         ; ano, skoc dopredu
0413  B8              CMP  B            ; je to koniec povelu ?
0414  C2 040D         JNZ  040D         ; nie, hladaj dalej
0417  23              INX  H            ; posun na dalsi povel v zozname
0418  C3 0408         JMP  0408         ; skoc porovnat

041B  32 1808         STA  1808         ; uloz kod povelu
041E  E5              PUSH H            ; odpamataj adresu parametrov povelu
041F  3E C3           MVI  A,C3         ; JMP - skok na rutinu parsovania
0421  32 180F         STA  180F         ; ciselneho parametra
0424  21 046B         LXI  H,046B       ; rutina pre prevod desiatkoveho cisla
0427  13              INX  D            ; posun ukazatel v buffri
0428  1A              LDAX D            ; vezmi znak
0429  FE 44           CPI  44           ; je to 'D' - desiatkove cisla
042B  CA 0436         JZ   0436         ; ano, skoc dalej
042E  FE 48           CPI  48           ; je to 'H' - sestnastkove cisla
0430  C2 059F         JNZ  059F         ; nie, 5 - chybna syntax v COMMAND slove
0433  21 08C9         LXI  H,08C9       ; rutina pre prevod sestnastkoveho cisla
0436  22 1810         SHLD 1810         ; uloz adresu rutiny
0439  E1              POP  H            ; obnov adresu parametrov povelu
043A  23              INX  H            ; posun ukazatele
043B  13              INX  D
043C  7E              MOV  A,M          ; vezmi parameter povelu
043D  B8              CMP  B            ; je to koniec povelu ?
043E  CA 04B9         JZ   04B9         ; ano, skoc dopredu
0441  1A              LDAX D            ; vezmi kod parametra z buffra
0442  BE              CMP  M            ; porovnaj s tabulkou
0443  C2 05AB         JNZ  05AB         ; nezhoduje sa, 9 - neukonceny COMMAND
0446  E5              PUSH H            ; odpamataj adresu tabulky
0447  C5              PUSH B            ; aj koncovu znacku
0448  CD 04BC         CALL 04BC         ; spracuj parameter
044B  C1              POP  B            ; obnov BC, HL
044C  E1              POP  H
044D  D0              RNC               ; vrat sa pri chybe
044E  C3 043A         JMP  043A         ; dalsi parameter

0451  2A 1801         LHLD 1801         ; vezmi adresu dalsich povelov
0454  CD 045D         CALL 045D         ; je to nula ?
0457  C2 0403         JNZ  0403         ; nie, najdi dalsi povel
045A  C3 05A8         JMP  05A8         ; inak, 8 - nenasiel typ sluzby

; zisti, ci je HL = 0
045D  AF              XRA  A            ; ??? a pritom stacilo
045E  BC              CMP  H            ;   MOV   A,H
045F  C0              RNZ               ;   ORA   L
0460  BD              CMP  L
0461  C9              RET


;------------------------------------------------------------------------------
; Pokracovanie po chybe.
;------------------------------------------------------------------------------
0462  32 1800         STA  1800         ; uloz kod chyby
0465  C3 076A         JMP  076A         ; a pokracuj dalej


;------------------------------------------------------------------------------
; Hluchy kod.
;------------------------------------------------------------------------------
0468  C3 076A         JMP  076A


;------------------------------------------------------------------------------
; Rutina na prevod retazca reprezentujuceho desiatkove cislo.
; Cislo moze byt dlhe max. 4 znaky z vysledku sa berie iba nizsi byte.
; Ak je cislo zapisane chybne, vyvola sa chyba 7 a CY=0
; Vstup: DE = adresa COMMAND slova
; Vystup: HL=vysledne cislo (16 bit), A=vysledne cislo (8 bit), CY=1
; Meni: vsetky
;------------------------------------------------------------------------------
046B  21 1828         LXI  H,1828       ; cielovy buffer
046E  0E 03           MVI  C,03         ; vynuluj prve 3 miesta,
0470  36 00           MVI  M,00         ; ak by bolo cislo iba z jedneho znaku
0472  23              INX  H
0473  0D              DCR  C
0474  C2 0470         JNZ  0470
0477  13              INX  D            ; posun ukazatel
0478  0E 04           MVI  C,04         ; - zbytocne
047A  13              INX  D            ; posun ukazatel
047B  1A              LDAX D            ; vezmi znak
047C  CD 05D5         CALL 05D5         ; zisti, ci je to cislo
047F  D2 05A5         JNC  05A5         ; nie je, 7 - chybna hodnota v parametri
0482  E6 0F           ANI  0F           ; odmaskuj na binarne cislo
0484  77              MOV  M,A          ; uloz cislo
0485  23              INX  H            ; posun ukazatele
0486  13              INX  D
0487  1A              LDAX D            ; vezmi znak
0488  CD 05D5         CALL 05D5         ; zisti, ci je to cislo
048B  DA 0482         JC   0482         ; ak ano, skoc ho ulozit
048E  2B              DCX  H            ; vrat sa naspat o 4 miesta
048F  2B              DCX  H
0490  2B              DCX  H
0491  2B              DCX  H
0492  0E 03           MVI  C,03         ; 3 + 1 znakov
0494  1B              DCX  D            ; vrat sa o jedno miesto
0495  D5              PUSH D            ; a odpamataj
0496  5E              MOV  E,M          ; vezmi hodnotu
0497  16 00           MVI  D,00
0499  EB              XCHG              ; a uloz do HL
049A  D5              PUSH D            ; HL = HL * 10
049B  E5              PUSH H
049C  29              DAD  H
049D  29              DAD  H
049E  D1              POP  D
049F  19              DAD  D
04A0  29              DAD  H
04A1  D1              POP  D
04A2  13              INX  D
04A3  1A              LDAX D            ; vezmi dalsiu hodnotu
04A4  85              ADD  L            ; pripocitaj
04A5  6F              MOV  L,A
04A6  7C              MOV  A,H
04A7  CE 00           ACI  00
04A9  67              MOV  H,A
04AA  0D              DCR  C            ; zniz pocitadlo
04AB  C2 049A         JNZ  049A         ; opakuj 3x
04AE  7D              MOV  A,L          ; A = nizsi byte vysledku
04AF  D1              POP  D            ; obnov ukazatel na COMMAND slovo
04B0  37              STC               ; CY=1
04B1  C9              RET               ; navrat


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
04B2  FF FF FF FF     DB   FF,FF,FF,FF
04B6  FF FF FF        DB   FF,FF,FF


;------------------------------------------------------------------------------
; Podprogram EXECUTE.
; Rutina vykona urcenu sluzbu. Podmienkou je predosle zavolanie podprogramu
; COMMAND na adrese 0400 a kod povelu na adrese 1808
; Vstup: (1808) = kod povelu
; Vystup: -
; Meni: vsetky
;------------------------------------------------------------------------------
04B9  11 1808         LXI  D,1808       ; adresa, kde je pripraveny kod povelu

;------------------------------------------------------------------------------
; Rutina spracuje prislusny povel alebo parameter COMMAND slova.
; Vstup: DE = vstupny buffer - musi ukazovat na kod povelu/parametra
; Vystup: -
; Meni: vsetky
;------------------------------------------------------------------------------
04BC  01 0000         LXI  B,0000       ; offset do "tabulky skokov"
04BF  2A 1803         LHLD 1803         ; adresa zoznamu povelov/params. do HL
04C2  1A              LDAX D            ; vezmi kod povelu/parametra
04C3  BE              CMP  M            ; porovnaj s polozkou v zozname
04C4  CA 04D1         JZ   04D1         ; je to on, skoc dopredu
04C7  0C              INR  C            ; zvys offset
04C8  7E              MOV  A,M          ; test na koniec zoznamu
04C9  B8              CMP  B
04CA  23              INX  H            ; posun ukazatel v zozname
04CB  C2 04C2         JNZ  04C2         ; nie si na konci, pokracuj
04CE  C3 05A2         JMP  05A2         ; 6 - chyba v parametri

04D1  2A 1806         LHLD 1806         ; tabulka offsetov adries rutin params.
04D4  09              DAD  B            ; pripocitaj offset
04D5  6E              MOV  L,M          ; vezmi z tabulky nizsi byte
04D6  3A 1805         LDA  1805         ; vyssi byte
04D9  67              MOV  H,A          ; do H
04DA  E9              PCHL              ; skoc na obsluhu povelu/parametra


;------------------------------------------------------------------------------
; Rutina vypocita sektor, v ktorom sa nachadza zodpovedajuci zaznam.
; Vstup: (181E) = offset zaznamu v subore
;        (1823) = velkost casti zaznamu, ktora uz bola prenesena
;        (1812) = adresa RJ daneho suboru
; Vystup: (181E) = novy offset zaznamu v subore
;         (1825) = stopa a sektor, kde sa zaznam nachadza
; Meni: vsetky
;------------------------------------------------------------------------------
04DB  2A 181E         LHLD 181E         ; offset zaznamu v subore
04DE  3A 1823         LDA  1823         ; zvys o velkost uz prenesenej casti
04E1  5F              MOV  E,A
04E2  16 00           MVI  D,00
04E4  19              DAD  D
04E5  22 181E         SHLD 181E         ; a uloz
04E8  7D              MOV  A,L          ; vypocitaj offset zaznamu od zaciatku
04E9  E6 7F           ANI  7F           ; sektora
04EB  32 1824         STA  1824         ; a uloz
04EE  2F              CMA               ; vypocitaj dlzku casti zaznamu - 1,
04EF  E6 7F           ANI  7F           ; ktora sa nachadza v jednom sektore
04F1  32 1823         STA  1823         ; uloz
04F4  7C              MOV  A,H          ; vypocitaj offset RJ v zozname
04F5  0F              RRC               ; RJ ma 1kB - 8 logickych sektorov
04F6  0F              RRC
04F7  E6 3F           ANI  3F
04F9  5F              MOV  E,A          ; uloz
04FA  29              DAD  H            ; offset zaznamu * 2
04FB  7C              MOV  A,H          ; vypocitaj "offset" log. sektora v RJ
04FC  E6 07           ANI  07
04FE  4F              MOV  C,A          ; uloz do C
04FF  2A 1812         LHLD 1812         ; adresa zoznamu RJ suboru
0502  19              DAD  D            ; pripocitaj offset
0503  6E              MOV  L,M
0504  62              MOV  H,D          ; HL = cislo RJ
0505  59              MOV  E,C          ; DE = "offset" log. sektora v RJ
0506  29              DAD  H            ; HL = HL * 8
0507  29              DAD  H
0508  29              DAD  H            ; HL = HL + DE
0509  19              DAD  D            ; HL = cislo logickeho sektora
050A  06 08           MVI  B,08         ; vypocet fyzickej stopy a sektora
050C  29              DAD  H            ;   stopa = HL / 18
050D  7C              MOV  A,H          ;   sektor = (HL MOD 18) + 1
050E  D6 12           SUI  12
0510  DA 0515         JC   0515
0513  67              MOV  H,A
0514  2C              INR  L
0515  05              DCR  B
0516  C2 050C         JNZ  050C
0519  24              INR  H            ; zvys cislo sektora (su cislovane od 1)
051A  22 1825         SHLD 1825         ; uloz vypocitane cislo stopy a sektora
051D  C9              RET


;------------------------------------------------------------------------------
; Rutina prenesie pozadovany zaznam Subor <-> IMS-2.
; Vstup: (1820) = cislo zaznamu
;        (1822) = velkost zaznamu
;        (1812) = adresa RJ daneho suboru
; Vystup: -
; Meni: vsetky
;------------------------------------------------------------------------------
051E  CD 057E         CALL 057E         ; vypocitaj offset zaznamu v subore
0521  CD 04DB         CALL 04DB         ; najdi zodpovedajuci sektor
0524  CD 032D         CALL 032D         ; nacitaj sektor
0527  C0              RNZ               ; vrat sa pri chybe
0528  2A 180B         LHLD 180B         ; adresa buffra pre fyzicky sektor
052B  16 00           MVI  D,00
052D  3A 1824         LDA  1824         ; offset zaznamu od zaciatku sektora
0530  5F              MOV  E,A          ; pripocitaj
0531  19              DAD  D
0532  EB              XCHG              ; uloz do DE
0533  2A 180D         LHLD 180D         ; HL = adresa do IMS-2 buffra
0536  3A 1822         LDA  1822         ; dlzka zaznamu
0539  00              NOP
053A  4F              MOV  C,A          ; do C
053B  CD 180F         CALL 180F         ; urob prislusny prenos
053E  C0              RNZ               ; vrat sa pri chybe
053F  2A 1822         LHLD 1822         ; L = velkost zazn., H = prenesene - 1
0542  24              INR  H            ; + 1
0543  7D              MOV  A,L          ; vypocitaj velkost zostavajucej casti
0544  A7              ANA  A            ; zbytocne
0545  94              SUB  H            ; odpocitaj uz prenesenu cast
0546  C8              RZ                ; vrat sa, ak uz bol cely zaznam
0547  D8              RC
0548  6F              MOV  L,A          ; uloz zostavavajucu dlzku zaznamu
0549  22 1822         SHLD 1822
054C  C3 0521         JMP  0521         ; opakuj pre zbytok zaznamu


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
054F  FF              DB   FF


;------------------------------------------------------------------------------
; Presun dat zo sektoroveho buffra do IMS-2 buffra
; Vstup: DE = adresa vstupneho sektoroveho buffra
;        HL = adresa vystupneho IMS-2 buffra
;        C = dlzka data
; Vystup: (180D) = nova adresa do IMS-2 buffra
;------------------------------------------------------------------------------
0550  1A              LDAX D            ; vezmi byte zo vstupneho buffra
0551  77              MOV  M,A          ; uloz do vystupneho IMS-2 buffra
0552  2C              INR  L            ; posun ukazatel vyst. buffra
0553  22 180D         SHLD 180D         ; uloz adresu
0556  CA 0560         JZ   0560         ; koniec vyst. buffra ? Ano, skoc.
0559  1C              INR  E            ; posun ukazatel vst. buffra
055A  C8              RZ                ; vrat sa na konci vst. buffra
055B  0D              DCR  C            ; zniz pocitadlo
055C  C2 0550         JNZ  0550         ; opakuj
055F  3E              DB   3E           ; MVI A,n - preskoc POP AF
0560  F1              POP  PSW          ; zahod navratovu adresu
0561  C9              RET


;------------------------------------------------------------------------------
; Presun dat z IMS-2 buffra do sektoroveho buffra.
; Vstup: DE = adresa vystupneho sektoroveho buffra
;        HL = adresa vstupneho IMS-2 buffra
;        C = dlzka data
; Vystup: (180D) = nova adresa do IMS-2 buffra
;------------------------------------------------------------------------------
0562  7E              MOV  A,M          ; vezmi byte zo vstupneho IMS-2 buffra
0563  12              STAX D            ; uloz do vystupneho buffra
0564  2C              INR  L            ; posun ukazatel vst. buffra
0565  22 180D         SHLD 180D         ; uloz adresu
0568  CA 0574         JZ   0574         ; koniec vst. buffra ? Ano, skoc.
056B  1C              INR  E            ; posun ukazatel vyst. buffra
056C  CA 0575         JZ   0575         ; koniec vyst. buffra ? Ano, skoc.
056F  0D              DCR  C            ; zniz pocitadlo
0570  C2 0562         JNZ  0562         ; opakuj
0573  3E              DB   3E           ; MVI A,n - preskoc POP AF
0574  F1              POP  PSW          ; zahod navratovu adresu
0575  21 0714         LXI  H,0714       ; adresa rutiny pre zapis sektora
0578  22 1809         SHLD 1809         ; uloz
057B  C3 074A         JMP  074A         ; a vrat sa cez ulozenie sektora


;------------------------------------------------------------------------------
; Rutina vypocita offset zaznamu v subore.
; Vstup: (1820) = cislo zaznamu
;        (1822) = velkost zaznamu
; Vystup: (181E) = HL = logicky offset
;         A = C = 0, DE = cislo zaznamu
;         (1823) = 0 - ziadna cast zaznamu este nebola prenesena
; Meni: HL, DE, C, AF
;------------------------------------------------------------------------------
057E  AF              XRA  A            ; ziadna cast zaznamu
057F  32 1823         STA  1823         ; este nebola prenesena

;------------------------------------------------------------------------------
; Rutina vynasobi 16. bitove a 8. bitove cislo.
; Vstup: (1820) = 16. bitovy cinitel
;        (1822) = 8. bitovy cinitel
; Vystup: A = C = 0, DE = 1.cinitel
;         (181E) = HL = vysledok
; Meni: HL, DE, C, AF
;------------------------------------------------------------------------------
0582  2A 1820         LHLD 1820         ; HL = 1. cinitel
0585  3A 1822         LDA  1822         ; A = 2. cinitel
0588  EB              XCHG              ; DE = 1. cinitel
0589  21 0000         LXI  H,0000       ; vynuluj vysledok
058C  0E 08           MVI  C,08         ; 8 radov ma druhy cinitel
058E  A7              ANA  A            ; CY = 0
058F  17              RAL               ; pripocitat rad
0590  D2 0596         JNC  0596         ; nie, skoc dalej
0593  19              DAD  D            ; pripocitaj rad
0594  CE 00           ACI  00           ; inkrementuj 2. cinitel pri preteceni
0596  0D              DCR  C            ; zniz pocitadlo
0597  22 181E         SHLD 181E         ; uloz vysledok
059A  C8              RZ                ; a vrat sa, ak si presiel vsetky rady
059B  29              DAD  H            ; zdvojnasob vysledok
059C  C3 058F         JMP  058F         ; opakuj pre dalsi rad


;------------------------------------------------------------------------------
; Chybove "rozskoky".
;------------------------------------------------------------------------------
059F  3E 05           MVI  A,05         ; 5 - chybna syntax v COMMAND slove
05A1  21              DB   21
05A2  3E 06           MVI  A,06         ; 6 - chyba v parametri
05A4  21              DB   21
05A5  3E 07           MVI  A,07         ; 7 - chybna hodnota v parametri
05A7  21              DB   21
05A8  3E 08           MVI  A,08         ; 8 - nenasiel typ sluzby
05AA  21              DB   21
05AB  3E 09           MVI  A,09         ; 9 - neukonceny COMMAND
05AD  21              DB   21
05AE  3E 0A           MVI  A,0A         ; 10 - disk plny
05B0  21              DB   21
05B1  3E 0B           MVI  A,0B         ; 11 - nie je otvoreny subor
05B3  21              DB   21
05B4  3E 0C           MVI  A,0C         ; 12 - chyba nazvu suboru al. duplicita
05B6  21              DB   21
05B7  3E 0D           MVI  A,0D         ; 13 - parameter mimo rozsah
05B9  21              DB   21
05BA  3E 0E           MVI  A,0E         ; 14 - subor utajeny - nevyuzite
05BC  21              DB   21
05BD  3E 0F           MVI  A,0F         ; 15 - chyba v type suboru
05BF  21              DB   21
05C0  3E 10           MVI  A,10         ; 16 - nevyuzite
05C2  21              DB   21
05C3  3E 11           MVI  A,11         ; 17 - katalog je zaplneny
05C5  C3 0462         JMP  0462


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
05C8  FF              DB   FF


;------------------------------------------------------------------------------
; Rutina presunie kod diskovej sluzby do RAM na adresu 1828 z dovodu potreby
; modifikovat parametre sluzby.
; vstup: B = pocet, HL = zdrojova adresa
; vystup: B = 0, Z = 1
; meni: HL, DE, B, AF
;------------------------------------------------------------------------------
05C9  11 1828         LXI  D,1828

;------------------------------------------------------------------------------
; Podprogram MOVE - zabezpecuje presun dat
; vstup: B = pocet, HL = zdrojova adresa, DE = cielova adresa
; vystup: B = 0, Z = 1
; meni: HL, DE, B, AF
;------------------------------------------------------------------------------
05CC  7E              MOV  A,M
05CD  12              STAX D
05CE  05              DCR  B
05CF  23              INX  H
05D0  13              INX  D
05D1  C2 05CC         JNZ  05CC
05D4  C9              RET


;------------------------------------------------------------------------------
; Test na ciselny znak - '0' az '9'.
; vstup: A = testovany znak
; vystup: CY = 1 - v A je ciselny znak
;         CY = 0 - v A je neciselny znak
; meni: PSW
;------------------------------------------------------------------------------
05D5  FE 3A           CPI  3A
05D7  D0              RNC
05D8  FE 30           CPI  30
05DA  3F              CMC
05DB  C9              RET


;------------------------------------------------------------------------------
; Rutina pre odoslanie povelu do FDC. Data su ulozene za volanim rutiny.
; 1. byte je povel, 2. byte je pocet parametrov, 3. byte atd. su parametre
; Vstup: data povelu za volanim rutiny
; Vystup: -
; Meni: AF, B
;------------------------------------------------------------------------------
05DC  DB EC           IN   EC           ; otestuj pristup ku COMMAND registru
05DE  E6 A0           ANI  A0
05E0  C2 05DC         JNZ  05DC
05E3  E3              XTHL              ; do HL adresu parametrov
05E4  7E              MOV  A,M          ; POVEL byte
05E5  D3 EC           OUT  EC           ; do FDC
05E7  23              INX  H            ; posun ukazatel
05E8  46              MOV  B,M          ; pocet parametrov
05E9  23              INX  H            ; posun ukazatel
05EA  DB EC           IN   EC           ; otestuj pristup ku PARAMETER registru
05EC  E6 20           ANI  20
05EE  C2 05EA         JNZ  05EA
05F1  7E              MOV  A,M          ; parameter
05F2  D3 ED           OUT  ED           ; do FDC
05F4  05              DCR  B            ; dalsi paramater ?
05F5  C2 05E9         JNZ  05E9
05F8  23              INX  H            ; posun ukazatel
05F9  E3              XTHL
05FA  C9              RET


;------------------------------------------------------------------------------
; Inicializacia FDC.
; Vstup: -
; Vystup: -
; Meni: AF, B
;------------------------------------------------------------------------------
05FB  CD 05DC         CALL 05DC         ; SPECIFY COMMAND - Initialization
05FE  35 04 0D 0F     DB   35,04,0D,0F
0602  14 8C           DB   14,8C
0604  CD 05DC         CALL 05DC         ; SPECIFY COMMAND - Load Bad Tracks
0607  35 04 10 FF     DB   35,04,10,FF  ;   Surface '0'
060B  FF FF           DB   FF,FF
060D  00              NOP
060E  00              NOP
060F  CD 05DC         CALL 05DC         ; SEEK COMMAND
0612  29 01 00        DB   29,01,00     ; stopa = 0
0615  FB              EI                ; vrat sa cez prerusenie a citanie
0616  C3 0616         JMP  0616         ; stavoveho slova


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0619  FF FF FF FF     DB   FF,FF,FF,FF
061D  FF FF FF FF     DB   FF,FF,FF,FF
0621  FF              DB   FF


;------------------------------------------------------------------------------
; 'T' - stopa - pokracovanie
; Vstup: DE = adresa vstupneho buffra
; Vystup: (1825) = cislo stopy
; Meni vsetky
;------------------------------------------------------------------------------
0622  FE 28           CPI  28           ; cislo stopy 0 az 39
0624  D2 05B7         JNC  05B7         ; 13 - parameter mimo rozsah
0627  32 1825         STA  1825         ; uloz cislo stopy
062A  C9              RET


;------------------------------------------------------------------------------
; Sluzba READ SECTOR
; Vstup: (1825) = cislo stopy
;        (1826) = cislo sektoru
; Vystup: Z = 1, OK
;         Z = 0, A = kod chyby
; Meni: vsetky
;------------------------------------------------------------------------------
062B  CD 076F         CALL 076F         ; zisti, ci je sektor nacitany
                                        ; ak nie, HL = 0640 - rutina READ SEC.

;------------------------------------------------------------------------------
; Sluzba READ/WRITE SECTOR
; Vstup: HL = adresa rutiny Read/Write, ktora sa prenesie do RAM
;        (1825) = cislo stopy
;        (1826) = cislo sektoru
; Vystup: Z = 1, OK
;         Z = 0, A = kod chyby
; Meni: vsetky
;------------------------------------------------------------------------------
062E  06 0B           MVI  B,0B         ; dlzka rutiny 11 bytov
0630  CD 05C9         CALL 05C9         ; prenes do RAM
0633  2A 180B         LHLD 180B         ; adresa cieloveho buffru do DE
0636  EB              XCHG
0637  2A 1825         LHLD 1825         ; stopa, sektor
063A  22 182D         SHLD 182D         ; do FDC povelu
063D  C3 1828         JMP  1828         ; vykonaj FDC povel

; kod pre FDC povel
0640  CD 05DC         CALL 05DC         ; odosli do FDC
0643  16 02 00 01     DB   16,02,00,01  ; COMMAND - Read data and deleted data
0647  FB              EI                ; povol prerusenie
0648  C3 064B         JMP  064B         ; skoc precitat sektor

; citanie sektoru
064B  DB BF           IN   BF           ; ???
064D  DB DD           IN   DD           ; otestuj DRQ
064F  1F              RAR               ; je "pripraveny" byte ?
0650  D2 064D         JNC  064D
0653  DB BF           IN   BF           ; citaj byte z FDC
0655  12              STAX D            ; uloz do pamati
0656  13              INX  D            ; posun ukazatel
0657  C3 064D         JMP  064D         ; opakuj pre cely sektor


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
065A  FF FF FF FF     DB   FF,FF,FF,FF
065E  FF FF FF FF     DB   FF,FF,FF,FF
0662  FF              DB   FF


;------------------------------------------------------------------------------
; Sluzba WRITE SECTOR
; Vstup: (1825) = cislo stopy
;        (1826) = cislo sektoru
; Vystup: Z = 1, OK
;         Z = 0, A = kod chyby
; Meni: vsetky
;------------------------------------------------------------------------------
0663  21 0669         LXI  H,0669
0666  C3 062E         JMP  062E

; kod pre FDC povel
0669  CD 05DC         CALL 05DC         ; COMMAND - Write data
066C  0A 02 00 01     DB   0A,02,00,01  ; stopa = 0, sektor = 1
0670  FB              EI
0671  C3 0674         JMP  0674

; zapis sektoru
0674  DB BF           IN   BF           ; ???
0676  DB DD           IN   DD           ; otestuj DRQ
0678  1F              RAR               ; je volne FDC ?
0679  D2 0676         JNC  0676
067C  1A              LDAX D            ; byte z pamati
067D  D3 BF           OUT  BF           ; posli do FDC
067F  13              INX  D            ; posun ukazatel
0680  C3 0676         JMP  0676         ; opakuj pre cely sektor


;------------------------------------------------------------------------------
; Rutina pripravi adresu obsluznej rutiny
;------------------------------------------------------------------------------
0683  3E 80           MVI  A,80         ; flag - budu sa posielat data
0685  21 0937         LXI  H,0937       ; adresa obsluznej rutiny
0688  22 1810         SHLD 1810         ; uloz
068B  C9              RET


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
068C  FF FF           DB   FF,FF


;------------------------------------------------------------------------------
; Rutina pre sformatovanie diskety.
; Vstup: -
; Vystup: Z=1 - OK, Z=0 - chyba
; Meni: vsetky
;------------------------------------------------------------------------------
068E  06 48           MVI  B,48         ; priprav ID pole pre kazdy sektor
0690  2A 180B         LHLD 180B         ; ID pole ma 4 byty
0693  36 00           MVI  M,00         ; 0. cylinder, 1. hlava,
0695  23              INX  H            ; 2. sektor, 3. velkost sektora
0696  05              DCR  B
0697  C2 0693         JNZ  0693         ; najprv vsetko vynuluj
069A  01 06DF         LXI  B,06DF       ; zoznam cisel sektorov
069D  23              INX  H
069E  23              INX  H
069F  11 FFFC         LXI  D,FFFC       ; DE = -4 - ukladame odzadu
06A2  19              DAD  D
06A3  0A              LDAX B            ; vezmi cislo sektoru z tabulky
06A4  3D              DCR  A            ; ak je to koniec tabulky
06A5  CA 06AD         JZ   06AD         ; skoc dalej
06A8  77              MOV  M,A          ; uloz cislo sektoru
06A9  03              INX  B
06AA  C3 06A2         JMP  06A2
; poradie sektorov na stope
; 1, 6, 11, 15, 2, 7, 12, 16, 3, 8, 13, 17, 4, 9, 14, 18, 5, 10

06AD  6F              MOV  L,A          ; cislo stopy
06AE  26 0B           MVI  H,0B
06B0  22 1825         SHLD 1825
06B3  21 06F2         LXI  H,06F2       ; adresa FDC povelu Format Track
06B6  06 0E           MVI  B,0E         ; dlzka FDC povelu 14 bytov
06B8  CD 0630         CALL 0630         ; formatuj stopu
06BB  C0              RNZ               ; vrat sa pri chybe
06BC  3E 01           MVI  A,01         ; zbytocne
06BE  32 1826         STA  1826
06C1  00              NOP
06C2  00              NOP
06C3  00              NOP
06C4  00              NOP
06C5  06 12           MVI  B,12         ; vo vsetkych ID poliiach sektorov
06C7  2A 180B         LHLD 180B
06CA  34              INR  M            ; zvys cislo cylindra (stopy)
06CB  23              INX  H
06CC  23              INX  H
06CD  23              INX  H
06CE  23              INX  H
06CF  05              DCR  B
06D0  C2 06CA         JNZ  06CA
06D3  3A 1825         LDA  1825         ; zvys cislo stopy
06D6  3C              INR  A
06D7  FE 28           CPI  28           ; 40 stop
06D9  C2 06AD         JNZ  06AD
06DC  C3 05FB         JMP  05FB         ; vrat sa cez inicializaciu FDC

;------------------------------------------------------------------------------
; Zoznam cisel sektorov pre format - v obratenom poradi.
; Hodnoty su vacsie o 1.
;------------------------------------------------------------------------------
06DF  0B 06 13 0F     DB   0B,06,13,0F  ; 10,5,18,14
06E3  0A 05 12 0E     DB   0A,05,12,0E  ; 9,4,17,13
06E7  09 04 11 0D     DB   09,04,11,0D  ; 8,3,16,12
06EB  08 03 10 0C     DB   08,03,10,0C  ; 7,2,15,11
06EF  07 02 01        DB   07,02,01     ; 6,1 - 0 - ukoncenie tabulky

;------------------------------------------------------------------------------
; FDC povel Format Track
;------------------------------------------------------------------------------
06F2  CD 05DC         CALL 05DC         ; COMMAND - Format Track
06F5  23 05 00 0B     DB   23,05,00,0B  ; Track 0
06F9  12 00 10        DB   12,00,10     ; 18 - 128 bytovych sektorov na stopu
06FC  FB              EI
06FD  C3 0674         JMP  0674


;------------------------------------------------------------------------------
; Obsluha 'E' - vymazanie z katalogu
;------------------------------------------------------------------------------
0700  CD 0399         CALL 0399         ; vyhladaj subor a priprav zoznam RJ
0703  C3 0068         JMP  0068         ; skoc dalej


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0706  FF FF           DB   FF,FF


;------------------------------------------------------------------------------
; FDC povel Verify data and deleted data
;------------------------------------------------------------------------------
0708  CD 05DC         CALL 05DC         ; COMMAND - Verify data and deleted data
070B  1F 03 00 01     DB   1F,03,00,01  ; stopa = 0, sektor = 1
070F  12              DB   12           ; 18 - 128 bytovych sektorov na stope
0710  FB              EI
0711  C3 0674         JMP  0674

;------------------------------------------------------------------------------
; Zapis sektora
;------------------------------------------------------------------------------
0714  C3 0663         JMP  0663         ; Zapis sektor


;------------------------------------------------------------------------------
; FDC povel Verify data and deleted data - nepouzite
;------------------------------------------------------------------------------
0717  21 071D         LXI  H,071D
071A  C3 0666         JMP  0666


;------------------------------------------------------------------------------
; FDC povel Verify data and deleted data - nepouzite
;------------------------------------------------------------------------------
071D  CD 05DC         CALL 05DC         ; COMMAND - Verify data and deleted data
0720  1E 02 00 01     DB   1E,02,00,01  ; stopa = 0, sektor = 1
0724  FB              EI
0725  C3 1830         JMP  1830         ; skok do neznama - ???


;------------------------------------------------------------------------------
; Rutina precita FDC STATUS register.
; Vstup: -
; Vystup: A = negovany FDC STATUS
; Meni: AF
;------------------------------------------------------------------------------
0728  DB EC           IN   EC           ; otestuj pristup ku COMMAND registru
072A  E6 A0           ANI  A0
072C  C2 0728         JNZ  0728
072F  3E 2C           MVI  A,2C         ; POVEL: READ DRIVE STATUS
0731  D3 EC           OUT  EC           ; posli do FDC
0733  DB EC           IN   EC           ; otestuj pristup k RESULT registru
0735  E6 10           ANI  10
0737  CA 0733         JZ   0733
073A  DB ED           IN   ED           ; precitaj vysledok povelu
073C  2F              CMA               ; a zneguj ho
073D  C9              RET


;------------------------------------------------------------------------------
; Obsluha prerusenia.
; Prerusenie je vyvolane radicom po ukonceni povelu.
; Rutina zabezpeci navrat do podprogramu, ktory vyvolal vykonanie FDC povelu.
; Zaroven ulozi na adresu 1800 (bity 1:0) obsah FDC RESULT registra (bity 4:3)
; COMPLETION TYPE - 0 = OK
;                   1 = chyba pri snimani dat, CRC...
;                   2 = chyba na mechanike disku (otvorene dvierka)
;                   3 = nenajdeny sektor, stopa
; Vstup: -
; Vystup: (1800) = Result
; Meni: AF
;------------------------------------------------------------------------------
073E  F1              POP  PSW          ; zahod navratovu adresu z prerusenia
073F  DB ED           IN   ED           ; precitaj RESULT register FDC
0741  1F              RAR               ; presun typ vysledku do dolnych bitov
0742  1F              RAR
0743  1F              RAR
0744  E6 03           ANI  03           ; odmaskuj
0746  32 1800         STA  1800         ; uloz
0749  C9              RET               ; a vrat sa do volajuceho podprogramu


;------------------------------------------------------------------------------
; Podprogram DISK vykona diskovu operaciu, ktorej adresa podprogramu je ulozena
; na adrese 1809.
; Vstup: (1809) = adresa podprogramu diskovej sluzby
;        dalsie parametre v zapisniku systemu potrebne pre vykonanie sluzby
; Vystup: A = RESULT
;         (1839) = aktualizovane aktualne stopa a sektor
; Meni: vsetky
;------------------------------------------------------------------------------
074A  0E 0A           MVI  C,0A         ; 10 pokusov
074C  CD 0728         CALL 0728         ; precitaj FDC STATUS
074F  C5              PUSH B            ; odpamataj pocitadlo pokusov
0750  21 0758         LXI  H,0758       ; navratovu adresu zo sluzby
0753  E5              PUSH H            ; na zasobnik
0754  2A 1809         LHLD 1809         ; adresa sluzby do HL
0757  E9              PCHL              ; skoc vykonat pozadovanu sluzbu

; navrat zo sluzby
0758  C1              POP  B            ; obnov pocitadlo pokusov
0759  CA 0784         JZ   0784         ; skoc dopredu ak, je vsetko OK
075C  FE 02           CPI  02           ; ak je to chyba typu Drive Not Ready
075E  CA 076A         JZ   076A         ; a pod., skoc dopredu
0761  0D              DCR  C            ; inak zniz pocitadlo opakovani
0762  C2 074F         JNZ  074F         ; a opakuj
0765  00              NOP
0766  00              NOP
0767  00              NOP
0768  00              NOP
0769  00              NOP               ; sluzbu sa nepodarilo vykonat
076A  26 00           MVI  H,00         ; "zneplatni" aktualnu stopu
076C  C3 0787         JMP  0787


;------------------------------------------------------------------------------
; Rutina porovna pozadovane a aktualne cislo stopy a sektora.
; Vstup: (1825) = cislo pozadovanej stopy
;        (1826) = cislo pozadovaneho sektoru
;        (1839) = cislo aktualnej stopy
;        (183A) = cislo aktualneho sektoru
; Vystup: ak su zhodne - A = 0, Z = 1, navrat do rutiny, o uroven vyssie
;         ak nie su zhodne - Z = 0, HL = 0640
; Meni: AF, HL, SP
;------------------------------------------------------------------------------
076F  2A 1825         LHLD 1825         ; pozadovana stopa a sektor
0772  EB              XCHG              ; do DE
0773  2A 1839         LHLD 1839         ; aktualna stopa a sektor
0776  7D              MOV  A,L          ; porovnaj cisla stop
0777  BB              CMP  E
0778  C2 077D         JNZ  077D         ; ak nie su rovnake, skoc dalej
077B  7C              MOV  A,H          ; porovnaj cisla sektorov
077C  BA              CMP  D
077D  21 0640         LXI  H,0640       ; adresa povelu READ DATA
0780  C0              RNZ               ; vrat sa, ak nie su zhodne
0781  AF              XRA  A
0782  E1              POP  H            ; zahod navratovu adresu
0783  C9              RET


;------------------------------------------------------------------------------
; Ukoncenie podprogramu DISK
;------------------------------------------------------------------------------
0784  2A 1825         LHLD 1825         ; skopiruj pozadovanu stopu a sektor
0787  22 1839         SHLD 1839         ; do aktualnych
078A  C9              RET


;------------------------------------------------------------------------------
; Zoznam kodov parametrov a povelov.
;------------------------------------------------------------------------------
078B  54              DB   'T'          ; stopa
078C  53              DB   'S'          ; sektor
078D  24              DB   '$'          ; cislo zaznamu
078E  27              DB   ''''         ; nazov suboru
078F  40              DB   '@'          ; dlzka zaznamu
0790  26              DB   '&'          ; adresa
0791  23              DB   '#'          ; cislo otvoreneho suboru
0792  57              DB   'W'          ; zapis na fyzicky sektor
0793  52              DB   'R'          ; citanie z fyzickeho sektoru
0794  50              DB   'P'          ; zapis na logicky sektor
0795  49              DB   'I'          ; citanie z logickeho sektora
0796  43              DB   'C'          ; vytvorenie datoveho suboru
0797  55              DB   'U'          ; uzatvorenie suboru
0798  46              DB   'F'          ; formatovanie diskety
0799  01              DB   01           ; pokracovanie 'W' a 'R'
079A  02              DB   02           ; pokracovanie 'P' a 'I'
079B  03              DB   03           ; binarne citanie/zapis - 'Z', 'L'
079C  21              DB   '!'          ; kontrola parametrov
079D  4F              DB   'O'          ; otvorenie datoveho suboru
079E  41              DB   'A'          ; uzatvorenie vsetkych suborov
079F  47              DB   'G'          ; citanie z operacnej pamati
07A0  4A              DB   'J'          ; skok na podprogram
07A1  45              DB   'E'          ; vymazanie z katalogu
07A2  4C              DB   'L'          ; citanie binarnych dat
07A3  2A              DB   '*'          ; typ suboru
07A4  4D              DB   'M'          ; zapis do operacnej pamati
07A5  04              DB   04           ; pokr./ukoncenie 'D'
07A6  44              DB   'D'          ; citanie katalogu
07A7  4E              DB   'N'          ; citanie nazvu diskety
07A8  5A              DB   'Z'          ; zapis binarnych dat
07A9  05              DB   05           ; ukoncenie povelov
07AA  42              DB   'B'          ; utajenie suboru v katalogu
07AB  48              DB   'H'          ; vyhladanie slova v subore
07AC  06              DB   06           ; pokr. vyhl. sl. v subore
07AD  FF FF FF        DB   FF,FF,FF

;------------------------------------------------------------------------------
; Zoznam povelov a ich parametrov.
;------------------------------------------------------------------------------
07B0  00 0D           DB   00,0D
07B2  57 54 53 40     DB   'WTS@*',0D   ; zapis na fyzicky sektor
07B6  2A 0D
07B8  52 54 53 40     DB   'RTS@*',0D   ; citanie z fyzickeho sektora
07BC  2A 0D
07BE  50 23 24 21     DB   'P#$!',0D    ; zapis na logicky sektor
07C2  0D
07C3  49 23 24 21     DB   'I#$!',0D    ; citanie z logickeho sektora
07C7  0D
07C8  43 27 24 40     DB   'C''$@*',0D  ; vytvorenie suboru
07CC  2A 0D
07CE  55 23 0D        DB   'U#',0D      ; uzatvorenie suboru
07D1  46 27 0D        DB   'F''',0D     ; formatovanie diskety
07D4  4F 27 23 0D     DB   'O''#',0D    ; otvorenie suboru
07D8  47 26 40 0D     DB   'G&@',0D     ; citanie dat z ram
07DC  41 0D           DB   'A',0D       ; uzatvorenie vsetkych suborov
07DE  4A 26 0D        DB   'J&',0D      ; skok na podprogram
07E1  45 27 0D        DB   'E''',0D     ; vymazanie z katalogu (suboru)
07E4  4D 26 40 0D     DB   'M&@',0D     ; zapis do RAM
07E8  44 0D           DB   'D',0D       ; citanie katalogu
07EA  4E 0D           DB   'N',0D       ; citanie nazvu diskety
07EC  5A 27 24 2A     DB   'Z''$*',0D   ; zapis binarny
07F0  0D
07F1  4C 27 2A 0D     DB   'L''*',0D    ; citanie binarne
07F5  42 27 0D        DB   'B''',0D     ; utajenie suboru
07F8  48 23 24 40     DB   'H#$@',0D    ; hladanie v subore
07FC  0D
07FD  FF 0D           DB   FF,0D
07FF  00              DB   00


;------------------------------------------------------------------------------
; Obsluha povelu 'D'.
;------------------------------------------------------------------------------
0800  3E 04           MVI  A,04         ; novy kod povelu pre katalog disku

;------------------------------------------------------------------------------
; Obsluha povelu 'N'
;------------------------------------------------------------------------------
0802  CD 0912         CALL 0912         ; nastav kod povelu a typ suboru 'D'
0805  3E 07           MVI  A,07         ; cislo prvej polozky adresara - 1
0807  32 183E         STA  183E         ; uloz
080A  3E 0C           MVI  A,0C
080C  32 1822         STA  1822
080F  21 1A78         LXI  H,1A78       ; adresa buffra pre IMS-2
0812  22 180D         SHLD 180D
0815  21 0100         LXI  H,0100       ; stopa = 0, sektor = 1
0818  22 1825         SHLD 1825
081B  21 1A00         LXI  H,1A00       ; nacitaj sektor s alokacnou mapou
081E  CD 032A         CALL 032A         ; a menom disku na adresu 1A00
0821  C0              RNZ               ; vrat sa pri chybe
0822  21 1A02         LXI  H,1A02       ; spocitame volnych RJ
0825  0E 00           MVI  C,00         ; vynuluj pocet
0827  7E              MOV  A,M          ; vezmi byte z alokacnej mapy
0828  B7              ORA  A            ; ak je to 0 - volna RJ,
0829  CC 08DD         CZ   08DD         ; zvys pocet volnych RJ
082C  23              INX  H            ; posun na dalsiu polozku
082D  7D              MOV  A,L
082E  FE 5A           CPI  5A           ; max. 78 RJ (90 - 2)
0830  C2 0827         JNZ  0827
0833  79              MOV  A,C          ; pocet volnych RJ do A
0834  21 1A80         LXI  H,1A80       ; adresa kam sa prevedie cislo
0837  36 20           MVI  M,20         ; najprv medzera
0839  23              INX  H
083A  11 2B2B         LXI  D,2B2B       ; ???
083D  CD 0A01         CALL 0A01         ; preved cislo
0840  C3 093B         JMP  093B         ; skoc nast. priznak - pripravene data


;------------------------------------------------------------------------------
; Rutina prevedie inicializaciu FDC a vynuluje oblasti OPEN bufferu.
; Vstup: -
; Vystup: -
; Meni: AF, B
;------------------------------------------------------------------------------
0843  CD 05FB         CALL 05FB         ; preved inicializaciu FDC
0846  C3 01B3         JMP  01B3         ; vrat sa cez zmazanie OPEN buffra


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0849  FF FF FF        DB   FF,FF,FF


;------------------------------------------------------------------------------
; Parameter '!' - kontrola parametrov povelov 'P', 'I' a 'H' - pokracovanie
; Vstup: (1812) = adresa polozky OPEN buffra
;        (1820) = pozadovane cislo zaznamu
; Vystup: (1812) = ukazatel na rozmiestnovacie jednotky suboru
; Meni: HL, BC, AF
;------------------------------------------------------------------------------
084C  D2 05B7         JNC  05B7         ; 13 - parameter mimo rozsah
084F  C9              RET


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0850  FF FF FF        DB   FF,FF,FF


;------------------------------------------------------------------------------
; Rutina prevedie jeden rad cisla v akumulatore do ASCII formy.
; Vstup: A = prevadzane cislo
;        B = rad
;        HL = adresa kam sa ulozi vysledok
; Vystup: A = zostatok
;         HL = nasledujuca adresa
; Meni: AF, HL
;------------------------------------------------------------------------------
0853  36 30           MVI  M,30         ; uloz '0'
0855  90              SUB  B            ; odpocitaj rad
0856  DA 08DA         JC   08DA         ; ak doslo k preteceniu, skoc dopredu
0859  34              INR  M            ; zvys cislo
085A  C3 0855         JMP  0855         ; opakuj


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
085D  3A 3E           DB  3A,3E


;------------------------------------------------------------------------------
; Povel 04 - pokracovanie/ukoncenie povelu 'D'
;------------------------------------------------------------------------------
085F  3A 183E         LDA  183E         ; vezmi cislo polozky adresara
0862  3C              INR  A            ; posun na dalsiu
0863  32 183E         STA  183E         ; uloz novu hodnotu
0866  1F              RAR               ; vypocitaj cislo sektora
0867  1F              RAR
0868  E6 3F           ANI  3F
086A  FE 11           CPI  11           ; presiel si uz vsetky sektory adresara?
086C  CA 08BA         JZ   08BA         ; ano, skoc dopredu
086F  32 1826         STA  1826         ; uloz cislo sektoru
0872  CD 032D         CALL 032D         ; precitaj sektor
0875  C0              RNZ               ; vrat sa pri chybe
0876  3A 183E         LDA  183E         ; vezmi cislo polozky adresara
0879  E6 03           ANI  03           ; vypocitaj poziciu polozky v sektore
087B  3C              INR  A            ; uprav rozsah na 1 az 4
087C  21 1960         LXI  H,1960       ; buffer sektora - 20h
087F  11 0020         LXI  D,0020       ; najdi pozadovanu polozku
0882  19              DAD  D
0883  3D              DCR  A
0884  C2 0882         JNZ  0882
0887  4E              MOV  C,M          ; priznak utajenia suboru do C
0888  23              INX  H            ; posun ukazatel
0889  22 180D         SHLD 180D         ; a uloz ako adresu buffra pre IMS-2
088C  11 0008         LXI  D,0008       ; dlzka mena suboru
088F  19              DAD  D            ; preskoc
0890  7E              MOV  A,M          ; vezmi typ suboru
0891  FE 45           CPI  45           ; je to 'E' zmazany subor ?
0893  CA 085F         JZ   085F         ; ano, chod pre dalsiu polozku
0896  FE FF           CPI  FF           ; je to FF - zaznam o "dlhom subore" ?
0898  CA 085F         JZ   085F         ; ano, chod pre dalsiu polozku
089B  B7              ORA  A            ; je to volna polozka - koniec katalogu?
089C  CA 08BA         JZ   08BA         ; ano, skoc dopredu
089F  23              INX  H            ; posun ukazatel
08A0  36 20           MVI  M,20         ; zapis medzeru
08A2  23              INX  H            ; posun ukazatel na pocet RJ
08A3  23              INX  H
08A4  7E              MOV  A,M          ; vezmi pocet RJ
08A5  2B              DCX  H            ; vrat sa 1 nazad
08A6  CD 0A12         CALL 0A12         ; preved cislo
08A9  0D              DCR  C            ; ak subor nie je utajeny
08AA  0C              INR  C
08AB  C8              RZ                ; vrat sa
08AC  2A 180D         LHLD 180D         ; utajeny subor sa zobrazuje
08AF  00              NOP
08B0  06 08           MVI  B,08         ; ako 8 hviezdiciek
08B2  36 2A           MVI  M,2A         ; '*'
08B4  23              INX  H
08B5  05              DCR  B
08B6  C2 08B2         JNZ  08B2
08B9  C9              RET

08BA  21 092A         LXI  H,092A       ; text pre koniec katalogu
08BD  22 180D         SHLD 180D
08C0  CD 076A         CALL 076A         ; zneplatni aktualnu stopu
08C3  C3 016F         JMP  016F         ; ukonci povel 'D'


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
08C6  FF FF FF        DB   FF,FF,FF


;------------------------------------------------------------------------------
; Rutina na prevod retazca reprezentujuceho sestnastkove cislo.
; Cislo musi byt dlhe presne 4 znaky.
; Ak je cislo zapisane chybne, vyvola sa chyba 7 a CY=0
; Vstup: DE = adresa COMMAND slova
; Vystup: HL=vysledne cislo, CY=1
; Meni: AF, B, DE, HL
;------------------------------------------------------------------------------
08C9  CD 08DF         CALL 08DF         ; preved prve dva znaky
08CC  DA 08D6         JC   08D6         ; skoc pri chybe
08CF  67              MOV  H,A          ; uloz vyssi byte
08D0  CD 08DF         CALL 08DF         ; preved druhe dva znaky
08D3  6F              MOV  L,A          ; uloz nizsi byte
08D4  3F              CMC
08D5  D8              RC                ; vrat sa s CY=1, ak je vsetko OK
08D6  E1              POP  H            ; zahod navratovu adresu a vrat sa s
08D7  C3 05A5         JMP  05A5         ; chybou, 7-chybna hodnota v parametri


;------------------------------------------------------------------------------
; Pokracovanie rutina na prevedienie jedneho radu cisla v akumulatore do
;------------------------------------------------------------------------------
08DA  80              ADD  B            ; vrat "odpocitany" rad
08DB  23              INX  H            ; posun ukazatel
08DC  C9              RET               ; vrat sa


;------------------------------------------------------------------------------
; Rutina je volana pri vyziadani mena disku, kedy sa pocitaju volne RJ
;------------------------------------------------------------------------------
08DD  0C              INR  C            ; zvys pocet volnych RJ
08DE  C9              RET


;------------------------------------------------------------------------------
; Prevedie dve HEXA na cislo.
; vstup: DE = ukazatel
; vystup: CY = 1 - chyba
;         CY = 0 - OK, A = cislo
; meni: DE, B, AF
;------------------------------------------------------------------------------
08DF  13              INX  D            ; posun ukazatel
08E0  1A              LDAX D            ; vezmi znak
08E1  CD 08F2         CALL 08F2         ; preved na cislo
08E4  D8              RC                ; vrat sa pri chybe
08E5  07              RLC               ; presun do hornych bitov
08E6  07              RLC
08E7  07              RLC
08E8  07              RLC
08E9  47              MOV  B,A          ; uloz
08EA  13              INX  D            ; posun ukazatel
08EB  1A              LDAX D            ; vezmi znak
08EC  CD 08F2         CALL 08F2         ; preved cislo
08EF  D8              RC                ; vrat sa pri chybe
08F0  B0              ORA  B            ; pridaj horne bity
08F1  C9              RET

;------------------------------------------------------------------------------
; Prevedie hexa znak - '0' az '9' a 'A' az 'F' na cislo.
; vstup: A = testovany znak
; vystup: CY = 1 - chyba
;         CY = 0 - OK, A = cislo
; meni: AF
;------------------------------------------------------------------------------
08F2  FE 30           CPI  30           ; '0'
08F4  D8              RC                ; vrat sa s CY=1, ak je mimo
08F5  FE 3A           CPI  3A           ; '9' + 1
08F7  D2 08FD         JNC  08FD         ; je to 'A' az 'F'
08FA  E6 0F           ANI  0F           ; odmaskuj cislo
08FC  C9              RET

08FD  E6 1F           ANI  1F           ; maska pre 'A' az 'F'
08FF  FE 01           CPI  01
0901  D8              RC
0902  FE 07           CPI  07
0904  3F              CMC
0905  D8              RC
0906  C6 09           ADI  09           ; uprav na 10 az 15
0908  C9              RET


;------------------------------------------------------------------------------
; Rutina pripravi hodnotu STATUS registre.
;------------------------------------------------------------------------------
0909  3A 1800         LDA  1800         ; hodnota status registra do A
090C  21 183F         LXI  H,183F       ; cielova adresa kam sa ulozi
090F  C3 0A01         JMP  0A01         ; textova podoba hodnoty


;------------------------------------------------------------------------------
; Rutina nastavi typ suboru 'D' a novy kod povelu.
; Vstup: A = novy kod povelu
; Vystup: (1808) = novy kod povelu
;         (183D) = H = A = 'D' typ suboru
; Meni: A, H
;------------------------------------------------------------------------------
0912  26 44           MVI  H,44         ; typ suboru 'D'
0914  32 1808         STA  1808         ; uloz kod povelu
0917  7C              MOV  A,H
0918  00              NOP
0919  32 183D         STA  183D         ; uloz typ suboru
091C  C9              RET


;------------------------------------------------------------------------------
; Obsluha 'P', 'I' a 'H' - pokracovanie
;------------------------------------------------------------------------------
091D  CD 051E         CALL 051E         ; prenes pozad. zaznam Subor <-> IMS-2
0920  AF              XRA  A
0921  32 180D         STA  180D         ; vynuluj nizsi byte adresy IMS-2 buffra
0924  CD 0912         CALL 0912         ; a nastav typ suboru 'D'
0927  C3 0963         JMP  0963         ; skoc dopredu


;------------------------------------------------------------------------------
; Ukoncovacia hlaska povelu 'D' - katalog diskety
;------------------------------------------------------------------------------
092A  2D 2D 2D 2D     DB   '---------END',0D
092E  2D 2D 2D 2D
0932  2D 45 4E 44
0936  0D


;------------------------------------------------------------------------------
; Obsluzna rutina pre nacitanie sektora, nastavenie flagu, ze su pripravene data
; na odoslanie.
;------------------------------------------------------------------------------
0937  CD 074A         CALL 074A         ; zavolaj rutinu
093A  C0              RNZ               ; vrat sa pri chybe
093B  3E 80           MVI  A,80         ; su pripravene data na odoslanie
093D  C3 0174         JMP  0174         ; uloz flag


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0940  00              DB   00


;------------------------------------------------------------------------------
; Povel 'B' - utajenie suboru v katalogu
;------------------------------------------------------------------------------
0941  3E 4E           MVI  A,4E         ; 'N' - bude sa hladat podla mena
0943  32 1838         STA  1838
0946  CD 01F4         CALL 01F4         ; vyhladaj subor
0949  C0              RNZ               ; ak sa subor nenajde,
094A  D2 05B4         JNC  05B4         ; 12 - chyba nazvu suboru al. duplicita
094D  7E              MOV  A,M          ; zmen stav utajeny/neutajeny
094E  2F              CMA
094F  77              MOV  M,A
0950  C3 038D         JMP  038D         ; skoc zapisat zmenu na disk


;------------------------------------------------------------------------------
; * Rezim MASTER *
; Na toto miesto sa skace po resete, ak je zvoleny rezim MASTER (8. DIL
; prepinac je v polohe 1). Prepoklada sa, ze v sektore 17 stopy 0 je ulozeny
; BOOT kod, ktoremu sa odovzda riadenie. Dalsia cinnost je uz dana uzivatelskym
; BOOT programom.
;------------------------------------------------------------------------------
0953  21 1100         LXI  H,1100       ; stopa 0, sektor 17 - BOOT kod
0956  22 1825         SHLD 1825         ; uloz pozadovanu stopu a sektor
0959  CD 032D         CALL 032D         ; nacitaj sektor
095C  C2 095C         JNZ  095C         ; pri chybe - nekonecna slucka -> RESET
095F  2A 180B         LHLD 180B         ; HL = adresa sektoroveho buffra
0962  E9              PCHL              ; vykonaj BOOT kod


;------------------------------------------------------------------------------
; Obsluha 'P', 'I' a 'H' - pokracovanie
;------------------------------------------------------------------------------
0963  2A 1812         LHLD 1812         ; adresa zoznamu RJ suboru
0966  2B              DCX  H            ; spat na dlzku zaznamu
0967  7E              MOV  A,M          ; dlzka zaznamu
0968  32 1822         STA  1822         ; vrat povodnu dlzku zaznamu
096B  C3 016F         JMP  016F         ; ukonci povel


;------------------------------------------------------------------------------
; Obsluha 'Z' - zapis binarnych dat - pokracovanie
;------------------------------------------------------------------------------
096E  21 09F3         LXI  H,09F3       ; adresa obsluznej rutiny
0971  22 1810         SHLD 1810
0974  3E 80           MVI  A,80         ; dlzka zaznamu 128 bytov
0976  32 1822         STA  1822
0979  2A 1820         LHLD 1820         ; dlzka suboru
097C  22 181E         SHLD 181E         ; uloz aj na adresu 181E
097F  7C              MOV  A,H          ; vypocitaj pocet potrebnych RJ
0980  1F              RAR
0981  1F              RAR
0982  E6 3F           ANI  3F
0984  CD 02F6         CALL 02F6         ; alokuj miesto na disku
0987  C0              RNZ               ; vrat sa, ak nie je dost miesta
0988  3E 4E           MVI  A,4E         ; 'N' - bude sa hladat podla mena
098A  32 1838         STA  1838
098D  CD 01F4         CALL 01F4         ; vyhladaj subor, ci existuje
0990  C0              RNZ               ; vrat sa pri chybe, ak subor existuje,
0991  DA 05B4         JC   05B4         ; 12 - chyba nazvu suboru al. duplicita
0994  0E 10           MVI  C,10         ; offset do zoznamu RJ
0996  3E 45           MVI  A,45         ; 'E' - bude sa hladat volna hlavicka
0998  32 1838         STA  1838
099B  C5              PUSH B
099C  CD 01F4         CALL 01F4         ; vyhladaj volnu hlavicku
099F  C1              POP  B
09A0  C0              RNZ               ; vrat sa pri chybe
09A1  06 08           MVI  B,08         ; dlzka mena
09A3  36 00           MVI  M,00         ; flag - neutajeny subor
09A5  23              INX  H            ; posun ukazatel
09A6  EB              XCHG              ; a prehod do DE
09A7  21 1816         LXI  H,1816       ; pridaj meno suboru
09AA  CD 05CC         CALL 05CC
09AD  3A 183D         LDA  183D         ; pridaj typ suboru
09B0  12              STAX D
09B1  13              INX  D            ; posun ukazatel
09B2  13              INX  D
09B3  13              INX  D
09B4  3A 1827         LDA  1827         ; pridaj pocet RJ
09B7  12              STAX D
09B8  06 03           MVI  B,03
09BA  23              INX  H
09BB  23              INX  H
09BC  13              INX  D
09BD  CD 05CC         CALL 05CC         ; pridaj dlzku suboru a velkost zaznamu
09C0  21 1860         LXI  H,1860       ; adresa zoznamu RJ
09C3  09              DAD  B            ; pripocitaj offset
09C4  06 10           MVI  B,10         ; pridaj zoznam RJ
09C6  CD 05CC         CALL 05CC
09C9  C5              PUSH B
09CA  CD 0575         CALL 0575         ; zapis sektor
09CD  C1              POP  B
09CE  C0              RNZ               ; vrat sa pri chybe
09CF  3A 1827         LDA  1827         ; celkovy pocet RJ
09D2  91              SUB  C            ; odpocitaj uz "spracovane"
09D3  21 0663         LXI  H,0663       ; adresa rutiny pre zapis sektora
09D6  22 1809         SHLD 1809
09D9  CA 09EB         JZ   09EB         ; ak uz bol spracovany cely subor,
09DC  FA 09EB         JM   09EB         ; skoc dopredu
09DF  3E 10           MVI  A,10         ; zvys offset do oznamu RJ o 16
09E1  81              ADD  C
09E2  4F              MOV  C,A
09E3  3E FF           MVI  A,FF         ; dalsie hlavicky budu mat typ FF
09E5  32 183D         STA  183D
09E8  C3 0996         JMP  0996         ; dalsia hlavicka

09EB  CD 0381         CALL 0381         ; zapis alokacnu mapu
09EE  3E 40           MVI  A,40         ; flag - ocakavaju sa data
09F0  C3 03F0         JMP  03F0         ; vrat sa cez nastavenie parametrov.

; Rutina zapise sektor po prijati dat.
09F3  CD 074A         CALL 074A         ; zapis sektor
09F6  C0              RNZ
09F7  3E 40           MVI  A,40         ; flag - ocakavaju sa data
09F9  C3 0174         JMP  0174         ; vrat sa cez ulozenie flagu


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
09FC  FF FF FF FF     DB   FF,FF,FF,FF
0A00  FF              DB   FF


;------------------------------------------------------------------------------
; Rutina prevedie 8 bitove cislo na troj znakovy retazec ukonceny 0D.
; Vstup: A = prevadzane cislo
;        HL = cielova adresa
; Vystup: HL = HL + 3
; Meni: AF, B, HL
;------------------------------------------------------------------------------
0A01  06 64           MVI  B,64         ; rad 100
0A03  CD 0853         CALL 0853         ; urob odpocet a uloz cislicu

;------------------------------------------------------------------------------
; Rutina prevedie 8 bitove cislo na dvoj znakovy retazec ukonceny 0D.
; Vstup: A = prevadzane cislo
;        HL = cielova adresa
; Vystup: HL = HL + 2
; Meni: AF, B, HL
;------------------------------------------------------------------------------
0A06  06 0A           MVI  B,0A         ; rad 10
0A08  CD 0853         CALL 0853         ; urob odpocet a uloz cislicu
0A0B  F6 30           ORI  30           ; najnizsi rad 1
0A0D  77              MOV  M,A          ; uloz
0A0E  23              INX  H            ; posun ukazatel
0A0F  36 0D           MVI  M,0D         ; ukonci retazec
0A11  C9              RET


;------------------------------------------------------------------------------
; Rutina prevedie cislo (pocet RJ) na retazec, ukonci 0D a nastavi priznak,
; ze su pripravene data na odoslanie.
;------------------------------------------------------------------------------
0A12  CD 0A06         CALL 0A06         ; preved cislo na retazec
0A15  C3 093B         JMP  093B         ; skoc nast. priznak - pripravene data


;------------------------------------------------------------------------------
; Povel 'F' - formatovanie diskety
; Vstup: (1816) = meno suboru
; Vystup: -
; Meni: vsetky
;------------------------------------------------------------------------------
0A18  CD 0261         CALL 0261         ; sformatuj disketu
0A1B  C0              RNZ               ; vrat sa pri chybe


;------------------------------------------------------------------------------
; Podprogram VERIFY DISK
;------------------------------------------------------------------------------
0A1C  21 0708         LXI  H,0708       ; FDC povel - Verify track
0A1F  06 0C           MVI  B,0C
0A21  CD 05C9         CALL 05C9         ; presun na adresu 1828
0A24  21 1828         LXI  H,1828
0A27  CD 0578         CALL 0578         ; verifikuj stopu
0A2A  B7              ORA  A
0A2B  C0              RNZ               ; vrat sa pri chybe
0A2C  3A 182D         LDA  182D         ; dalsia stopa
0A2F  3C              INR  A
0A30  32 182D         STA  182D
0A33  FE 28           CPI  28           ; 40 stop
0A35  C2 0A24         JNZ  0A24
0A38  C9              RET


;------------------------------------------------------------------------------
; Rutina zapise pozadovany zaznam na disk. Je pouzity IMS-2 buffer.
; Vstup: (1A00) = zapisovany retazec do zaznamu
;        (1812) = adresa zoznamu RJ suboru
;        (1820) = aktualne cislo zaznamu
; Vystup: Z=0, ak doslo ku chybe
;         HL = (1820) = aktualne cislo zaznamu + 1
;         (1822) = dlzka zaznamu
;         BC = pocet zaznamov v subore
; Meni: vsetky
;------------------------------------------------------------------------------
0A39  21 0562         LXI  H,0562       ; adr. rutiny - presun IMS-2 -> sektor

;------------------------------------------------------------------------------
; Rutina nacita/zapise pozadovany zaznam z/na disk. Ako cielovy/zdrojovy buffer
; je pouzity IMS-2 buffer na adrese 1A00.
; Vstup: HL = adresa obsluznej rutiny na presun medzi IMS-2 <-> sektor
;        (1812) = adresa zoznamu RJ suboru
;        (1820) = aktualne cislo zaznamu
; Vystup: Z=0, ak doslo k chybe
;         HL = (1820) = aktualne cislo zaznamu + 1
;         (1822) = dlzka zaznamu
;         BC = pocet zaznamov v subore
; Meni: vsetky
;------------------------------------------------------------------------------
0A3C  22 1810         SHLD 1810         ; uloz adresu rutiny
0A3F  21 1A00         LXI  H,1A00       ; adresa IMS-2 buffra
0A42  22 180D         SHLD 180D
0A45  2A 1812         LHLD 1812         ; adresa zoznamu RJ
0A48  2B              DCX  H            ; presun sa na dlzku zaznamu
0A49  7E              MOV  A,M          ; vezmi dlzku zaznamu
0A4A  32 1822         STA  1822         ; uloz
0A4D  2B              DCX  H            ; presun sa na pocet zaznamov
0A4E  46              MOV  B,M          ; BC = pocet zaznamov
0A4F  2B              DCX  H
0A50  4E              MOV  C,M
0A51  C5              PUSH B            ; odpamataj pocet zaznamov
0A52  CD 091D         CALL 091D         ; prenes pozad. zaznam Subor <-> IMS-2
0A55  C1              POP  B            ; obnov pocet zaznamov
0A56  3A 1800         LDA  1800         ; kod chyby
0A59  B7              ORA  A
0A5A  C0              RNZ               ; vrat sa, ak doslo ku chybe
0A5B  2A 1820         LHLD 1820         ; zvys cislo zaznamu
0A5E  23              INX  H
0A5F  22 1820         SHLD 1820
0A62  C9              RET


;------------------------------------------------------------------------------
; Rutina pre vyhladavanie retazcov v datovom subore.
; Vstup : (1812) = adresa zoznamu RJ suboru
;         (1820) = aktualne cislo zaznamu
; Vystup: (1A00) = cislo najdeneho zaznamu v ASCII
;                  ak zacina '9', zaznam sa nenasiel
;------------------------------------------------------------------------------
0A63  21 0550         LXI  H,0550       ; adr. rutiny - presun sektor -> IMS-2
0A66  CD 0A3C         CALL 0A3C         ; precitaj dalsi zaznam
0A69  C0              RNZ               ; vrat sa pri chybe
0A6A  CD 0252         CALL 0252         ; porovnaj BC a HL
0A6D  3E 39           MVI  A,39         ; "flag" '9' - zaznam sa nenasiel
0A6F  DA 0ABE         JC   0ABE         ; skoc, ak si dorazil na posl. zaznam
0A72  3A 1819         LDA  1819         ; pocet znakov do konca zaznamu
0A75  57              MOV  D,A
0A76  2A 1816         LHLD 1816         ; adresa v zazname, kde sa hlada retazec
0A79  06 1B           MVI  B,1B         ; vyssi byte adresy hladaneho retazca
0A7B  AF              XRA  A            ; offset do hladaneho zaznamu = 0
0A7C  32 1818         STA  1818         ; uloz
0A7F  3A 1818         LDA  1818         ; vezmi "offset" do hladaneho retazca
0A82  4F              MOV  C,A          ; daj do C
0A83  0A              LDAX B            ; vezmi znak hladaneho retazca
0A84  FE 0D           CPI  0D           ; je to koniec retazca ?
0A86  CA 0A63         JZ   0A63         ; ano, skus dalsi zaznam
0A89  BE              CMP  M            ; porovnaj so zaznamom
0A8A  C2 0AA6         JNZ  0AA6         ; nezhoduje sa, skoc dopredu
0A8D  79              MOV  A,C
0A8E  32 1818         STA  1818         ; uloz "offset" do hladaneho retazca
0A91  15              DCR  D            ; zniz zostavajuci pocet zn. v zazname
0A92  23              INX  H            ; posun ukazatel v zazname
0A93  03              INX  B            ; posun ukazatel v hladanom retazci
0A94  0A              LDAX B            ; vezmi znak hladaneho retazca
0A95  FE 0D           CPI  0D           ; je to koniec retazca ?
0A97  CA 0ABC         JZ   0ABC         ; ano, nasiel hladany retazec, skoc
0A9A  FE 2C           CPI  2C           ; je to oddelovac ciarka ?
0A9C  CA 0AAE         JZ   0AAE         ; ano skoc dopredu
0A9F  BE              CMP  M            ; porovnaj so zaznamom
0AA0  CA 0A91         JZ   0A91         ; zhoduje sa, porovnavaj dalej
0AA3  C3 0A7F         JMP  0A7F         ; nezhoduje sa, vrat sa do hl. slucky

0AA6  23              INX  H            ; posun ukazatel v zazname
0AA7  15              DCR  D            ; zniz zostavajuci pocet zn. v zazname
0AA8  C2 0A83         JNZ  0A83         ; nepresiel si vsetky, pokracuj
0AAB  C3 0A63         JMP  0A63         ; inak skus dalsi zaznam

0AAE  03              INX  B            ; preskoc ciarku
0AAF  0A              LDAX B            ; vezmi dalsi znak
0AB0  BE              CMP  M            ; porovnaj so zaznamom
0AB1  CA 0A8D         JZ   0A8D         ; zhoduje sa, vrat sa do hl. slucky
0AB4  23              INX  H            ; posun ukazatel v zazname
0AB5  15              DCR  D            ; zniz zostavajuci pocet zn. v zazname
0AB6  C2 0AB0         JNZ  0AB0         ; nepresiel si vsetky, pokracuj
0AB9  C3 0A63         JMP  0A63         ; inak skus dalsi zaznam

; prevedenie cisla zaznamu na retazec
0ABC  3E 30           MVI  A,30         ; "flag" '0' - zaznam sa nasiel
0ABE  2A 1820         LHLD 1820         ; cislo zaznamu
0AC1  2B              DCX  H            ; zniz
0AC2  EB              XCHG              ; uloz do DE
0AC3  21 1A00         LXI  H,1A00       ; adresa cieloveho buffra
0AC6  77              MOV  M,A          ; zapis flag
0AC7  23              INX  H            ; posun ukazatel
0AC8  EB              XCHG              ; HL = cislo zaznamu, DE = buffer
0AC9  01 D8F0         LXI  B,D8F0       ; -10000
0ACC  CD 0AEB         CALL 0AEB         ; odpocitaj rad
0ACF  01 FC18         LXI  B,FC18       ; -1000
0AD2  CD 0AEB         CALL 0AEB         ; odpocitaj rad
0AD5  01 FF9C         LXI  B,FF9C       ; -100
0AD8  CD 0AEB         CALL 0AEB         ; odpocitaj rad
0ADB  01 FFF6         LXI  B,FFF6       ; -10
0ADE  CD 0AEB         CALL 0AEB         ; odpocitaj rad
0AE1  7D              MOV  A,L          ; a najnizssi rad
0AE2  F6 30           ORI  30           ; na ASCII
0AE4  12              STAX D            ; uloz do buffra
0AE5  EB              XCHG              ; adresa buffra do HL
0AE6  23              INX  H            ; posun ukazatel
0AE7  C3 0BE0         JMP  0BE0         ; skoc dopredu


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0AEA  00              DB   00


;------------------------------------------------------------------------------
; Rutina prevedie na ASCII jeden rad cisla.
; Vstup: HL = prevadzane cislo
;        DE = adresa cieloveho buffra
;        BC = odpocitavany rad ako zaporne cislo
; Vystup: (DE - 1) = vysledna ASCII cislica
;         DE = DE + 1
;         HL = zostatok
; Meni: HL, DE, AF
;------------------------------------------------------------------------------
0AEB  AF              XRA  A            ; A = 0
0AEC  D5              PUSH D            ; odpamataj adresu buffra
0AED  5D              MOV  E,L          ; prevadzane cislo do DE
0AEE  54              MOV  D,H
0AEF  3C              INR  A            ; + 1
0AF0  09              DAD  B            ; odpocitaj rad
0AF1  DA 0AED         JC   0AED         ; ak sa v cisle nachadza, opakuj
0AF4  3D              DCR  A            ; uprav
0AF5  6B              MOV  L,E          ; vrat zostatok do HL
0AF6  62              MOV  H,D
0AF7  D1              POP  D            ; obnov buffer
0AF8  F6 30           ORI  30           ; preved na ASCII
0AFA  12              STAX D            ; uloz do buffra
0AFB  13              INX  D            ; posun ukazatel
0AFC  C9              RET


;------------------------------------------------------------------------------
; Povel 'H' - vyhladanie slova v subore
;------------------------------------------------------------------------------
0AFD  3E 1A           MVI  A,1A         ; vyssi byte adresy buffra
0AFF  32 1817         STA  1817
0B02  3A 1822         LDA  1822         ; pozicia hladaneho retazca v zazname
0B05  32 1816         STA  1816         ; uloz ako nizsi byte buffra
0B08  3E 40           MVI  A,40         ; flag - ocakavaju sa data
0B0A  32 1800         STA  1800
0B0D  3E 06           MVI  A,06         ; novy kod povelu vyhladavanie
0B0F  32 1808         STA  1808
0B12  C3 017E         JMP  017E         ; vrat sa cez kontrolu parametrov


;------------------------------------------------------------------------------
; Povel 06 - pokracovanie 'H'
;------------------------------------------------------------------------------
0B15  0E 00           MVI  C,00         ; dlzka hladaneho retazca
0B17  21 19FF         LXI  H,19FF       ; vstupny buffer
0B1A  11 1AFF         LXI  D,1AFF       ; vystupny buffer
0B1D  23              INX  H            ; posun ukazatele
0B1E  13              INX  D
0B1F  7E              MOV  A,M          ; vezmi znak zo vstupneho buffra
0B20  12              STAX D            ; uloz do vystupneho buffra
0B21  FE 0D           CPI  0D           ; je to CR ?
0B23  CA 0B2F         JZ   0B2F         ; ano, skoc dopredu
0B26  FE 2C           CPI  2C           ; je oddelocvac ciarka ',' ?
0B28  CA 0B1D         JZ   0B1D         ; ano, nepocita sa do dlzky retazca
0B2B  0C              INR  C            ; zvys dlzku hladaneho retazca
0B2C  C3 0B1D         JMP  0B1D         ; pokracuj v cykle

0B2F  3A 1816         LDA  1816         ; pozicia hladaneho retazca v zazname
0B32  57              MOV  D,A          ; do D
0B33  3A 1822         LDA  1822         ; dlzka zaznamu
0B36  92              SUB  D            ; odpocitaj poziciu
0B37  DA 05B7         JC   05B7         ; 13 - parameter mimo rozsah
0B3A  91              SUB  C            ; odpocitaj dlzku retazca
0B3B  DA 05B7         JC   05B7         ; 13 - parameter mimo rozsah
0B3E  81              ADD  C            ; pripocitaj nazad dlzku retazca
0B3F  3C              INR  A            ; a zvys o 1
0B40  32 1819         STA  1819         ; uloz pocet znakov do konca zaznamu
0B43  CD 0A63         CALL 0A63         ; vyhladaj retazec
0B46  C0              RNZ               ; vrat sa pri chybe
0B47  21 1A00         LXI  H,1A00       ; IMS-2 buffer
0B4A  22 180D         SHLD 180D
0B4D  3E 80           MVI  A,80         ; flag - budu sa posielat data
0B4F  32 1800         STA  1800
0B52  3E 05           MVI  A,05         ; kod - ukoncenie povelu
0B54  32 1808         STA  1808
0B57  C9              RET


;------------------------------------------------------------------------------
; Nepouzita rutina pre vyplnenie zaznamov datoveho suboru zvolenym retazcom.
; Vstup: (1A00) = zapisovany retazec do zaznamu
;        (1812) = adresa zoznamu RJ suboru
;        (1820) = aktualne cislo zaznamu
; Vystup: Z=0, ak doslo ku chybe
;         CY=1 - OK
; Meni: vsetky
;------------------------------------------------------------------------------
0B58  CD 0A39         CALL 0A39         ; zapis retazec do aktualneho zaznamu
0B5B  C0              RNZ               ; navrat pri chybe
0B5C  CD 0252         CALL 0252         ; porovnaj BC a HL
0B5F  D2 0B58         JNC  0B58         ; opakuj pre vsetky zaznamy
0B62  C9              RET


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0B63  FF FF FF FF     DB   FF,FF,FF,FF
0B67  FF FF FF FF     DB   FF,FF,FF,FF
0B6B  FF FF FF FF     DB   FF,FF,FF,FF
0B6F  FF FF FF FF     DB   FF,FF,FF,FF
0B73  FF FF FF FF     DB   FF,FF,FF,FF
0B77  FF FF FF FF     DB   FF,FF,FF,FF
0B7B  FF FF FF FF     DB   FF,FF,FF,FF
0B7F  FF FF FF FF     DB   FF,FF,FF,FF
0B83  FF FF FF FF     DB   FF,FF,FF,FF
0B87  FF FF FF FF     DB   FF,FF,FF,FF
0B8B  FF FF FF FF     DB   FF,FF,FF,FF
0B8F  FF FF FF FF     DB   FF,FF,FF,FF
0B93  FF FF FF FF     DB   FF,FF,FF,FF
0B97  FF FF FF FF     DB   FF,FF,FF,FF
0B9B  FF FF FF FF     DB   FF,FF,FF,FF
0B9F  FF FF FF FF     DB   FF,FF,FF,FF
0BA3  FF FF FF FF     DB   FF,FF,FF,FF
0BA7  FF FF FF FF     DB   FF,FF,FF,FF
0BAB  FF FF FF FF     DB   FF,FF,FF,FF
0BAF  FF FF FF FF     DB   FF,FF,FF,FF
0BB3  FF FF FF FF     DB   FF,FF,FF,FF
0BB7  FF FF FF FF     DB   FF,FF,FF,FF
0BBB  FF FF FF FF     DB   FF,FF,FF,FF
0BBF  FF FF FF FF     DB   FF,FF,FF,FF
0BC3  FF FF FF FF     DB   FF,FF,FF,FF
0BC7  FF FF FF FF     DB   FF,FF,FF,FF
0BCB  FF FF FF FF     DB   FF,FF,FF,FF
0BCF  FF FF FF FF     DB   FF,FF,FF,FF
0BD3  FF FF FF FF     DB   FF,FF,FF,FF
0BD7  FF FF FF FF     DB   FF,FF,FF,FF
0BDB  FF FF FF FF     DB   FF,FF,FF,FF
0BDF  FF              DB   FF


;------------------------------------------------------------------------------
; Povel 06 - ukoncenie 'H'
;------------------------------------------------------------------------------
0BE0  36 0D           MVI  M,0D         ; ukonci retazec (cislo zaznamu)
0BE2  3E 06           MVI  A,06         ; dlzka retazca 6 znakov
0BE4  32 1822         STA  1822
0BE7  AF              XRA  A            ; Z=1, CY=0
0BE8  C9              RET


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0BE9  FF FF           DB   FF,FF


;------------------------------------------------------------------------------
; Povel 'C' - vytvorenie datoveho suboru - pokracovanie
;------------------------------------------------------------------------------
0BEB  CD 01F4         CALL 01F4         ; hladaj polozku zmazaneho suboru
0BEE  C0              RNZ               ; pri chybe sa vrat
0BEF  3A 1826         LDA  1826         ; zisti, ci je zaplneny katalog
0BF2  FE 10           CPI  10           ; je to posledny sektor katalogu ?
0BF4  C2 0356         JNZ  0356         ; nie, skoc dalej
0BF7  7D              MOV  A,L
0BF8  FE E0           CPI  E0           ; ukazuje HL na poslednu polozku ?
0BFA  CA 05C3         JZ   05C3         ; 17 - katalog je zaplneny
0BFD  C3 0356         JMP  0356         ; skoc dalej


;------------------------------------------------------------------------------
; Rezim SLAVE
; V SLAVE rezime PMD 30 ocakava z IMS-2 zbernice od CONTROLLERa povely, ktore
; prislusne PMD 30 spracovava.
;------------------------------------------------------------------------------
0C00  3E 92           MVI  A,92         ; init IMS-2 - vstup
0C02  D3 DF           OUT  DF
0C04  3E 01           MVI  A,01         ; vstup, vsetky signaly = 0
0C06  D3 DE           OUT  DE
0C08  06 00           MVI  B,00         ; kod registra PMD 30 - ziadny
0C0A  16 3F           MVI  D,3F         ; 63 pokusov
0C0C  DB DD           IN   DD           ; precitaj stav zbernice
0C0E  E6 60           ANI  60           ; odmaskuj ATN a REN
0C10  FE 60           CPI  60           ; ATN=1 a REN=1 ?
0C12  CA 0C26         JZ   0C26         ; ano, skoc, ide o povel alebo adresu
0C15  FE 40           CPI  40           ; ATN=0 a REN=1 ?
0C17  CA 0C6D         JZ   0C6D         ; ano, ide o data
0C1A  15              DCR  D            ; nie, cakaj na povel alebo data
0C1B  C2 0C0C         JNZ  0C0C
0C1E  C3 0C04         JMP  0C04


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0C21  00 00 00 00     DB   00,00,00,00
0C25  00              DB   00


;------------------------------------------------------------------------------
; Obsluha stykovej spravy - povel alebo adresa zariadenia
;------------------------------------------------------------------------------
0C26  3E 09           MVI  A,09         ; NDAC=1, NRFD=0
0C28  D3 DE           OUT  DE
0C2A  DB DD           IN   DD           ; je DAV=1 ?
0C2C  E6 02           ANI  02
0C2E  CA 0C0A         JZ   0C0A         ; nie, cakaj
0C31  DB DC           IN   DC           ; prevezmi byte
0C33  E6 7F           ANI  7F           ; ponechaj iba 7 dolnych bitov
0C35  5F              MOV  E,A          ; uloz do E
0C36  3E 0D           MVI  A,0D         ; NDAC=1, NRFD =1
0C38  D3 DE           OUT  DE
0C3A  3E 05           MVI  A,05         ; NDAC=0, NRFD =1
0C3C  D3 DE           OUT  DE           ; potvrd prijaty byte
0C3E  DB DD           IN   DD           ; pockaj na DAV=0
0C40  E6 02           ANI  02
0C42  C2 0C3E         JNZ  0C3E
0C45  3E 0D           MVI  A,0D         ; NDAC=1, NRFD =1
0C47  D3 DE           OUT  DE
0C49  21 0D10         LXI  H,0D10       ; tabulka sprav Unlisten, Untalk
0C4C  7E              MOV  A,M          ; kod spravy
0C4D  B7              ORA  A
0C4E  CA 0C61         JZ   0C61         ; ak je to koniec tabulky, skoc dopredu
0C51  7B              MOV  A,E          ; porovnaj prijaty byte s kodom spravy
0C52  BE              CMP  M
0C53  C2 0C5C         JNZ  0C5C         ; ak sa nezhoduje, skoc dalej
0C56  23              INX  H            ; posun sa na dalsi byte v tabulke
0C57  46              MOV  B,M          ; zneplatni aktualny kod (je tam 0)
0C58  23              INX  H            ; posun sa na dalsi byte v tabulke
0C59  C3 0C4C         JMP  0C4C         ; pokracuj v slucke

0C5C  23              INX  H            ; posun sa na dalsiu polozku v tabulke
0C5D  23              INX  H
0C5E  C3 0C4C         JMP  0C4C         ; pokracuj v slucke

0C61  CD 0E69         CALL 0E69         ; do B kod registra PMD 30
0C64  C3 0C0A         JMP  0C0A


;------------------------------------------------------------------------------
; hluchy kod
;------------------------------------------------------------------------------
0C67  DB DD           IN   DD
0C69  E6 20           ANI  20
0C6B  C2 7C           DB   C2,7C


;------------------------------------------------------------------------------
; Obsluha pristrojovych sprav - data.
;------------------------------------------------------------------------------
0C6D  78              MOV  A,B          ; ak je PMD 30 aktivnym Listenerom
0C6E  B7              ORA  A            ; alebo Talkerom
0C6F  C2 0E3D         JNZ  0E3D         ; skoc dopredu
0C72  C3 0C04         JMP  0C04         ; inak tieto data ignoruj a vrat sa


;------------------------------------------------------------------------------
; hluchy kod
;------------------------------------------------------------------------------
0C75  3E 0D           MVI  A,0D
0C77  D3 DE           OUT  DE
0C79  DB DC           IN   DC
0C7B  C9              RET

0C7C  D1              POP  D
0C7D  3E 09           MVI  A,09
0C7F  D3 DE           OUT  DE
0C81  C3 0C06         JMP  0C06

0C84  C3 0C0A         JMP  0C0A


;------------------------------------------------------------------------------
; Obsluha COMMAND registra.
; Rutina prijme z nadradeneho pocitaca COMMAND povel a spracuje ho.
;------------------------------------------------------------------------------
0C87  21 1870         LXI  H,1870       ; buffer COMMAND registra
0C8A  CD 0CC7         CALL 0CC7         ; prijmi byte
0C8D  77              MOV  M,A          ; uloz
0C8E  FE 0A           CPI  0A           ; je to koniec retazca ?
0C90  C2 0E36         JNZ  0E36         ; nie, citaj dalej
0C93  CD 0400         CALL 0400         ; spracuj COMMAND
0C96  CD 0CD9         CALL 0CD9         ; potvrd prijatie bytu
0C99  C9              RET


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0C9A  00 00 00 00     DB   00,00,00,00
0C9E  00              DB   00


;------------------------------------------------------------------------------
; Obsluha vyziadania STATUS registra.
; Rutina odosle do nadradeneho pocitaca hodnotu STATUS registra.
;------------------------------------------------------------------------------
0C9F  3E 82           MVI  A,82         ; init IMS-2 - vystup
0CA1  D3 DF           OUT  DF
0CA3  3E 00           MVI  A,00         ; vystup, vsetky signaly = 0
0CA5  D3 DE           OUT  DE
0CA7  CD 0909         CALL 0909         ; priprav hodnotu STATUS registra
0CAA  21 183F         LXI  H,183F       ; na adresu 183F
0CAD  CD 0CED         CALL 0CED         ; cakaj na NDAC=1
0CB0  7E              MOV  A,M          ; byte na odoslanie
0CB1  CD 0CF7         CALL 0CF7         ; posli na zbernicu
0CB4  7E              MOV  A,M
0CB5  FE 0D           CPI  0D           ; poslal si uz vsetko ?
0CB7  C2 0CC3         JNZ  0CC3         ; nie, opakuj
0CBA  C3 0D1D         JMP  0D1D         ; inak skoc odoslat 0A

; "hluchy" kod
0CBD  00              NOP
0CBE  3E 01           MVI  A,01
0CC0  D3 DE           OUT  DE
0CC2  C9              RET

; zvys ukazatel
0CC3  23              INX  H
0CC4  C3 0CAD         JMP  0CAD         ; vrat sa do slucky


;------------------------------------------------------------------------------
; Rutina na prijem datoveho bytu zo zbernice IMS-2.
; Vstup: -
; Vystup: A = nacitany byte
;         ak doslo ku chybe, vrati sa do hlavnej slucky
;------------------------------------------------------------------------------
0CC7  3E 09           MVI  A,09         ; NDAC = 1, NRFD = 0, DAV = 0
0CC9  D3 DE           OUT  DE
0CCB  C3 0FB0         JMP  0FB0         ; skoc dopredu


;------------------------------------------------------------------------------
; hluchy kod
;------------------------------------------------------------------------------
0CCE  02              DB   02
0CCF  CA 0CCB         JZ   0CCB
0CD2  3E 0D           MVI  A,0D
0CD4  D3 DE           OUT  DE
0CD6  DB DC           IN   DC
0CD8  C9              RET


;------------------------------------------------------------------------------
; Rutina potvrdi prijatie bytu z IMS-2 zbernice.
; Vstup: -
; Vystup: -
; Meni: AF
;------------------------------------------------------------------------------
0CD9  3E 05           MVI  A,05         ; NDAC = 0, NRFD = 1
0CDB  D3 DE           OUT  DE
0CDD  DB DD           IN   DD           ; cakaj na DAV = 0
0CDF  E6 02           ANI  02
0CE1  C2 0CDD         JNZ  0CDD
0CE4  3E 0D           MVI  A,0D         ; NDAC = 1, NRFD = 1
0CE6  D3 DE           OUT  DE
0CE8  3E 09           MVI  A,09         ; NDAC = 1, NRFD = 0
0CEA  D3 DE           OUT  DE
0CEC  C9              RET


;------------------------------------------------------------------------------
; Rutina caka na NDAC=1
; Vstup: -
; Vystup: -
; Meni: - AF
;------------------------------------------------------------------------------
0CED  DB DD           IN   DD           ; citaj riadiacu zbernicu
0CEF  E6 0C           ANI  0C           ; maskuj NDAC a NRFD
0CF1  FE 08           CPI  08           ; NDAC = 1 a NRFD = 0 ?
0CF3  C2 0CED         JNZ  0CED         ; nie, cakaj
0CF6  C9              RET               ; vrat sa


;------------------------------------------------------------------------------
; Vysle byte na datovu zbernicu IMS-2
; Vstup: A = posielany byte
; Vystup: -
; Meni: AF
;------------------------------------------------------------------------------
0CF7  D3 DC           OUT  DC           ; posli byte
0CF9  AF              XRA  A            ; ukludnenie zbernice
0CFA  3D              DCR  A
0CFB  C2 0CFA         JNZ  0CFA
0CFE  3E 02           MVI  A,02         ; DAV=1
0D00  D3 DE           OUT  DE
0D02  DB DD           IN   DD           ; citaj riadiacu zbernicu
0D04  E6 0C           ANI  0C           ; maskuj NDAC a NRFD
0D06  FE 04           CPI  04           ; NRFD = 1 a NDAC = 0  ?
0D08  C2 0D02         JNZ  0D02         ; nie cakaj
0D0B  3E 00           MVI  A,00         ; DAV=0
0D0D  D3 DE           OUT  DE
0D0F  C9              RET


;------------------------------------------------------------------------------
; Tabulka sprav Unlisten, Untalk
;------------------------------------------------------------------------------
0D10  3F 00           DB   3F,00        ; '?' - Unlisten
0D12  5F 00           DB   5F,00        ; '_' - Untalk
0D14  00              DB   00           ; koniec tabulky


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0D15  FF FF FF FF     DB   FF,FF,FF,FF
0D19  FF FF FF 00     DB   FF,FF,FF,00


;------------------------------------------------------------------------------
; Pokracovanie obsluhy vyziadania STATUS registra PMD 30.
; Odosle LF prepne zbernicu na vstup.
;------------------------------------------------------------------------------
0D1D  CD 0CED         CALL 0CED         ; cakaj na NDAC=1
0D20  3E 0A           MVI  A,0A         ; odosli LF
0D22  CD 0CF7         CALL 0CF7
0D25  3E 92           MVI  A,92         ; prepni zbernicu na vstup
0D27  D3 DF           OUT  DF
0D29  3E 01           MVI  A,01
0D2B  D3 DE           OUT  DE
0D2D  C9              RET


;------------------------------------------------------------------------------
; Obsluha registra DATA READ.
; Rutina pripravi blok dat pre odoslanie do nadradeneho pocitaca volanim
; procedury EXECUTE. Nasledne tieto data odosle
;------------------------------------------------------------------------------
0D2E  3E 82           MVI  A,82         ; init IMS-2 - vystup
0D30  D3 DF           OUT  DF
0D32  3E 00           MVI  A,00
0D34  D3 DE           OUT  DE
0D36  CD 04B9         CALL 04B9         ; EXECUTE - priprav odosielane data
0D39  CD 0E61         CALL 0E61         ; HL = adresa buffra, C = dlzka zaznamu
0D3C  CD 0DBC         CALL 0DBC         ; A = typ suboru
0D3F  FE 44           CPI  44           ; je to 'D' datovy subor ?
0D41  C2 0D5B         JNZ  0D5B         ; nie, skoc dopredu

; datovy subor
; data sa posielaju podla dlzky alebo po CR
0D44  CD 0CED         CALL 0CED         ; cakaj na NDAC=1
0D47  7E              MOV  A,M          ; vezmi byte
0D48  CD 0CF7         CALL 0CF7         ; posli na zbernicu
0D4B  7E              MOV  A,M          ; vezmi byte
0D4C  23              INX  H            ; posun ukazatel
0D4D  FE 0D           CPI  0D           ; je to koniec dat ?
0D4F  C2 0DAD         JNZ  0DAD         ; nie, skoc dopredu
0D52  CD 0CED         CALL 0CED         ; cakaj na NDAC=1
0D55  3E 0A           MVI  A,0A         ; posli LF
0D57  CD 0DA1         CALL 0DA1         ; a prepni zbernicu na vstup
0D5A  C9              RET

; binarne data
; data sa posielaju ako ASCII HEXA
0D5B  00              NOP
0D5C  00              NOP
0D5D  7E              MOV  A,M          ; vezmi byte
0D5E  CD 0D87         CALL 0D87         ; preved do ACSII
0D61  CD 0CED         CALL 0CED         ; cakaj na NDAC=1
0D64  7A              MOV  A,D          ; vyssie 4 bity
0D65  CD 0CF7         CALL 0CF7         ; posli na zbernicu
0D68  CD 0CED         CALL 0CED         ; cakaj na NDAC=1
0D6B  7B              MOV  A,E          ; nizsie 4 bity
0D6C  CD 0CF7         CALL 0CF7         ; posli na zbernicu
0D6F  0D              DCR  C            ; zniz pocitadlo
0D70  79              MOV  A,C          ; test na 0 - naco ????
0D71  B7              ORA  A
0D72  23              INX  H            ; posun ukazatel
0D73  C2 0D5D         JNZ  0D5D         ; opakuj pre vsetky byty
0D76  CD 0CED         CALL 0CED         ; cakaj na NDAC=1
0D79  3E 0D           MVI  A,0D         ; posli CR
0D7B  CD 0CF7         CALL 0CF7
0D7E  CD 0CED         CALL 0CED         ; cakaj na NDAC=1
0D81  3E 0A           MVI  A,0A         ; posli LF
0D83  CD 0DA1         CALL 0DA1         ; a prepni zbernicu na vstup
0D86  C9              RET

;------------------------------------------------------------------------------
; Rutina prevedie byte do dvoch HEXA ASCII znakov
; Vstup: HL = adresa prevadzaneho bytu
; Vystup: D = znak pre vyssie 4. bitov, E = znak pre nissie 4. bitov
; Meni: AF, DE
;------------------------------------------------------------------------------
0D87  7E              MOV  A,M          ; vezmi byte
0D88  E6 0F           ANI  0F           ; odmaskuj len dolne 4 bity
0D8A  CD 0D9A         CALL 0D9A         ; preved na znak
0D8D  5F              MOV  E,A          ; uloz do E
0D8E  7E              MOV  A,M          ; opat vezmi byte
0D8F  0F              RRC               ; presun horne bity do dolnych
0D90  0F              RRC
0D91  0F              RRC
0D92  0F              RRC
0D93  E6 0F           ANI  0F           ; odmaskuj
0D95  CD 0D9A         CALL 0D9A         ; preved na znak
0D98  57              MOV  D,A          ; uloz do D
0D99  C9              RET

;------------------------------------------------------------------------------
; Rutina prevedie byte s hodnotou 0 az F na znak '0' az 'F'.
; Vstup: A = byte 0 az F
; Vystup: A = znak '0' az 'F'
; Meni: AF
;------------------------------------------------------------------------------
0D9A  C6 90           ADI  90
0D9C  27              DAA
0D9D  CE 40           ACI  40
0D9F  27              DAA
0DA0  C9              RET

;------------------------------------------------------------------------------
; Rutina odosle byte na zbernicu a prepne zbernicu na vstup
;------------------------------------------------------------------------------
0DA1  CD 0CF7         CALL 0CF7         ; odosli byte
0DA4  3E 92           MVI  A,92         ; init IMS-2 - vstup
0DA6  D3 DF           OUT  DF
0DA8  3E 01           MVI  A,01
0DAA  D3 DE           OUT  DE
0DAC  C9              RET

;------------------------------------------------------------------------------
; Znizenie pocitadla odosielanych znakov pre datovy subor
;------------------------------------------------------------------------------
0DAD  0D              DCR  C            ; zniz pocitalo dlzky zaznamu
0DAE  C2 0D44         JNZ  0D44         ; opakuj pre cely zaznam
0DB1  CD 0CED         CALL 0CED         ; cakaj na NDAC=1
0DB4  3E 0D           MVI  A,0D         ; posli CR
0DB6  CD 0CF7         CALL 0CF7
0DB9  C3 0D52         JMP  0D52         ; posli LF


;------------------------------------------------------------------------------
; Rutina vrati dlzku zaznamu a typ suboru.
; Vstup: (183D) = typ suboru
;        (1822) = dlzka dat
; Vystup: A = typ suboru
;         C = dlzka zaznamu
; Meni: C, A
;------------------------------------------------------------------------------
0DBC  3A 1822         LDA  1822
0DBF  4F              MOV  C,A
0DC0  3A 183D         LDA  183D
0DC3  C9              RET


;------------------------------------------------------------------------------
; Obsluha registra DATA WRITE.
; Rutina prijme do buffra blok dat od nadradeneho pocitaca a spracuje volanim
; procedury EXECUTE.
;------------------------------------------------------------------------------
0DC4  2A 180D         LHLD 180D         ; HL = adresa IMS-2 buffra
0DC7  3A 1822         LDA  1822
0DCA  4F              MOV  C,A          ; C = dlzka dat
0DCB  3A 183D         LDA  183D         ; A = typ suboru
0DCE  FE 44           CPI  44           ; je to 'D' datovy subor
0DD0  C2 0DF0         JNZ  0DF0         ; nie, skoc dopredu

; datovy subor
; data sa prijimaju az po CRLF
0DD3  CD 0CC7         CALL 0CC7         ; prijmi byte
0DD6  77              MOV  M,A          ; uloz do pamati
0DD7  CD 0CD9         CALL 0CD9         ; potvrd prijatie bytu
0DDA  7E              MOV  A,M
0DDB  FE 0D           CPI  0D           ; je to CR
0DDD  23              INX  H            ; posun ukazatel
0DDE  C2 0DD3         JNZ  0DD3         ; nie, opakuj
0DE1  CD 0CC7         CALL 0CC7         ; prijmi LF
0DE4  CD 04B9         CALL 04B9         ; EXECUTE - spracuj prijate data
0DE7  CD 0CD9         CALL 0CD9         ; potvrd prijatie bytu
0DEA  C9              RET

;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0DEB  00 00 00 00 00  DB   00,00,00,00,00

;------------------------------------------------------------------------------
; Obsluha registra DATA WRITE - binarne data
; Binarne data su vo forme dvojic HEXA znakov, data su ukoncene CRLF
;------------------------------------------------------------------------------
0DF0  CD 0CC7         CALL 0CC7         ; prijmi byte
0DF3  FE 0D           CPI  0D           ; je to CR ?
0DF5  CA 0E14         JZ   0E14         ; ano, skoc dopredu
0DF8  57              MOV  D,A          ; prijaty znak do D
0DF9  CD 0CD9         CALL 0CD9         ; potvrd prijatie bytu
0DFC  CD 0CC7         CALL 0CC7         ; prijmi byte
0DFF  5F              MOV  E,A          ; prijaty znak do E
0E00  CD 0CD9         CALL 0CD9         ; potvrd prijatie bytu
0E03  CD 0E25         CALL 0E25         ; preved dvojicu HEXA do bytu
0E06  77              MOV  M,A          ; uloz
0E07  23              INX  H            ; posun ukazatel
0E08  0D              DCR  C            ; zniz pocitadlo - zbytocne
0E09  C3 0DF0         JMP  0DF0         ; pokracuj v cykle

;------------------------------------------------------------------------------
; hluchy kod
;------------------------------------------------------------------------------
0E0C  CD 0CC7         CALL 0CC7
0E0F  FE 0D           CPI  0D
0E11  00              NOP
0E12  00              NOP
0E13  00              NOP

;------------------------------------------------------------------------------
; Obsluha registra DATA WRITE - binarne data - pokracovanie
;------------------------------------------------------------------------------
0E14  CD 0CD9         CALL 0CD9         ; potvrd prijatie bytu
0E17  CD 0CC7         CALL 0CC7         ; prijmi byte
0E1A  FE 0A           CPI  0A           ; je to LF ? - no a co?
0E1C  CD 04B9         CALL 04B9         ; EXECUTE - spracuj prijate data
0E1F  CD 0CD9         CALL 0CD9         ; potvrd prijatie bytu
0E22  C9              RET

;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0E23  00 00           DB   00,00

;------------------------------------------------------------------------------
; Rutina prevedie dva HEXA znaky do bytu.
; Vstup: D = vyssie 4 bity, E = nizsie 4 bity
;------------------------------------------------------------------------------
0E25  7A              MOV  A,D          ; horne 4 bity
0E26  CD 08F2         CALL 08F2         ; preved znak na cislo
0E29  07              RLC               ; presun hore
0E2A  07              RLC
0E2B  07              RLC
0E2C  07              RLC
0E2D  E6 F0           ANI  F0           ; odmaskuj
0E2F  57              MOV  D,A          ; uloz do D
0E30  7B              MOV  A,E          ; dolne 4 bity
0E31  CD 08F2         CALL 08F2         ; preved znak na cislo
0E34  B2              ORA  D            ; pridaj horne styri byty
0E35  C9              RET


;------------------------------------------------------------------------------
; Obsluha COMMAND registra - pokracovanie
;------------------------------------------------------------------------------
0E36  CD 0CD9         CALL 0CD9         ; potvrd prijatie bytu
0E39  23              INX  H            ; posun ukazatel
0E3A  C3 0C8A         JMP  0C8A         ; vrat sa do slucky pre dalsi byte


;------------------------------------------------------------------------------
; Obsluha pristrojovych sprav - data. Pokracovanie.
; Vstup: B = typ registra PMD 30
; Vystup: -
; Meni: vsetky
;------------------------------------------------------------------------------
0E3D  78              MOV  A,B          ; zisti typ registra PMD 30
0E3E  E6 01           ANI  01           ; je to register STATUS alebo DATA READ
0E40  CA 0E52         JZ   0E52         ; ano, skoc
0E43  78              MOV  A,B
0E44  FE 03           CPI  03           ; je to register COMMAND ?
0E46  CC 0C87         CZ   0C87         ; ano obsluz COMMAND
0E49  78              MOV  A,B
0E4A  FE 05           CPI  05           ; je to register DATA WRITE ?
0E4C  CC 0DC4         CZ   0DC4         ; ano, obsluz zapis dat
0E4F  C3 0C0A         JMP  0C0A         ; vrat sa do slucky

0E52  78              MOV  A,B
0E53  FE 30           CPI  30           ; je to register STATUS ?
0E55  CC 0C9F         CZ   0C9F         ; obsluha STATUS register
0E58  78              MOV  A,B
0E59  FE 50           CPI  50           ; je to register DATA READ
0E5B  CC 0D2E         CZ   0D2E         ; ano, obsluz citanie dat
0E5E  C3 0C04         JMP  0C04         ; vrat sa do slucky


;------------------------------------------------------------------------------
; Rutina vrati adresu IMS-2 buffra a dlzku zaznamu.
; Vstup: (180D) = adresa IMS-2 buffra
;        (1822) = dlzka zaznamu
; Vystup: HL = adresa IMS-2 buffra
;         A = C = dlzka zaznamu
; Meni: HL, C, A
;------------------------------------------------------------------------------
0E61  2A 180D         LHLD 180D
0E64  3A 1822         LDA  1822
0E67  4F              MOV  C,A
0E68  C9              RET


;------------------------------------------------------------------------------
; Rutina precita konfiguraciu jednotky, zisti cislo zariadenia a vrati "kod"
; komunikacneho registra PMD 30, ak cislo zariadenia zodpoveda adrese zariadenia
; z IMS-2 spravy.
; Vstup: E = adresa zariadenia zo spravy IMS-2 zbernice
; Vystup: C = cislo zariadenia - 0 az 15
;         B = "kod" registra PMD 30 - povodna hodnota z B, ak to nie je pre nas
;                                     03 - STATUS
;                                     30 - COMMAND
;                                     05 - DATA READ
;                                     50 - DATA WRITE
; Meni: HL, BC, AF
;------------------------------------------------------------------------------
0E69  21 1400         LXI  H,1400       ; precitaj stav konfiguracnych DIL
0E6C  7E              MOV  A,M          ; prepinacov a zisti zvoleny rezim
0E6D  2F              CMA               ; invertuj
0E6E  E6 0F           ANI  0F           ; a ponechaj iba cislo zariadenia
0E70  4F              MOV  C,A          ; uloz do C
0E71  C6 20           ADI  20
0E73  BB              CMP  E            ; je to STATUS register ?
0E74  C2 0E79         JNZ  0E79         ; nie, skoc dalej
0E77  06 03           MVI  B,03         ; nastav kod STATUS registra
0E79  C6 20           ADI  20
0E7B  BB              CMP  E            ; je to COMMAND register ?
0E7C  C2 0E81         JNZ  0E81         ; nie, skoc dalej
0E7F  06 30           MVI  B,30         ; nastav kod COMMAND registra
0E81  79              MOV  A,C
0E82  C6 30           ADI  30
0E84  BB              CMP  E            ; je to DATA READ register ?
0E85  C2 0E8A         JNZ  0E8A         ; nie, skoc dalej
0E88  06 05           MVI  B,05         ; nastav kod DATA READ registra
0E8A  C6 20           ADI  20
0E8C  BB              CMP  E            ; je to DATA WRITE register ?
0E8D  C2 0E92         JNZ  0E92         ; nie, skoc dalej
0E90  06 50           MVI  B,50         ; nastav kod DATA WRITE registra
0E92  C9              RET               ; navrat


;------------------------------------------------------------------------------
; hluchy kod
;------------------------------------------------------------------------------
0E93  B7              ORA  A
0E94  C2 0C10         JNZ  0C10
0E97  C3 0C66         JMP  0C66


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0E9A  FF FF FF FF     DB   FF,FF,FF,FF
0E9E  FF              DB   FF


;------------------------------------------------------------------------------
; Inicializacia zbernice IMS-2 na vystup - interne nepouzita rutina.
; Pouzitelna vsak v rezime MASTER pri ovladani dalsich zariadeni, kedy je
; disketova jednotka  vo funkcii CONTROLLER.
;------------------------------------------------------------------------------
0E9F  3E 82           MVI  A,82         ; init IMS-2 - vystup
0EA1  D3 DF           OUT  DF
0EA3  3E 40           MVI  A,40
0EA5  D3 DE           OUT  DE
0EA7  C9              RET


;------------------------------------------------------------------------------
; LISTENER - vystup dat na zvolene zariadenie - interne nepouzita rutina.
; Pouzitelna vsak v rezime MASTER pri ovladani dalsich zariadeni, kedy je
; disketova jednotka  vo funkcii CONTROLLER.
; Vstup: A = adresa zariadenia (posluchaca) - 001xxxxx
;        (180D) = adresa dat ukoncenych 0D
; Vystup: Z = 1 - OK
;         Z = 0 - chyba
;------------------------------------------------------------------------------
0EA8  47              MOV  B,A          ; adresa do B
0EA9  3E 82           MVI  A,82         ; init IMS-2 - vystup
0EAB  D3 DF           OUT  DF
0EAD  3E 40           MVI  A,40         ; REN = 1
0EAF  D3 DE           OUT  DE
0EB1  21 0FA8         LXI  H,0FA8       ; tabulka adries zariadeni
0EB4  CD 0EBB         CALL 0EBB         ; posli na zbernicu stykovu spravu
0EB7  CD 0EFF         CALL 0EFF         ; odosli data
0EBA  C9              RET


;------------------------------------------------------------------------------
; Rutina posle stykovu spravu so zoznamom adries oslovovanych zariadeni.
; Ak dojde ku chybe pri inicializacii zbernice dojde k navratu o uroven vyssie
; do volaneho podprogramu so Z = 0.
; Vstup: HL = adresa stykovej spravy
;        B = IMS-2 adresa oslovovaneho zariadenia
; Vystup: Z = 1 - odoslana stykova sprava
;------------------------------------------------------------------------------
0EBB  3E 60           MVI  A,60         ; REN = 1, ATN = 1, DAV = 0
0EBD  D3 DE           OUT  DE
0EBF  CD 0F3A         CALL 0F3A         ; cakaj 1 ms
0EC2  DB DD           IN   DD
0EC4  E6 0C           ANI  0C           ; stav NDAC a NRFD
0EC6  FE 08           CPI  08           ; NDAC = 1 a NRFD = 0 ?
0EC8  C2 0EFD         JNZ  0EFD         ; nie, je to chyba, skoc dopredu
0ECB  7E              MOV  A,M          ; vezmi byte spravy
0ECC  FE 0D           CPI  0D           ; je to koniec spravy ?
0ECE  CA 0EE8         JZ   0EE8         ; ano, skoc dopredu
0ED1  D3 DC           OUT  DC           ; posli na zbernicu
0ED3  CD 0F3A         CALL 0F3A         ; cakaj 1 ms
0ED6  3E 62           MVI  A,62         ; REN = 1, ATN = 1, DAV = 1
0ED8  D3 DE           OUT  DE           ; platne data na zbernici
0EDA  CD 0F53         CALL 0F53         ; cakaj na potvrdenie
0EDD  3E 60           MVI  A,60         ; REN = 1, ATN = 1, DAV = 0
0EDF  D3 DE           OUT  DE
0EE1  CD 0F5D         CALL 0F5D         ; cakaj na uvolnenie zbernice
0EE4  23              INX  H            ; posun ukazatel
0EE5  C3 0ECB         JMP  0ECB         ; vrat sa do slucky

0EE8  78              MOV  A,B          ; posli adresu posluchaca
0EE9  D3 DC           OUT  DC
0EEB  CD 0F3A         CALL 0F3A         ; cakaj 1 ms
0EEE  3E 62           MVI  A,62         ; REN = 1, ATN = 1, DAV = 1
0EF0  D3 DE           OUT  DE           ; platne data na zbernici
0EF2  CD 0F53         CALL 0F53         ; cakaj na potvrdenie
0EF5  3E 60           MVI  A,60         ; REN = 1, ATN = 1, DAV = 0
0EF7  D3 DE           OUT  DE
0EF9  CD 0F5D         CALL 0F5D         ; cakaj na uvolnenie zbernice
0EFC  C9              RET

0EFD  D1              POP  D            ; zahod navratovu adresu
0EFE  C9              RET               ; a vrat sa do volajuceho podprogramu


;------------------------------------------------------------------------------
; Rutina odosle data na zbernicu. Data musia byt ukoncene znakom CR.
; Vstup: (180D) = adresa dat ukoncenych 0D
; Vystup: odoslane data
;------------------------------------------------------------------------------
0EFF  2A 180D         LHLD 180D         ; adresa posielanych dat
0F02  3E 40           MVI  A,40         ; REN = 1, ATN = 0, DAV = 0
0F04  D3 DE           OUT  DE
0F06  7E              MOV  A,M          ; vezmi byte
0F07  D3 DC           OUT  DC           ; posli na zbernicu
0F09  CD 0F3A         CALL 0F3A         ; cakaj 1 ms
0F0C  3E 42           MVI  A,42         ; REN = 1, ATN = 0, DAV = 1
0F0E  D3 DE           OUT  DE           ; platne data na zbernici
0F10  CD 0F53         CALL 0F53         ; cakaj na potvrdenie
0F13  3E 40           MVI  A,40         ; REN = 1, ATN = 0, DAV = 0
0F15  D3 DE           OUT  DE
0F17  CD 0F5D         CALL 0F5D         ; cakaj na uvolnenie zbernice
0F1A  7E              MOV  A,M          ; bol to koniec dat ?
0F1B  FE 0D           CPI  0D
0F1D  CA 0F24         JZ   0F24         ; ano, skoc dopredu
0F20  23              INX  H            ; posun ukazatel
0F21  C3 0F06         JMP  0F06         ; opakuj

0F24  3E 0A           MVI  A,0A         ; odosli LF
0F26  D3 DC           OUT  DC
0F28  CD 0F3A         CALL 0F3A         ; cakaj 1 ms
0F2B  3E 42           MVI  A,42         ; REN = 1, ATN = 0, DAV = 1
0F2D  D3 DE           OUT  DE           ; platne data na zbernici
0F2F  CD 0F53         CALL 0F53         ; cakaj na potvrdenie
0F32  3E 40           MVI  A,40         ; REN = 1, ATN = 0, DAV = 0
0F34  D3 DE           OUT  DE
0F36  CD 0F5D         CALL 0F5D         ; cakaj na uvolnenie zbernice
0F39  C9              RET


;------------------------------------------------------------------------------
; Cakaj 1 ms
;------------------------------------------------------------------------------
0F3A  AF              XRA  A
0F3B  3C              INR  A
0F3C  F2 0F3B         JP   0F3B
0F3F  C9              RET


;------------------------------------------------------------------------------
; TALKER - vstup dat zo zvoleneho zariadenia - interne nepouzita rutina.
; Pouzitelna vsak v rezime MASTER pri ovladani dalsich zariadeni, kedy je
; disketova jednotka  vo funkcii CONTROLLER.
; Vstup: A = adresa zariadenia (hovorcy) - 010xxxxx
;        (180D) = adresa kam sa ulozia prijate data
; Vystup: Z = 1 - OK
;         Z = 0 - chyba
;------------------------------------------------------------------------------
0F40  47              MOV  B,A
0F41  3E 82           MVI  A,82         ; init IMS-2 - vystup
0F43  D3 DF           OUT  DF
0F45  3E 41           MVI  A,41         ; REN = 1 - teoreticky malo byt 40
0F47  D3 DE           OUT  DE
0F49  21 0FAC         LXI  H,0FAC       ; tabulka adries zariadeni
0F4C  CD 0EBB         CALL 0EBB         ; posli na zbernicu stykovu spravu
0F4F  CD 0F67         CALL 0F67         ; prijmi data
0F52  C9              RET


;------------------------------------------------------------------------------
; Rutina caka na potvrdenie prijatia dat.
;------------------------------------------------------------------------------
0F53  DB DD           IN   DD
0F55  E6 0C           ANI  0C           ; stav NDAC a NRFD
0F57  FE 04           CPI  04           ; NDAC = 0 a NRFD = 1 ?
0F59  C2 0F53         JNZ  0F53         ; nie, cakaj
0F5C  C9              RET


;------------------------------------------------------------------------------
; Rutina caka na "uvolnenie" zbernice po zruseni potvrdenia dat.
;------------------------------------------------------------------------------
0F5D  DB DD           IN   DD
0F5F  E6 0C           ANI  0C           ; stav NDAC a NRFD
0F61  FE 08           CPI  08           ; NDAC = 1 a NRFD = 0 ?
0F63  C2 0F5D         JNZ  0F5D         ; nie, cakaj
0F66  C9              RET


;------------------------------------------------------------------------------
; Rutina prijme data zo zbernice. Data musia byt ukoncene znakom LF.
; Vstup: (180D) = adresa kam sa ulozia prijate data
; Vystup: prijate data
;------------------------------------------------------------------------------
0F67  3E 92           MVI  A,92         ; init IMS-2 - vstup
0F69  D3 DF           OUT  DF
0F6B  2A 180D         LHLD 180D         ; adresa buffra
0F6E  3E 49           MVI  A,49         ; REN = 1, ATN = 0, NDAC = 1, NRFD = 0
0F70  D3 DE           OUT  DE
0F72  DB DD           IN   DD           ; cakaj na DAV = 1 - platne data
0F74  E6 02           ANI  02
0F76  CA 0F72         JZ   0F72
0F79  3E 49           MVI  A,49         ; naco opat ???
0F7B  D3 DE           OUT  DE
0F7D  DB DC           IN   DC           ; prevezmi byte
0F7F  FE 0A           CPI  0A           ; je to LF - koniec spravy
0F81  CA 0F98         JZ   0F98         ; ano, skoc dopredu
0F84  77              MOV  M,A          ; uloz byte
0F85  3E 45           MVI  A,45         ; REN = 1, ATN = 0, NDAC = 0, NRFD = 1
0F87  D3 DE           OUT  DE           ; potvrdenie dat
0F89  DB DD           IN   DD           ; cakaj na DAV = 0
0F8B  E6 02           ANI  02
0F8D  C2 0F89         JNZ  0F89
0F90  3E 4D           MVI  A,4D         ; REN = 1, ATN = 0, NDAC = 1, NRFD = 1
0F92  D3 DE           OUT  DE
0F94  23              INX  H            ; posun ukazatel
0F95  C3 0F6E         JMP  0F6E         ; opakuj

0F98  3E 45           MVI  A,45         ; REN = 1, ATN = 0, NDAC = 0, NRFD = 1
0F9A  D3 DE           OUT  DE
0F9C  DB DD           IN   DD           ; cakaj na DAV = 0
0F9E  E6 02           ANI  02
0FA0  C2 0F97         JNZ  0F97
0FA3  3E 4D           MVI  A,4D         ; REN = 1, ATN = 0, NDAC = 1, NRFD = 1
0FA5  D3 DE           OUT  DE
0FA7  C9              RET

;------------------------------------------------------------------------------
; Tabulka adries zariadeni pre vysielanie
;------------------------------------------------------------------------------
0FA8  3F 5F 55 0D     DB   3F,5F,55,0D  ; Unlisten, Untalk, Talker: 15h=PMD 30

;------------------------------------------------------------------------------
; Tabulka adries zariadeni pre prijimanie
;------------------------------------------------------------------------------
0FAC  5F 3F 35 0D     DB   5F,3F,35,0D  ; Untalk, Unlisten, Listener: 15h=PMD 30


;------------------------------------------------------------------------------
; Rutina na prijem datoveho bytu zo zbernice IMS-2 - pokracovanie.
; Vstup: -
; Vystup: A = nacitany byte
;         ak doslo ku chybe, vrati sa do hlavnej slucky
;------------------------------------------------------------------------------
0FB0  DB DD           IN   DD           ; citaj riadiacu zbernicu
0FB2  E6 20           ANI  20           ; ATN=1 ?
0FB4  C2 0FC5         JNZ  0FC5         ; ano, chyba, skoc dopredu
0FB7  DB DD           IN   DD           ; citaj riadiacu zbernicu
0FB9  E6 02           ANI  02           ; DAV = 1 ?
0FBB  CA 0FB0         JZ   0FB0         ; nie, cakaj
0FBE  3E 0D           MVI  A,0D         ; NDAC = 1, NRFD = 1
0FC0  D3 DE           OUT  DE
0FC2  DB DC           IN   DC           ; precitaj byte
0FC4  C9              RET

0FC5  D1              POP  D            ; zahod navratovu adresu
0FC6  3E 01           MVI  A,01         ; NDAC = 0, NRFD = 0
0FC8  D3 DE           OUT  DE
0FCA  3E 09           MVI  A,09         ; NDAC = 1, NRFD = 0
0FCC  D3 DE           OUT  DE
0FCE  C3 0C04         JMP  0C04         ; navrat do hlavnej slucky


;------------------------------------------------------------------------------
; seno
;------------------------------------------------------------------------------
0FD1  FF FF FF FF     DB   FF,FF,FF,FF
0FD5  FF FF FF FF     DB   FF,FF,FF,FF
0FD9  FF FF FF FF     DB   FF,FF,FF,FF
0FDD  FF FF FF FF     DB   FF,FF,FF,FF
0FE1  FF FF FF FF     DB   FF,FF,FF,FF
0FE5  FF FF FF FF     DB   FF,FF,FF,FF
0FE9  FF FF FF FF     DB   FF,FF,FF,FF
0FED  FF FF FF FF     DB   FF,FF,FF,FF
0FF1  FF FF FF FF     DB   FF,FF,FF,FF
0FF5  FF FF FF FF     DB   FF,FF,FF,FF
0FF9  FF FF FF FF     DB   FF,FF,FF,FF
0FFD  FF FF FF        DB   FF,FF,FF


;------------------------------------------------------------------------------
; Systemove premenne
; Pociatocne hodnoty su kopirovane pri inicializacii z adresy 0029
;------------------------------------------------------------------------------
1800  00              DB   00           ; STATUS register (kod chyby)
1801  00 00           DW   0000         ; adresa dalsich povelov - vzdy 0
1803  8B 07           DW   078B         ; adresa zoznamu parametrov
1805  01              DB   01           ; vyssi byte adries rutin parametrov
1806  D9 00           DW   00D9         ; tabulka offsetov adries rutin params.
1808  00              DB   00           ; kod povelu
1809  00 00           DW   0000         ; adresa sluzby podprogramu DISK
180B  80 19           DW   1980         ; adresa buffra pre fyzicky sektor
180D  00 1A           DW   1A00         ; adresa buffra pre IMS-2
180F  C3              DB   C3           ; JMP
1810  3E xx           DW   073E         ; adresa skoku

1812                  DS   02           ; adresa polozky v OPEN buffri
1814                  DS   02           ; adresa pamate alebo skoku

1816                  DS   08           ; buffer pre meno suboru

1816                  DS   02           ; adresa v zazname, kde sa hlada retazec
1818                  DS   01           ; offset do hladaneho zaznamu
1819                  DS   01           ; pocet znakov do konca zaznamu

181E                  DS   02           ; vysledok nasobenia
1820                  DS   02           ; 1. cinitel, cislo/pocet zaznamov
1822                  DS   01           ; 2. cinitel, dlzka zaznamu
1823                  DS   01           ; dlzka casti zaznamu - 1 v 1. sektore
1824                  DS   01           ; offset zaznamu od zaciatku sektora

1825                  DS   01           ; pozadovana stopa
1826                  DS   01           ; pozadovany sektor
1827                  DS   01           ; pocet RJ suboru

1828                  DS   05           ; buffer na prevod cisla

1828                  DS   ?            ; buffer pre FDC povel
182D                  DS   01           ; stopa v FDC povele
182E                  DS   01           ; sektor v FDC povele

1838                  DS   01           ; typ hladaneho suboru
1839                  DS   02           ; aktualna stopa a sektor
183B                  DS   02           ; poradove cislo log. sektora v subore
183D                  DS   01           ; typ suboru
183E                  DS   01           ; cislo polozky adresara + 8
183F                  DS   05           ; buffer pre ASCII hodnotu STATUS reg.

186F                                    ; zasobnik 8080 k nizsim adresam

1870                  DS   50           ; COMMAND register (80 bytov)
18C0                  DS   20           ; nevyuzite, resp. moze tu pokr. COMMAND
18E0                  DS   A0           ; OPEN register (160 bytov)
1980                  DS   80           ; buffer pre fyzicky sektor (128 bytov)
1A00                  DS   100          ; v/v buffer pre logicky sektor a IMS-2
1B00                  DS   100 (500)    ; uzivatelska oblast (256/1280 bytov)

1C00 (2000)
